/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

/**
 * Autogenerated by Thrift Compiler (0.9.3)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package beehive.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (0.9.3)", date = "2018-06-22")
public class Node_thrift implements org.apache.thrift.TBase<Node_thrift, Node_thrift._Fields>, java.io.Serializable, Cloneable, Comparable<Node_thrift> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("Node_thrift");

  private static final org.apache.thrift.protocol.TField NODE_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("nodeId", org.apache.thrift.protocol.TType.STRING, (short)1);
  private static final org.apache.thrift.protocol.TField TS_FIELD_DESC = new org.apache.thrift.protocol.TField("TS", org.apache.thrift.protocol.TType.I64, (short)2);
  private static final org.apache.thrift.protocol.TField NEIGHBORS_FIELD_DESC = new org.apache.thrift.protocol.TField("neighbors", org.apache.thrift.protocol.TType.MAP, (short)3);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new Node_thriftStandardSchemeFactory());
    schemes.put(TupleScheme.class, new Node_thriftTupleSchemeFactory());
  }

  public String nodeId; // required
  public long TS; // required
  public Map<String,Edge_thrift> neighbors; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    NODE_ID((short)1, "nodeId"),
    TS((short)2, "TS"),
    NEIGHBORS((short)3, "neighbors");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // NODE_ID
          return NODE_ID;
        case 2: // TS
          return TS;
        case 3: // NEIGHBORS
          return NEIGHBORS;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __TS_ISSET_ID = 0;
  private byte __isset_bitfield = 0;
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.NODE_ID, new org.apache.thrift.meta_data.FieldMetaData("nodeId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.TS, new org.apache.thrift.meta_data.FieldMetaData("TS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64        , "long")));
    tmpMap.put(_Fields.NEIGHBORS, new org.apache.thrift.meta_data.FieldMetaData("neighbors", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.MapMetaData(org.apache.thrift.protocol.TType.MAP, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING), 
            new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, Edge_thrift.class))));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(Node_thrift.class, metaDataMap);
  }

  public Node_thrift() {
  }

  public Node_thrift(
    String nodeId,
    long TS,
    Map<String,Edge_thrift> neighbors)
  {
    this();
    this.nodeId = nodeId;
    this.TS = TS;
    setTSIsSet(true);
    this.neighbors = neighbors;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Node_thrift(Node_thrift other) {
    __isset_bitfield = other.__isset_bitfield;
    if (other.isSetNodeId()) {
      this.nodeId = other.nodeId;
    }
    this.TS = other.TS;
    if (other.isSetNeighbors()) {
      Map<String,Edge_thrift> __this__neighbors = new HashMap<String,Edge_thrift>(other.neighbors.size());
      for (Map.Entry<String, Edge_thrift> other_element : other.neighbors.entrySet()) {

        String other_element_key = other_element.getKey();
        Edge_thrift other_element_value = other_element.getValue();

        String __this__neighbors_copy_key = other_element_key;

        Edge_thrift __this__neighbors_copy_value = new Edge_thrift(other_element_value);

        __this__neighbors.put(__this__neighbors_copy_key, __this__neighbors_copy_value);
      }
      this.neighbors = __this__neighbors;
    }
  }

  public Node_thrift deepCopy() {
    return new Node_thrift(this);
  }

  @Override
  public void clear() {
    this.nodeId = null;
    setTSIsSet(false);
    this.TS = 0;
    this.neighbors = null;
  }

  public String getNodeId() {
    return this.nodeId;
  }

  public Node_thrift setNodeId(String nodeId) {
    this.nodeId = nodeId;
    return this;
  }

  public void unsetNodeId() {
    this.nodeId = null;
  }

  /** Returns true if field nodeId is set (has been assigned a value) and false otherwise */
  public boolean isSetNodeId() {
    return this.nodeId != null;
  }

  public void setNodeIdIsSet(boolean value) {
    if (!value) {
      this.nodeId = null;
    }
  }

  public long getTS() {
    return this.TS;
  }

  public Node_thrift setTS(long TS) {
    this.TS = TS;
    setTSIsSet(true);
    return this;
  }

  public void unsetTS() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __TS_ISSET_ID);
  }

  /** Returns true if field TS is set (has been assigned a value) and false otherwise */
  public boolean isSetTS() {
    return EncodingUtils.testBit(__isset_bitfield, __TS_ISSET_ID);
  }

  public void setTSIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __TS_ISSET_ID, value);
  }

  public int getNeighborsSize() {
    return (this.neighbors == null) ? 0 : this.neighbors.size();
  }

  public void putToNeighbors(String key, Edge_thrift val) {
    if (this.neighbors == null) {
      this.neighbors = new HashMap<String,Edge_thrift>();
    }
    this.neighbors.put(key, val);
  }

  public Map<String,Edge_thrift> getNeighbors() {
    return this.neighbors;
  }

  public Node_thrift setNeighbors(Map<String,Edge_thrift> neighbors) {
    this.neighbors = neighbors;
    return this;
  }

  public void unsetNeighbors() {
    this.neighbors = null;
  }

  /** Returns true if field neighbors is set (has been assigned a value) and false otherwise */
  public boolean isSetNeighbors() {
    return this.neighbors != null;
  }

  public void setNeighborsIsSet(boolean value) {
    if (!value) {
      this.neighbors = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case NODE_ID:
      if (value == null) {
        unsetNodeId();
      } else {
        setNodeId((String)value);
      }
      break;

    case TS:
      if (value == null) {
        unsetTS();
      } else {
        setTS((Long)value);
      }
      break;

    case NEIGHBORS:
      if (value == null) {
        unsetNeighbors();
      } else {
        setNeighbors((Map<String,Edge_thrift>)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case NODE_ID:
      return getNodeId();

    case TS:
      return getTS();

    case NEIGHBORS:
      return getNeighbors();

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case NODE_ID:
      return isSetNodeId();
    case TS:
      return isSetTS();
    case NEIGHBORS:
      return isSetNeighbors();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof Node_thrift)
      return this.equals((Node_thrift)that);
    return false;
  }

  public boolean equals(Node_thrift that) {
    if (that == null)
      return false;

    boolean this_present_nodeId = true && this.isSetNodeId();
    boolean that_present_nodeId = true && that.isSetNodeId();
    if (this_present_nodeId || that_present_nodeId) {
      if (!(this_present_nodeId && that_present_nodeId))
        return false;
      if (!this.nodeId.equals(that.nodeId))
        return false;
    }

    boolean this_present_TS = true;
    boolean that_present_TS = true;
    if (this_present_TS || that_present_TS) {
      if (!(this_present_TS && that_present_TS))
        return false;
      if (this.TS != that.TS)
        return false;
    }

    boolean this_present_neighbors = true && this.isSetNeighbors();
    boolean that_present_neighbors = true && that.isSetNeighbors();
    if (this_present_neighbors || that_present_neighbors) {
      if (!(this_present_neighbors && that_present_neighbors))
        return false;
      if (!this.neighbors.equals(that.neighbors))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_nodeId = true && (isSetNodeId());
    list.add(present_nodeId);
    if (present_nodeId)
      list.add(nodeId);

    boolean present_TS = true;
    list.add(present_TS);
    if (present_TS)
      list.add(TS);

    boolean present_neighbors = true && (isSetNeighbors());
    list.add(present_neighbors);
    if (present_neighbors)
      list.add(neighbors);

    return list.hashCode();
  }

  @Override
  public int compareTo(Node_thrift other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetNodeId()).compareTo(other.isSetNodeId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetNodeId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.nodeId, other.nodeId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetTS()).compareTo(other.isSetTS());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTS()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.TS, other.TS);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetNeighbors()).compareTo(other.isSetNeighbors());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetNeighbors()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.neighbors, other.neighbors);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("Node_thrift(");
    boolean first = true;

    sb.append("nodeId:");
    if (this.nodeId == null) {
      sb.append("null");
    } else {
      sb.append(this.nodeId);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("TS:");
    sb.append(this.TS);
    first = false;
    if (!first) sb.append(", ");
    sb.append("neighbors:");
    if (this.neighbors == null) {
      sb.append("null");
    } else {
      sb.append(this.neighbors);
    }
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class Node_thriftStandardSchemeFactory implements SchemeFactory {
    public Node_thriftStandardScheme getScheme() {
      return new Node_thriftStandardScheme();
    }
  }

  private static class Node_thriftStandardScheme extends StandardScheme<Node_thrift> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, Node_thrift struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // NODE_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.nodeId = iprot.readString();
              struct.setNodeIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // TS
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.TS = iprot.readI64();
              struct.setTSIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // NEIGHBORS
            if (schemeField.type == org.apache.thrift.protocol.TType.MAP) {
              {
                org.apache.thrift.protocol.TMap _map0 = iprot.readMapBegin();
                struct.neighbors = new HashMap<String,Edge_thrift>(2*_map0.size);
                String _key1;
                Edge_thrift _val2;
                for (int _i3 = 0; _i3 < _map0.size; ++_i3)
                {
                  _key1 = iprot.readString();
                  _val2 = new Edge_thrift();
                  _val2.read(iprot);
                  struct.neighbors.put(_key1, _val2);
                }
                iprot.readMapEnd();
              }
              struct.setNeighborsIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, Node_thrift struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.nodeId != null) {
        oprot.writeFieldBegin(NODE_ID_FIELD_DESC);
        oprot.writeString(struct.nodeId);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(TS_FIELD_DESC);
      oprot.writeI64(struct.TS);
      oprot.writeFieldEnd();
      if (struct.neighbors != null) {
        oprot.writeFieldBegin(NEIGHBORS_FIELD_DESC);
        {
          oprot.writeMapBegin(new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.STRUCT, struct.neighbors.size()));
          for (Map.Entry<String, Edge_thrift> _iter4 : struct.neighbors.entrySet())
          {
            oprot.writeString(_iter4.getKey());
            _iter4.getValue().write(oprot);
          }
          oprot.writeMapEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class Node_thriftTupleSchemeFactory implements SchemeFactory {
    public Node_thriftTupleScheme getScheme() {
      return new Node_thriftTupleScheme();
    }
  }

  private static class Node_thriftTupleScheme extends TupleScheme<Node_thrift> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, Node_thrift struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      BitSet optionals = new BitSet();
      if (struct.isSetNodeId()) {
        optionals.set(0);
      }
      if (struct.isSetTS()) {
        optionals.set(1);
      }
      if (struct.isSetNeighbors()) {
        optionals.set(2);
      }
      oprot.writeBitSet(optionals, 3);
      if (struct.isSetNodeId()) {
        oprot.writeString(struct.nodeId);
      }
      if (struct.isSetTS()) {
        oprot.writeI64(struct.TS);
      }
      if (struct.isSetNeighbors()) {
        {
          oprot.writeI32(struct.neighbors.size());
          for (Map.Entry<String, Edge_thrift> _iter5 : struct.neighbors.entrySet())
          {
            oprot.writeString(_iter5.getKey());
            _iter5.getValue().write(oprot);
          }
        }
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, Node_thrift struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      BitSet incoming = iprot.readBitSet(3);
      if (incoming.get(0)) {
        struct.nodeId = iprot.readString();
        struct.setNodeIdIsSet(true);
      }
      if (incoming.get(1)) {
        struct.TS = iprot.readI64();
        struct.setTSIsSet(true);
      }
      if (incoming.get(2)) {
        {
          org.apache.thrift.protocol.TMap _map6 = new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
          struct.neighbors = new HashMap<String,Edge_thrift>(2*_map6.size);
          String _key7;
          Edge_thrift _val8;
          for (int _i9 = 0; _i9 < _map6.size; ++_i9)
          {
            _key7 = iprot.readString();
            _val8 = new Edge_thrift();
            _val8.read(iprot);
            struct.neighbors.put(_key7, _val8);
          }
        }
        struct.setNeighborsIsSet(true);
      }
    }
  }

}

