/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

/**
 * Autogenerated by Thrift Compiler (0.9.3)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package beehive.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (0.9.3)", date = "2017-12-22")
public class ValidationService_thrift {

  public interface Iface {

    public long getSTS_thrift() throws org.apache.thrift.TException;

    public long reportCompletion_thrift(long commitTS) throws org.apache.thrift.TException;

    public long reportCompletionBatch_thrift(List<Long> commitTS) throws org.apache.thrift.TException;

    public ValidateResponse_thrift validate_thrift(long startTS, RWSetInfo_thrift rwSet) throws org.apache.thrift.TException;

    public Map<String,ValidateResponse_thrift> batchValidate_thrift(List<ValidationRequest_thrift> requests) throws org.apache.thrift.TException;

  }

  public interface AsyncIface {

    public void getSTS_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void reportCompletion_thrift(long commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void reportCompletionBatch_thrift(List<Long> commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void validate_thrift(long startTS, RWSetInfo_thrift rwSet, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void batchValidate_thrift(List<ValidationRequest_thrift> requests, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

  }

  public static class Client extends org.apache.thrift.TServiceClient implements Iface {
    public static class Factory implements org.apache.thrift.TServiceClientFactory<Client> {
      public Factory() {}
      public Client getClient(org.apache.thrift.protocol.TProtocol prot) {
        return new Client(prot);
      }
      public Client getClient(org.apache.thrift.protocol.TProtocol iprot, org.apache.thrift.protocol.TProtocol oprot) {
        return new Client(iprot, oprot);
      }
    }

    public Client(org.apache.thrift.protocol.TProtocol prot)
    {
      super(prot, prot);
    }

    public Client(org.apache.thrift.protocol.TProtocol iprot, org.apache.thrift.protocol.TProtocol oprot) {
      super(iprot, oprot);
    }

    public long getSTS_thrift() throws org.apache.thrift.TException
    {
      send_getSTS_thrift();
      return recv_getSTS_thrift();
    }

    public void send_getSTS_thrift() throws org.apache.thrift.TException
    {
      getSTS_thrift_args args = new getSTS_thrift_args();
      sendBase("getSTS_thrift", args);
    }

    public long recv_getSTS_thrift() throws org.apache.thrift.TException
    {
      getSTS_thrift_result result = new getSTS_thrift_result();
      receiveBase(result, "getSTS_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "getSTS_thrift failed: unknown result");
    }

    public long reportCompletion_thrift(long commitTS) throws org.apache.thrift.TException
    {
      send_reportCompletion_thrift(commitTS);
      return recv_reportCompletion_thrift();
    }

    public void send_reportCompletion_thrift(long commitTS) throws org.apache.thrift.TException
    {
      reportCompletion_thrift_args args = new reportCompletion_thrift_args();
      args.setCommitTS(commitTS);
      sendBase("reportCompletion_thrift", args);
    }

    public long recv_reportCompletion_thrift() throws org.apache.thrift.TException
    {
      reportCompletion_thrift_result result = new reportCompletion_thrift_result();
      receiveBase(result, "reportCompletion_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "reportCompletion_thrift failed: unknown result");
    }

    public long reportCompletionBatch_thrift(List<Long> commitTS) throws org.apache.thrift.TException
    {
      send_reportCompletionBatch_thrift(commitTS);
      return recv_reportCompletionBatch_thrift();
    }

    public void send_reportCompletionBatch_thrift(List<Long> commitTS) throws org.apache.thrift.TException
    {
      reportCompletionBatch_thrift_args args = new reportCompletionBatch_thrift_args();
      args.setCommitTS(commitTS);
      sendBase("reportCompletionBatch_thrift", args);
    }

    public long recv_reportCompletionBatch_thrift() throws org.apache.thrift.TException
    {
      reportCompletionBatch_thrift_result result = new reportCompletionBatch_thrift_result();
      receiveBase(result, "reportCompletionBatch_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "reportCompletionBatch_thrift failed: unknown result");
    }

    public ValidateResponse_thrift validate_thrift(long startTS, RWSetInfo_thrift rwSet) throws org.apache.thrift.TException
    {
      send_validate_thrift(startTS, rwSet);
      return recv_validate_thrift();
    }

    public void send_validate_thrift(long startTS, RWSetInfo_thrift rwSet) throws org.apache.thrift.TException
    {
      validate_thrift_args args = new validate_thrift_args();
      args.setStartTS(startTS);
      args.setRwSet(rwSet);
      sendBase("validate_thrift", args);
    }

    public ValidateResponse_thrift recv_validate_thrift() throws org.apache.thrift.TException
    {
      validate_thrift_result result = new validate_thrift_result();
      receiveBase(result, "validate_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "validate_thrift failed: unknown result");
    }

    public Map<String,ValidateResponse_thrift> batchValidate_thrift(List<ValidationRequest_thrift> requests) throws org.apache.thrift.TException
    {
      send_batchValidate_thrift(requests);
      return recv_batchValidate_thrift();
    }

    public void send_batchValidate_thrift(List<ValidationRequest_thrift> requests) throws org.apache.thrift.TException
    {
      batchValidate_thrift_args args = new batchValidate_thrift_args();
      args.setRequests(requests);
      sendBase("batchValidate_thrift", args);
    }

    public Map<String,ValidateResponse_thrift> recv_batchValidate_thrift() throws org.apache.thrift.TException
    {
      batchValidate_thrift_result result = new batchValidate_thrift_result();
      receiveBase(result, "batchValidate_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "batchValidate_thrift failed: unknown result");
    }

  }
  public static class AsyncClient extends org.apache.thrift.async.TAsyncClient implements AsyncIface {
    public static class Factory implements org.apache.thrift.async.TAsyncClientFactory<AsyncClient> {
      private org.apache.thrift.async.TAsyncClientManager clientManager;
      private org.apache.thrift.protocol.TProtocolFactory protocolFactory;
      public Factory(org.apache.thrift.async.TAsyncClientManager clientManager, org.apache.thrift.protocol.TProtocolFactory protocolFactory) {
        this.clientManager = clientManager;
        this.protocolFactory = protocolFactory;
      }
      public AsyncClient getAsyncClient(org.apache.thrift.transport.TNonblockingTransport transport) {
        return new AsyncClient(protocolFactory, clientManager, transport);
      }
    }

    public AsyncClient(org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.async.TAsyncClientManager clientManager, org.apache.thrift.transport.TNonblockingTransport transport) {
      super(protocolFactory, clientManager, transport);
    }

    public void getSTS_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      getSTS_thrift_call method_call = new getSTS_thrift_call(resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class getSTS_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      public getSTS_thrift_call(org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("getSTS_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        getSTS_thrift_args args = new getSTS_thrift_args();
        args.write(prot);
        prot.writeMessageEnd();
      }

      public long getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getSTS_thrift();
      }
    }

    public void reportCompletion_thrift(long commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      reportCompletion_thrift_call method_call = new reportCompletion_thrift_call(commitTS, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class reportCompletion_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private long commitTS;
      public reportCompletion_thrift_call(long commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.commitTS = commitTS;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("reportCompletion_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        reportCompletion_thrift_args args = new reportCompletion_thrift_args();
        args.setCommitTS(commitTS);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public long getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_reportCompletion_thrift();
      }
    }

    public void reportCompletionBatch_thrift(List<Long> commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      reportCompletionBatch_thrift_call method_call = new reportCompletionBatch_thrift_call(commitTS, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class reportCompletionBatch_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private List<Long> commitTS;
      public reportCompletionBatch_thrift_call(List<Long> commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.commitTS = commitTS;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("reportCompletionBatch_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        reportCompletionBatch_thrift_args args = new reportCompletionBatch_thrift_args();
        args.setCommitTS(commitTS);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public long getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_reportCompletionBatch_thrift();
      }
    }

    public void validate_thrift(long startTS, RWSetInfo_thrift rwSet, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      validate_thrift_call method_call = new validate_thrift_call(startTS, rwSet, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class validate_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private long startTS;
      private RWSetInfo_thrift rwSet;
      public validate_thrift_call(long startTS, RWSetInfo_thrift rwSet, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.startTS = startTS;
        this.rwSet = rwSet;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("validate_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        validate_thrift_args args = new validate_thrift_args();
        args.setStartTS(startTS);
        args.setRwSet(rwSet);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public ValidateResponse_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_validate_thrift();
      }
    }

    public void batchValidate_thrift(List<ValidationRequest_thrift> requests, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      batchValidate_thrift_call method_call = new batchValidate_thrift_call(requests, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class batchValidate_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private List<ValidationRequest_thrift> requests;
      public batchValidate_thrift_call(List<ValidationRequest_thrift> requests, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.requests = requests;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("batchValidate_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        batchValidate_thrift_args args = new batchValidate_thrift_args();
        args.setRequests(requests);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public Map<String,ValidateResponse_thrift> getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_batchValidate_thrift();
      }
    }

  }

  public static class Processor<I extends Iface> extends org.apache.thrift.TBaseProcessor<I> implements org.apache.thrift.TProcessor {
    private static final Logger LOGGER = LoggerFactory.getLogger(Processor.class.getName());
    public Processor(I iface) {
      super(iface, getProcessMap(new HashMap<String, org.apache.thrift.ProcessFunction<I, ? extends org.apache.thrift.TBase>>()));
    }

    protected Processor(I iface, Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> processMap) {
      super(iface, getProcessMap(processMap));
    }

    private static <I extends Iface> Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> getProcessMap(Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> processMap) {
      processMap.put("getSTS_thrift", new getSTS_thrift());
      processMap.put("reportCompletion_thrift", new reportCompletion_thrift());
      processMap.put("reportCompletionBatch_thrift", new reportCompletionBatch_thrift());
      processMap.put("validate_thrift", new validate_thrift());
      processMap.put("batchValidate_thrift", new batchValidate_thrift());
      return processMap;
    }

    public static class getSTS_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, getSTS_thrift_args> {
      public getSTS_thrift() {
        super("getSTS_thrift");
      }

      public getSTS_thrift_args getEmptyArgsInstance() {
        return new getSTS_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public getSTS_thrift_result getResult(I iface, getSTS_thrift_args args) throws org.apache.thrift.TException {
        getSTS_thrift_result result = new getSTS_thrift_result();
        result.success = iface.getSTS_thrift();
        result.setSuccessIsSet(true);
        return result;
      }
    }

    public static class reportCompletion_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, reportCompletion_thrift_args> {
      public reportCompletion_thrift() {
        super("reportCompletion_thrift");
      }

      public reportCompletion_thrift_args getEmptyArgsInstance() {
        return new reportCompletion_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public reportCompletion_thrift_result getResult(I iface, reportCompletion_thrift_args args) throws org.apache.thrift.TException {
        reportCompletion_thrift_result result = new reportCompletion_thrift_result();
        result.success = iface.reportCompletion_thrift(args.commitTS);
        result.setSuccessIsSet(true);
        return result;
      }
    }

    public static class reportCompletionBatch_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, reportCompletionBatch_thrift_args> {
      public reportCompletionBatch_thrift() {
        super("reportCompletionBatch_thrift");
      }

      public reportCompletionBatch_thrift_args getEmptyArgsInstance() {
        return new reportCompletionBatch_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public reportCompletionBatch_thrift_result getResult(I iface, reportCompletionBatch_thrift_args args) throws org.apache.thrift.TException {
        reportCompletionBatch_thrift_result result = new reportCompletionBatch_thrift_result();
        result.success = iface.reportCompletionBatch_thrift(args.commitTS);
        result.setSuccessIsSet(true);
        return result;
      }
    }

    public static class validate_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, validate_thrift_args> {
      public validate_thrift() {
        super("validate_thrift");
      }

      public validate_thrift_args getEmptyArgsInstance() {
        return new validate_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public validate_thrift_result getResult(I iface, validate_thrift_args args) throws org.apache.thrift.TException {
        validate_thrift_result result = new validate_thrift_result();
        result.success = iface.validate_thrift(args.startTS, args.rwSet);
        return result;
      }
    }

    public static class batchValidate_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, batchValidate_thrift_args> {
      public batchValidate_thrift() {
        super("batchValidate_thrift");
      }

      public batchValidate_thrift_args getEmptyArgsInstance() {
        return new batchValidate_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public batchValidate_thrift_result getResult(I iface, batchValidate_thrift_args args) throws org.apache.thrift.TException {
        batchValidate_thrift_result result = new batchValidate_thrift_result();
        result.success = iface.batchValidate_thrift(args.requests);
        return result;
      }
    }

  }

  public static class AsyncProcessor<I extends AsyncIface> extends org.apache.thrift.TBaseAsyncProcessor<I> {
    private static final Logger LOGGER = LoggerFactory.getLogger(AsyncProcessor.class.getName());
    public AsyncProcessor(I iface) {
      super(iface, getProcessMap(new HashMap<String, org.apache.thrift.AsyncProcessFunction<I, ? extends org.apache.thrift.TBase, ?>>()));
    }

    protected AsyncProcessor(I iface, Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase, ?>> processMap) {
      super(iface, getProcessMap(processMap));
    }

    private static <I extends AsyncIface> Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase,?>> getProcessMap(Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase, ?>> processMap) {
      processMap.put("getSTS_thrift", new getSTS_thrift());
      processMap.put("reportCompletion_thrift", new reportCompletion_thrift());
      processMap.put("reportCompletionBatch_thrift", new reportCompletionBatch_thrift());
      processMap.put("validate_thrift", new validate_thrift());
      processMap.put("batchValidate_thrift", new batchValidate_thrift());
      return processMap;
    }

    public static class getSTS_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, getSTS_thrift_args, Long> {
      public getSTS_thrift() {
        super("getSTS_thrift");
      }

      public getSTS_thrift_args getEmptyArgsInstance() {
        return new getSTS_thrift_args();
      }

      public AsyncMethodCallback<Long> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Long>() { 
          public void onComplete(Long o) {
            getSTS_thrift_result result = new getSTS_thrift_result();
            result.success = o;
            result.setSuccessIsSet(true);
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            getSTS_thrift_result result = new getSTS_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, getSTS_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Long> resultHandler) throws TException {
        iface.getSTS_thrift(resultHandler);
      }
    }

    public static class reportCompletion_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, reportCompletion_thrift_args, Long> {
      public reportCompletion_thrift() {
        super("reportCompletion_thrift");
      }

      public reportCompletion_thrift_args getEmptyArgsInstance() {
        return new reportCompletion_thrift_args();
      }

      public AsyncMethodCallback<Long> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Long>() { 
          public void onComplete(Long o) {
            reportCompletion_thrift_result result = new reportCompletion_thrift_result();
            result.success = o;
            result.setSuccessIsSet(true);
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            reportCompletion_thrift_result result = new reportCompletion_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, reportCompletion_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Long> resultHandler) throws TException {
        iface.reportCompletion_thrift(args.commitTS,resultHandler);
      }
    }

    public static class reportCompletionBatch_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, reportCompletionBatch_thrift_args, Long> {
      public reportCompletionBatch_thrift() {
        super("reportCompletionBatch_thrift");
      }

      public reportCompletionBatch_thrift_args getEmptyArgsInstance() {
        return new reportCompletionBatch_thrift_args();
      }

      public AsyncMethodCallback<Long> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Long>() { 
          public void onComplete(Long o) {
            reportCompletionBatch_thrift_result result = new reportCompletionBatch_thrift_result();
            result.success = o;
            result.setSuccessIsSet(true);
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            reportCompletionBatch_thrift_result result = new reportCompletionBatch_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, reportCompletionBatch_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Long> resultHandler) throws TException {
        iface.reportCompletionBatch_thrift(args.commitTS,resultHandler);
      }
    }

    public static class validate_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, validate_thrift_args, ValidateResponse_thrift> {
      public validate_thrift() {
        super("validate_thrift");
      }

      public validate_thrift_args getEmptyArgsInstance() {
        return new validate_thrift_args();
      }

      public AsyncMethodCallback<ValidateResponse_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<ValidateResponse_thrift>() { 
          public void onComplete(ValidateResponse_thrift o) {
            validate_thrift_result result = new validate_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            validate_thrift_result result = new validate_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, validate_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<ValidateResponse_thrift> resultHandler) throws TException {
        iface.validate_thrift(args.startTS, args.rwSet,resultHandler);
      }
    }

    public static class batchValidate_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, batchValidate_thrift_args, Map<String,ValidateResponse_thrift>> {
      public batchValidate_thrift() {
        super("batchValidate_thrift");
      }

      public batchValidate_thrift_args getEmptyArgsInstance() {
        return new batchValidate_thrift_args();
      }

      public AsyncMethodCallback<Map<String,ValidateResponse_thrift>> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Map<String,ValidateResponse_thrift>>() { 
          public void onComplete(Map<String,ValidateResponse_thrift> o) {
            batchValidate_thrift_result result = new batchValidate_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            batchValidate_thrift_result result = new batchValidate_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, batchValidate_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Map<String,ValidateResponse_thrift>> resultHandler) throws TException {
        iface.batchValidate_thrift(args.requests,resultHandler);
      }
    }

  }

  public static class getSTS_thrift_args implements org.apache.thrift.TBase<getSTS_thrift_args, getSTS_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<getSTS_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getSTS_thrift_args");


    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getSTS_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getSTS_thrift_argsTupleSchemeFactory());
    }


    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getSTS_thrift_args.class, metaDataMap);
    }

    public getSTS_thrift_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getSTS_thrift_args(getSTS_thrift_args other) {
    }

    public getSTS_thrift_args deepCopy() {
      return new getSTS_thrift_args(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getSTS_thrift_args)
        return this.equals((getSTS_thrift_args)that);
      return false;
    }

    public boolean equals(getSTS_thrift_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      return list.hashCode();
    }

    @Override
    public int compareTo(getSTS_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getSTS_thrift_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getSTS_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public getSTS_thrift_argsStandardScheme getScheme() {
        return new getSTS_thrift_argsStandardScheme();
      }
    }

    private static class getSTS_thrift_argsStandardScheme extends StandardScheme<getSTS_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getSTS_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getSTS_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getSTS_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public getSTS_thrift_argsTupleScheme getScheme() {
        return new getSTS_thrift_argsTupleScheme();
      }
    }

    private static class getSTS_thrift_argsTupleScheme extends TupleScheme<getSTS_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getSTS_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getSTS_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
      }
    }

  }

  public static class getSTS_thrift_result implements org.apache.thrift.TBase<getSTS_thrift_result, getSTS_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<getSTS_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getSTS_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.I64, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getSTS_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getSTS_thrift_resultTupleSchemeFactory());
    }

    public long success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getSTS_thrift_result.class, metaDataMap);
    }

    public getSTS_thrift_result() {
    }

    public getSTS_thrift_result(
      long success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getSTS_thrift_result(getSTS_thrift_result other) {
      __isset_bitfield = other.__isset_bitfield;
      this.success = other.success;
    }

    public getSTS_thrift_result deepCopy() {
      return new getSTS_thrift_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = 0;
    }

    public long getSuccess() {
      return this.success;
    }

    public getSTS_thrift_result setSuccess(long success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return EncodingUtils.testBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getSTS_thrift_result)
        return this.equals((getSTS_thrift_result)that);
      return false;
    }

    public boolean equals(getSTS_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true;
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(getSTS_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getSTS_thrift_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getSTS_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public getSTS_thrift_resultStandardScheme getScheme() {
        return new getSTS_thrift_resultStandardScheme();
      }
    }

    private static class getSTS_thrift_resultStandardScheme extends StandardScheme<getSTS_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getSTS_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.success = iprot.readI64();
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getSTS_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.isSetSuccess()) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          oprot.writeI64(struct.success);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getSTS_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public getSTS_thrift_resultTupleScheme getScheme() {
        return new getSTS_thrift_resultTupleScheme();
      }
    }

    private static class getSTS_thrift_resultTupleScheme extends TupleScheme<getSTS_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getSTS_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          oprot.writeI64(struct.success);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getSTS_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = iprot.readI64();
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class reportCompletion_thrift_args implements org.apache.thrift.TBase<reportCompletion_thrift_args, reportCompletion_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletion_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletion_thrift_args");

    private static final org.apache.thrift.protocol.TField COMMIT_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("commitTS", org.apache.thrift.protocol.TType.I64, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletion_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletion_thrift_argsTupleSchemeFactory());
    }

    public long commitTS; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      COMMIT_TS((short)1, "commitTS");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // COMMIT_TS
            return COMMIT_TS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __COMMITTS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.COMMIT_TS, new org.apache.thrift.meta_data.FieldMetaData("commitTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletion_thrift_args.class, metaDataMap);
    }

    public reportCompletion_thrift_args() {
    }

    public reportCompletion_thrift_args(
      long commitTS)
    {
      this();
      this.commitTS = commitTS;
      setCommitTSIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletion_thrift_args(reportCompletion_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.commitTS = other.commitTS;
    }

    public reportCompletion_thrift_args deepCopy() {
      return new reportCompletion_thrift_args(this);
    }

    @Override
    public void clear() {
      setCommitTSIsSet(false);
      this.commitTS = 0;
    }

    public long getCommitTS() {
      return this.commitTS;
    }

    public reportCompletion_thrift_args setCommitTS(long commitTS) {
      this.commitTS = commitTS;
      setCommitTSIsSet(true);
      return this;
    }

    public void unsetCommitTS() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __COMMITTS_ISSET_ID);
    }

    /** Returns true if field commitTS is set (has been assigned a value) and false otherwise */
    public boolean isSetCommitTS() {
      return EncodingUtils.testBit(__isset_bitfield, __COMMITTS_ISSET_ID);
    }

    public void setCommitTSIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __COMMITTS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case COMMIT_TS:
        if (value == null) {
          unsetCommitTS();
        } else {
          setCommitTS((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case COMMIT_TS:
        return getCommitTS();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case COMMIT_TS:
        return isSetCommitTS();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletion_thrift_args)
        return this.equals((reportCompletion_thrift_args)that);
      return false;
    }

    public boolean equals(reportCompletion_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_commitTS = true;
      boolean that_present_commitTS = true;
      if (this_present_commitTS || that_present_commitTS) {
        if (!(this_present_commitTS && that_present_commitTS))
          return false;
        if (this.commitTS != that.commitTS)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_commitTS = true;
      list.add(present_commitTS);
      if (present_commitTS)
        list.add(commitTS);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletion_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetCommitTS()).compareTo(other.isSetCommitTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetCommitTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.commitTS, other.commitTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletion_thrift_args(");
      boolean first = true;

      sb.append("commitTS:");
      sb.append(this.commitTS);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletion_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public reportCompletion_thrift_argsStandardScheme getScheme() {
        return new reportCompletion_thrift_argsStandardScheme();
      }
    }

    private static class reportCompletion_thrift_argsStandardScheme extends StandardScheme<reportCompletion_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletion_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // COMMIT_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.commitTS = iprot.readI64();
                struct.setCommitTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletion_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(COMMIT_TS_FIELD_DESC);
        oprot.writeI64(struct.commitTS);
        oprot.writeFieldEnd();
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletion_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public reportCompletion_thrift_argsTupleScheme getScheme() {
        return new reportCompletion_thrift_argsTupleScheme();
      }
    }

    private static class reportCompletion_thrift_argsTupleScheme extends TupleScheme<reportCompletion_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletion_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetCommitTS()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetCommitTS()) {
          oprot.writeI64(struct.commitTS);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletion_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.commitTS = iprot.readI64();
          struct.setCommitTSIsSet(true);
        }
      }
    }

  }

  public static class reportCompletion_thrift_result implements org.apache.thrift.TBase<reportCompletion_thrift_result, reportCompletion_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletion_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletion_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.I64, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletion_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletion_thrift_resultTupleSchemeFactory());
    }

    public long success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletion_thrift_result.class, metaDataMap);
    }

    public reportCompletion_thrift_result() {
    }

    public reportCompletion_thrift_result(
      long success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletion_thrift_result(reportCompletion_thrift_result other) {
      __isset_bitfield = other.__isset_bitfield;
      this.success = other.success;
    }

    public reportCompletion_thrift_result deepCopy() {
      return new reportCompletion_thrift_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = 0;
    }

    public long getSuccess() {
      return this.success;
    }

    public reportCompletion_thrift_result setSuccess(long success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return EncodingUtils.testBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletion_thrift_result)
        return this.equals((reportCompletion_thrift_result)that);
      return false;
    }

    public boolean equals(reportCompletion_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true;
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletion_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletion_thrift_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletion_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public reportCompletion_thrift_resultStandardScheme getScheme() {
        return new reportCompletion_thrift_resultStandardScheme();
      }
    }

    private static class reportCompletion_thrift_resultStandardScheme extends StandardScheme<reportCompletion_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletion_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.success = iprot.readI64();
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletion_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.isSetSuccess()) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          oprot.writeI64(struct.success);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletion_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public reportCompletion_thrift_resultTupleScheme getScheme() {
        return new reportCompletion_thrift_resultTupleScheme();
      }
    }

    private static class reportCompletion_thrift_resultTupleScheme extends TupleScheme<reportCompletion_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletion_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          oprot.writeI64(struct.success);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletion_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = iprot.readI64();
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class reportCompletionBatch_thrift_args implements org.apache.thrift.TBase<reportCompletionBatch_thrift_args, reportCompletionBatch_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletionBatch_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletionBatch_thrift_args");

    private static final org.apache.thrift.protocol.TField COMMIT_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("commitTS", org.apache.thrift.protocol.TType.LIST, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletionBatch_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletionBatch_thrift_argsTupleSchemeFactory());
    }

    public List<Long> commitTS; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      COMMIT_TS((short)1, "commitTS");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // COMMIT_TS
            return COMMIT_TS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.COMMIT_TS, new org.apache.thrift.meta_data.FieldMetaData("commitTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64              , "long"))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletionBatch_thrift_args.class, metaDataMap);
    }

    public reportCompletionBatch_thrift_args() {
    }

    public reportCompletionBatch_thrift_args(
      List<Long> commitTS)
    {
      this();
      this.commitTS = commitTS;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletionBatch_thrift_args(reportCompletionBatch_thrift_args other) {
      if (other.isSetCommitTS()) {
        List<Long> __this__commitTS = new ArrayList<Long>(other.commitTS.size());
        for (Long other_element : other.commitTS) {
          __this__commitTS.add(other_element);
        }
        this.commitTS = __this__commitTS;
      }
    }

    public reportCompletionBatch_thrift_args deepCopy() {
      return new reportCompletionBatch_thrift_args(this);
    }

    @Override
    public void clear() {
      this.commitTS = null;
    }

    public int getCommitTSSize() {
      return (this.commitTS == null) ? 0 : this.commitTS.size();
    }

    public java.util.Iterator<Long> getCommitTSIterator() {
      return (this.commitTS == null) ? null : this.commitTS.iterator();
    }

    public void addToCommitTS(long elem) {
      if (this.commitTS == null) {
        this.commitTS = new ArrayList<Long>();
      }
      this.commitTS.add(elem);
    }

    public List<Long> getCommitTS() {
      return this.commitTS;
    }

    public reportCompletionBatch_thrift_args setCommitTS(List<Long> commitTS) {
      this.commitTS = commitTS;
      return this;
    }

    public void unsetCommitTS() {
      this.commitTS = null;
    }

    /** Returns true if field commitTS is set (has been assigned a value) and false otherwise */
    public boolean isSetCommitTS() {
      return this.commitTS != null;
    }

    public void setCommitTSIsSet(boolean value) {
      if (!value) {
        this.commitTS = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case COMMIT_TS:
        if (value == null) {
          unsetCommitTS();
        } else {
          setCommitTS((List<Long>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case COMMIT_TS:
        return getCommitTS();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case COMMIT_TS:
        return isSetCommitTS();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletionBatch_thrift_args)
        return this.equals((reportCompletionBatch_thrift_args)that);
      return false;
    }

    public boolean equals(reportCompletionBatch_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_commitTS = true && this.isSetCommitTS();
      boolean that_present_commitTS = true && that.isSetCommitTS();
      if (this_present_commitTS || that_present_commitTS) {
        if (!(this_present_commitTS && that_present_commitTS))
          return false;
        if (!this.commitTS.equals(that.commitTS))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_commitTS = true && (isSetCommitTS());
      list.add(present_commitTS);
      if (present_commitTS)
        list.add(commitTS);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletionBatch_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetCommitTS()).compareTo(other.isSetCommitTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetCommitTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.commitTS, other.commitTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletionBatch_thrift_args(");
      boolean first = true;

      sb.append("commitTS:");
      if (this.commitTS == null) {
        sb.append("null");
      } else {
        sb.append(this.commitTS);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletionBatch_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_thrift_argsStandardScheme getScheme() {
        return new reportCompletionBatch_thrift_argsStandardScheme();
      }
    }

    private static class reportCompletionBatch_thrift_argsStandardScheme extends StandardScheme<reportCompletionBatch_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletionBatch_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // COMMIT_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list32 = iprot.readListBegin();
                  struct.commitTS = new ArrayList<Long>(_list32.size);
                  long _elem33;
                  for (int _i34 = 0; _i34 < _list32.size; ++_i34)
                  {
                    _elem33 = iprot.readI64();
                    struct.commitTS.add(_elem33);
                  }
                  iprot.readListEnd();
                }
                struct.setCommitTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletionBatch_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.commitTS != null) {
          oprot.writeFieldBegin(COMMIT_TS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, struct.commitTS.size()));
            for (long _iter35 : struct.commitTS)
            {
              oprot.writeI64(_iter35);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletionBatch_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_thrift_argsTupleScheme getScheme() {
        return new reportCompletionBatch_thrift_argsTupleScheme();
      }
    }

    private static class reportCompletionBatch_thrift_argsTupleScheme extends TupleScheme<reportCompletionBatch_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetCommitTS()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetCommitTS()) {
          {
            oprot.writeI32(struct.commitTS.size());
            for (long _iter36 : struct.commitTS)
            {
              oprot.writeI64(_iter36);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list37 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, iprot.readI32());
            struct.commitTS = new ArrayList<Long>(_list37.size);
            long _elem38;
            for (int _i39 = 0; _i39 < _list37.size; ++_i39)
            {
              _elem38 = iprot.readI64();
              struct.commitTS.add(_elem38);
            }
          }
          struct.setCommitTSIsSet(true);
        }
      }
    }

  }

  public static class reportCompletionBatch_thrift_result implements org.apache.thrift.TBase<reportCompletionBatch_thrift_result, reportCompletionBatch_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletionBatch_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletionBatch_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.I64, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletionBatch_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletionBatch_thrift_resultTupleSchemeFactory());
    }

    public long success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletionBatch_thrift_result.class, metaDataMap);
    }

    public reportCompletionBatch_thrift_result() {
    }

    public reportCompletionBatch_thrift_result(
      long success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletionBatch_thrift_result(reportCompletionBatch_thrift_result other) {
      __isset_bitfield = other.__isset_bitfield;
      this.success = other.success;
    }

    public reportCompletionBatch_thrift_result deepCopy() {
      return new reportCompletionBatch_thrift_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = 0;
    }

    public long getSuccess() {
      return this.success;
    }

    public reportCompletionBatch_thrift_result setSuccess(long success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return EncodingUtils.testBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletionBatch_thrift_result)
        return this.equals((reportCompletionBatch_thrift_result)that);
      return false;
    }

    public boolean equals(reportCompletionBatch_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true;
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletionBatch_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletionBatch_thrift_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletionBatch_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_thrift_resultStandardScheme getScheme() {
        return new reportCompletionBatch_thrift_resultStandardScheme();
      }
    }

    private static class reportCompletionBatch_thrift_resultStandardScheme extends StandardScheme<reportCompletionBatch_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletionBatch_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.success = iprot.readI64();
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletionBatch_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.isSetSuccess()) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          oprot.writeI64(struct.success);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletionBatch_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_thrift_resultTupleScheme getScheme() {
        return new reportCompletionBatch_thrift_resultTupleScheme();
      }
    }

    private static class reportCompletionBatch_thrift_resultTupleScheme extends TupleScheme<reportCompletionBatch_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          oprot.writeI64(struct.success);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = iprot.readI64();
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class validate_thrift_args implements org.apache.thrift.TBase<validate_thrift_args, validate_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<validate_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("validate_thrift_args");

    private static final org.apache.thrift.protocol.TField START_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("startTS", org.apache.thrift.protocol.TType.I64, (short)1);
    private static final org.apache.thrift.protocol.TField RW_SET_FIELD_DESC = new org.apache.thrift.protocol.TField("rwSet", org.apache.thrift.protocol.TType.STRUCT, (short)2);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new validate_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new validate_thrift_argsTupleSchemeFactory());
    }

    public long startTS; // required
    public RWSetInfo_thrift rwSet; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      START_TS((short)1, "startTS"),
      RW_SET((short)2, "rwSet");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // START_TS
            return START_TS;
          case 2: // RW_SET
            return RW_SET;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __STARTTS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.START_TS, new org.apache.thrift.meta_data.FieldMetaData("startTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      tmpMap.put(_Fields.RW_SET, new org.apache.thrift.meta_data.FieldMetaData("rwSet", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, RWSetInfo_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(validate_thrift_args.class, metaDataMap);
    }

    public validate_thrift_args() {
    }

    public validate_thrift_args(
      long startTS,
      RWSetInfo_thrift rwSet)
    {
      this();
      this.startTS = startTS;
      setStartTSIsSet(true);
      this.rwSet = rwSet;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public validate_thrift_args(validate_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.startTS = other.startTS;
      if (other.isSetRwSet()) {
        this.rwSet = new RWSetInfo_thrift(other.rwSet);
      }
    }

    public validate_thrift_args deepCopy() {
      return new validate_thrift_args(this);
    }

    @Override
    public void clear() {
      setStartTSIsSet(false);
      this.startTS = 0;
      this.rwSet = null;
    }

    public long getStartTS() {
      return this.startTS;
    }

    public validate_thrift_args setStartTS(long startTS) {
      this.startTS = startTS;
      setStartTSIsSet(true);
      return this;
    }

    public void unsetStartTS() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    /** Returns true if field startTS is set (has been assigned a value) and false otherwise */
    public boolean isSetStartTS() {
      return EncodingUtils.testBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    public void setStartTSIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __STARTTS_ISSET_ID, value);
    }

    public RWSetInfo_thrift getRwSet() {
      return this.rwSet;
    }

    public validate_thrift_args setRwSet(RWSetInfo_thrift rwSet) {
      this.rwSet = rwSet;
      return this;
    }

    public void unsetRwSet() {
      this.rwSet = null;
    }

    /** Returns true if field rwSet is set (has been assigned a value) and false otherwise */
    public boolean isSetRwSet() {
      return this.rwSet != null;
    }

    public void setRwSetIsSet(boolean value) {
      if (!value) {
        this.rwSet = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case START_TS:
        if (value == null) {
          unsetStartTS();
        } else {
          setStartTS((Long)value);
        }
        break;

      case RW_SET:
        if (value == null) {
          unsetRwSet();
        } else {
          setRwSet((RWSetInfo_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case START_TS:
        return getStartTS();

      case RW_SET:
        return getRwSet();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case START_TS:
        return isSetStartTS();
      case RW_SET:
        return isSetRwSet();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof validate_thrift_args)
        return this.equals((validate_thrift_args)that);
      return false;
    }

    public boolean equals(validate_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_startTS = true;
      boolean that_present_startTS = true;
      if (this_present_startTS || that_present_startTS) {
        if (!(this_present_startTS && that_present_startTS))
          return false;
        if (this.startTS != that.startTS)
          return false;
      }

      boolean this_present_rwSet = true && this.isSetRwSet();
      boolean that_present_rwSet = true && that.isSetRwSet();
      if (this_present_rwSet || that_present_rwSet) {
        if (!(this_present_rwSet && that_present_rwSet))
          return false;
        if (!this.rwSet.equals(that.rwSet))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_startTS = true;
      list.add(present_startTS);
      if (present_startTS)
        list.add(startTS);

      boolean present_rwSet = true && (isSetRwSet());
      list.add(present_rwSet);
      if (present_rwSet)
        list.add(rwSet);

      return list.hashCode();
    }

    @Override
    public int compareTo(validate_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetStartTS()).compareTo(other.isSetStartTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetStartTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.startTS, other.startTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetRwSet()).compareTo(other.isSetRwSet());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetRwSet()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.rwSet, other.rwSet);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("validate_thrift_args(");
      boolean first = true;

      sb.append("startTS:");
      sb.append(this.startTS);
      first = false;
      if (!first) sb.append(", ");
      sb.append("rwSet:");
      if (this.rwSet == null) {
        sb.append("null");
      } else {
        sb.append(this.rwSet);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (rwSet != null) {
        rwSet.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class validate_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public validate_thrift_argsStandardScheme getScheme() {
        return new validate_thrift_argsStandardScheme();
      }
    }

    private static class validate_thrift_argsStandardScheme extends StandardScheme<validate_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, validate_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // START_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.startTS = iprot.readI64();
                struct.setStartTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // RW_SET
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.rwSet = new RWSetInfo_thrift();
                struct.rwSet.read(iprot);
                struct.setRwSetIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, validate_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(START_TS_FIELD_DESC);
        oprot.writeI64(struct.startTS);
        oprot.writeFieldEnd();
        if (struct.rwSet != null) {
          oprot.writeFieldBegin(RW_SET_FIELD_DESC);
          struct.rwSet.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class validate_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public validate_thrift_argsTupleScheme getScheme() {
        return new validate_thrift_argsTupleScheme();
      }
    }

    private static class validate_thrift_argsTupleScheme extends TupleScheme<validate_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, validate_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetStartTS()) {
          optionals.set(0);
        }
        if (struct.isSetRwSet()) {
          optionals.set(1);
        }
        oprot.writeBitSet(optionals, 2);
        if (struct.isSetStartTS()) {
          oprot.writeI64(struct.startTS);
        }
        if (struct.isSetRwSet()) {
          struct.rwSet.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, validate_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(2);
        if (incoming.get(0)) {
          struct.startTS = iprot.readI64();
          struct.setStartTSIsSet(true);
        }
        if (incoming.get(1)) {
          struct.rwSet = new RWSetInfo_thrift();
          struct.rwSet.read(iprot);
          struct.setRwSetIsSet(true);
        }
      }
    }

  }

  public static class validate_thrift_result implements org.apache.thrift.TBase<validate_thrift_result, validate_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<validate_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("validate_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new validate_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new validate_thrift_resultTupleSchemeFactory());
    }

    public ValidateResponse_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ValidateResponse_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(validate_thrift_result.class, metaDataMap);
    }

    public validate_thrift_result() {
    }

    public validate_thrift_result(
      ValidateResponse_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public validate_thrift_result(validate_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new ValidateResponse_thrift(other.success);
      }
    }

    public validate_thrift_result deepCopy() {
      return new validate_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public ValidateResponse_thrift getSuccess() {
      return this.success;
    }

    public validate_thrift_result setSuccess(ValidateResponse_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ValidateResponse_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof validate_thrift_result)
        return this.equals((validate_thrift_result)that);
      return false;
    }

    public boolean equals(validate_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(validate_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("validate_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class validate_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public validate_thrift_resultStandardScheme getScheme() {
        return new validate_thrift_resultStandardScheme();
      }
    }

    private static class validate_thrift_resultStandardScheme extends StandardScheme<validate_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, validate_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new ValidateResponse_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, validate_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class validate_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public validate_thrift_resultTupleScheme getScheme() {
        return new validate_thrift_resultTupleScheme();
      }
    }

    private static class validate_thrift_resultTupleScheme extends TupleScheme<validate_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, validate_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, validate_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new ValidateResponse_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class batchValidate_thrift_args implements org.apache.thrift.TBase<batchValidate_thrift_args, batchValidate_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<batchValidate_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("batchValidate_thrift_args");

    private static final org.apache.thrift.protocol.TField REQUESTS_FIELD_DESC = new org.apache.thrift.protocol.TField("requests", org.apache.thrift.protocol.TType.LIST, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new batchValidate_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new batchValidate_thrift_argsTupleSchemeFactory());
    }

    public List<ValidationRequest_thrift> requests; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      REQUESTS((short)1, "requests");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // REQUESTS
            return REQUESTS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.REQUESTS, new org.apache.thrift.meta_data.FieldMetaData("requests", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ValidationRequest_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(batchValidate_thrift_args.class, metaDataMap);
    }

    public batchValidate_thrift_args() {
    }

    public batchValidate_thrift_args(
      List<ValidationRequest_thrift> requests)
    {
      this();
      this.requests = requests;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public batchValidate_thrift_args(batchValidate_thrift_args other) {
      if (other.isSetRequests()) {
        List<ValidationRequest_thrift> __this__requests = new ArrayList<ValidationRequest_thrift>(other.requests.size());
        for (ValidationRequest_thrift other_element : other.requests) {
          __this__requests.add(new ValidationRequest_thrift(other_element));
        }
        this.requests = __this__requests;
      }
    }

    public batchValidate_thrift_args deepCopy() {
      return new batchValidate_thrift_args(this);
    }

    @Override
    public void clear() {
      this.requests = null;
    }

    public int getRequestsSize() {
      return (this.requests == null) ? 0 : this.requests.size();
    }

    public java.util.Iterator<ValidationRequest_thrift> getRequestsIterator() {
      return (this.requests == null) ? null : this.requests.iterator();
    }

    public void addToRequests(ValidationRequest_thrift elem) {
      if (this.requests == null) {
        this.requests = new ArrayList<ValidationRequest_thrift>();
      }
      this.requests.add(elem);
    }

    public List<ValidationRequest_thrift> getRequests() {
      return this.requests;
    }

    public batchValidate_thrift_args setRequests(List<ValidationRequest_thrift> requests) {
      this.requests = requests;
      return this;
    }

    public void unsetRequests() {
      this.requests = null;
    }

    /** Returns true if field requests is set (has been assigned a value) and false otherwise */
    public boolean isSetRequests() {
      return this.requests != null;
    }

    public void setRequestsIsSet(boolean value) {
      if (!value) {
        this.requests = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case REQUESTS:
        if (value == null) {
          unsetRequests();
        } else {
          setRequests((List<ValidationRequest_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case REQUESTS:
        return getRequests();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case REQUESTS:
        return isSetRequests();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof batchValidate_thrift_args)
        return this.equals((batchValidate_thrift_args)that);
      return false;
    }

    public boolean equals(batchValidate_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_requests = true && this.isSetRequests();
      boolean that_present_requests = true && that.isSetRequests();
      if (this_present_requests || that_present_requests) {
        if (!(this_present_requests && that_present_requests))
          return false;
        if (!this.requests.equals(that.requests))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_requests = true && (isSetRequests());
      list.add(present_requests);
      if (present_requests)
        list.add(requests);

      return list.hashCode();
    }

    @Override
    public int compareTo(batchValidate_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetRequests()).compareTo(other.isSetRequests());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetRequests()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.requests, other.requests);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("batchValidate_thrift_args(");
      boolean first = true;

      sb.append("requests:");
      if (this.requests == null) {
        sb.append("null");
      } else {
        sb.append(this.requests);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class batchValidate_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public batchValidate_thrift_argsStandardScheme getScheme() {
        return new batchValidate_thrift_argsStandardScheme();
      }
    }

    private static class batchValidate_thrift_argsStandardScheme extends StandardScheme<batchValidate_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, batchValidate_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // REQUESTS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list40 = iprot.readListBegin();
                  struct.requests = new ArrayList<ValidationRequest_thrift>(_list40.size);
                  ValidationRequest_thrift _elem41;
                  for (int _i42 = 0; _i42 < _list40.size; ++_i42)
                  {
                    _elem41 = new ValidationRequest_thrift();
                    _elem41.read(iprot);
                    struct.requests.add(_elem41);
                  }
                  iprot.readListEnd();
                }
                struct.setRequestsIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, batchValidate_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.requests != null) {
          oprot.writeFieldBegin(REQUESTS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.requests.size()));
            for (ValidationRequest_thrift _iter43 : struct.requests)
            {
              _iter43.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class batchValidate_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public batchValidate_thrift_argsTupleScheme getScheme() {
        return new batchValidate_thrift_argsTupleScheme();
      }
    }

    private static class batchValidate_thrift_argsTupleScheme extends TupleScheme<batchValidate_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, batchValidate_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetRequests()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetRequests()) {
          {
            oprot.writeI32(struct.requests.size());
            for (ValidationRequest_thrift _iter44 : struct.requests)
            {
              _iter44.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, batchValidate_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list45 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.requests = new ArrayList<ValidationRequest_thrift>(_list45.size);
            ValidationRequest_thrift _elem46;
            for (int _i47 = 0; _i47 < _list45.size; ++_i47)
            {
              _elem46 = new ValidationRequest_thrift();
              _elem46.read(iprot);
              struct.requests.add(_elem46);
            }
          }
          struct.setRequestsIsSet(true);
        }
      }
    }

  }

  public static class batchValidate_thrift_result implements org.apache.thrift.TBase<batchValidate_thrift_result, batchValidate_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<batchValidate_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("batchValidate_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.MAP, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new batchValidate_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new batchValidate_thrift_resultTupleSchemeFactory());
    }

    public Map<String,ValidateResponse_thrift> success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.MapMetaData(org.apache.thrift.protocol.TType.MAP, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING), 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ValidateResponse_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(batchValidate_thrift_result.class, metaDataMap);
    }

    public batchValidate_thrift_result() {
    }

    public batchValidate_thrift_result(
      Map<String,ValidateResponse_thrift> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public batchValidate_thrift_result(batchValidate_thrift_result other) {
      if (other.isSetSuccess()) {
        Map<String,ValidateResponse_thrift> __this__success = new HashMap<String,ValidateResponse_thrift>(other.success.size());
        for (Map.Entry<String, ValidateResponse_thrift> other_element : other.success.entrySet()) {

          String other_element_key = other_element.getKey();
          ValidateResponse_thrift other_element_value = other_element.getValue();

          String __this__success_copy_key = other_element_key;

          ValidateResponse_thrift __this__success_copy_value = new ValidateResponse_thrift(other_element_value);

          __this__success.put(__this__success_copy_key, __this__success_copy_value);
        }
        this.success = __this__success;
      }
    }

    public batchValidate_thrift_result deepCopy() {
      return new batchValidate_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public void putToSuccess(String key, ValidateResponse_thrift val) {
      if (this.success == null) {
        this.success = new HashMap<String,ValidateResponse_thrift>();
      }
      this.success.put(key, val);
    }

    public Map<String,ValidateResponse_thrift> getSuccess() {
      return this.success;
    }

    public batchValidate_thrift_result setSuccess(Map<String,ValidateResponse_thrift> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Map<String,ValidateResponse_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof batchValidate_thrift_result)
        return this.equals((batchValidate_thrift_result)that);
      return false;
    }

    public boolean equals(batchValidate_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(batchValidate_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("batchValidate_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class batchValidate_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public batchValidate_thrift_resultStandardScheme getScheme() {
        return new batchValidate_thrift_resultStandardScheme();
      }
    }

    private static class batchValidate_thrift_resultStandardScheme extends StandardScheme<batchValidate_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, batchValidate_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.MAP) {
                {
                  org.apache.thrift.protocol.TMap _map48 = iprot.readMapBegin();
                  struct.success = new HashMap<String,ValidateResponse_thrift>(2*_map48.size);
                  String _key49;
                  ValidateResponse_thrift _val50;
                  for (int _i51 = 0; _i51 < _map48.size; ++_i51)
                  {
                    _key49 = iprot.readString();
                    _val50 = new ValidateResponse_thrift();
                    _val50.read(iprot);
                    struct.success.put(_key49, _val50);
                  }
                  iprot.readMapEnd();
                }
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, batchValidate_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          {
            oprot.writeMapBegin(new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.STRUCT, struct.success.size()));
            for (Map.Entry<String, ValidateResponse_thrift> _iter52 : struct.success.entrySet())
            {
              oprot.writeString(_iter52.getKey());
              _iter52.getValue().write(oprot);
            }
            oprot.writeMapEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class batchValidate_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public batchValidate_thrift_resultTupleScheme getScheme() {
        return new batchValidate_thrift_resultTupleScheme();
      }
    }

    private static class batchValidate_thrift_resultTupleScheme extends TupleScheme<batchValidate_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, batchValidate_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          {
            oprot.writeI32(struct.success.size());
            for (Map.Entry<String, ValidateResponse_thrift> _iter53 : struct.success.entrySet())
            {
              oprot.writeString(_iter53.getKey());
              _iter53.getValue().write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, batchValidate_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TMap _map54 = new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.success = new HashMap<String,ValidateResponse_thrift>(2*_map54.size);
            String _key55;
            ValidateResponse_thrift _val56;
            for (int _i57 = 0; _i57 < _map54.size; ++_i57)
            {
              _key55 = iprot.readString();
              _val56 = new ValidateResponse_thrift();
              _val56.read(iprot);
              struct.success.put(_key55, _val56);
            }
          }
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

}
