/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

package beehive.util;

import java.rmi.RemoteException;

import beehive.server.HashtableServer;
import beehive.server.ResultObject;
import java.util.concurrent.Callable;

public class CacheCopy implements Callable<ResultObject> {

	private String nodeId;
	private HashtableServer hashTableServer;

	public CacheCopy(String nodeID,HashtableServer server) {
		nodeId = nodeID;
		hashTableServer = server;
	}

	@Override
	public ResultObject call() throws Exception{
		try {
			hashTableServer.cacheInvalidate(nodeId);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		return new ResultObject(""+0);//dummy return objects
	}

}