/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

package beehive.util;

public final class Constants {
    public static final String FROM_MASTER = "from_master";
    public static final String FROM_CACHE = "from_cache";
    public static final String NOT_AVAILABLE = "not_available";
    public static final String INIT_CACHING = "init_caching";
    public static final String CONCURRENT_INVALIDATION = "concurrent_invalidation";
    public static final String CHANGED_MASTERSHIP = "changed_mastership";
    public static final String NOT_CURRENT_MASTER = "not_current_master";
    public static final String INSERTED_IN_MASTER = "inserted_in_master";
    public static final String NODE_LOCKED = "node_locked";
    public static final String NODE_RELOCATED = "node_relocated";
    public static final String NOT_PRESENT = "not present";
    public static final String CACHING_ALREADY_IN_PROGRESS = "caching already in progress";

    public static final int CACHE_INVALIDATION_ASYNCHRONOUS = 0;
    public static final int CACHE_INVALIDATION_SYNCHRONOUS_PARALLEL = 1;
    public static final int CACHE_INVALIDATION_SYNCHRONOUS_SERIAL = 2;
    public static final int CACHE_INVALIDATION_ASYNC_SERIAL = 3;

    // ResultObject Constants
    public static final int FAILED = -1;
    public static final int SUCCESS = 0;
    public static final int RELOCATED = 1;
    public static final int LOCATION_LOCKED = 2;
    public static final int NONEXISTENT_KEY = 3;

    // Validation Constants use in ResultObject status
    public static final int VALIDATION_ABORT = 4;
    public static final int VALIDATION_WRITE_LOCK_FAILED = 5;
    public static final int VALIDATION_WRITE_LOCK_SUCCESS = 6;
    public static final int VALIDATION_READ_LOCK_FAILED = 7;
    public static final int VALIDATION_READ_LOCK_SUCCESS = 8;
    public static final int VALIDATION_LOCK_READ_MODE = 9;
    public static final int VALIDATION_LOCK_WRITE_MODE = 10;

    //RemoteCallConstants
    public static final int ParallelRemoteCall = 0;
    public static final int SerialRemoteCall = 1;
    public static final int ExecutorRemoteServiceCall = 2;

    public static final int WRITE = 100;
    public static final int READ = 101;
    public static final int LOCK_ACQUIRED = 103;
    public static final int LOCK_NOT_ACQUIRED = 104;
}