/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

package beehive.util;

import beehive.server.*;

import java.util.Vector;
import java.util.concurrent.ConcurrentHashMap;

public class RemotePutHandler extends Thread {


	public HashtableServer serverHandle;
//	Barrier barrier;	
	String nodeId;
	ConcurrentHashMap<String, Node> nodeTable;
	public int status = -1;		// 0 equals failed, 1 equals success
	public Object result;

	public RemotePutHandler(HashtableServer server, ConcurrentHashMap<String, Node> nT/*, Barrier barrier*/) {
		this.serverHandle = server;
//		this.barrier = barrier;
		this.nodeTable = nT;
	}

	public void run() {
		try {
			result = serverHandle.putObjects(this.nodeTable);
			status = 1;
		} catch(Exception e) {
			e.printStackTrace();
		}
//		barrier.reportDone();		
	}
}
