/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

package beehive.validationService;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * Created by khand055 on 3/23/17.
 */
public class CoordinationRequestStatus {

    public static final int NOT_INITIATED = 0;
    public static final int IN_PHASE_1 = 1;
    public static final int PHASE_1_COMPLETE = 2;
    public static final int IN_PHASE_2 = 3;
    public static final int COMPLETED = 4;

    Map<Integer, Integer> serverComitted = new ConcurrentHashMap<Integer,Integer>();
    Map<Integer, Integer> serverAborted = new ConcurrentHashMap<Integer,Integer>();

    int cmtVoteCnt;		// num of participants who have voted 'Commit'
    int completedVoteCnt; // num of peer server who completed (either commited or aborted)
    int status;
    int validationOutcome;	// outcome of the phase1 of 2PC request
    int phase1ResponseCount;

}
