/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

package beehive.validationService;

import java.util.HashSet;


public class TimestampManager {  
	
	long gts = 0;	//GTS
	long sts = 0;	//STS
	
	//LinkedList<Long> incompleteTS;	// the list of ts whose completion is not yet reported.
	//LinkedList<Long> completeTS;	// the list of ts whose completion is reported.
	//TreeSet<Long> completeTS;
	HashSet<Long> completeTS1;
	//TreeSet<Long> removedTS;
	//TreeSet<Long> masterTS;
	
	public TimestampManager() {
		//completeTS = new LinkedList<Long>();
		//completeTS = new TreeSet<Long>();
		completeTS1 = new HashSet<Long>();
		//removedTS = new TreeSet<Long>();
		//masterTS = new TreeSet<Long>();
		//incompleteTS = new LinkedList<Long>();
	}

	public synchronized void setSts(long sts) { // At the moment called by GTSTimestamp Manager
		if( this.sts < sts ){
			this.sts = sts;
		}
	}

	public synchronized long getGTS(){		
		gts = gts+1;
		//incompleteTS.add(new Long(gts));
		return gts;
	}

	public long getSTS() {
		//System.out.println("| "+System.currentTimeMillis()+" |"+sts);// + " Set Info Complete" + completeTS.toString() + " Set Info Removed" + removedTS.toString()+ " Set Info Master" + masterTS.toString());
		return sts;
	}
	
	// 
	public synchronized void reportDone(long ts){

		//masterTS.add(ts);
		// remove this ts from the list uncmtTS
		//System.out.println("Report Completion CTS: "+ts);
		//long first;
		//incompleteTS.remove(new Long(ts));

		// if the one that is completed is the immediately next to the current STS
		// then avance STS
		if(ts == sts+1){
			sts = ts;
		} else {
			completeTS1.add(new Long(ts));
		}

		while( completeTS1.size() > 0 ){

			if( completeTS1.contains(sts+1) ){
				completeTS1.remove(sts+1);
				sts++;
			} else {
				break;
			}
//			first = completeTS1.
//
//			first = completeTS.first();
//			if( first == sts + 1){
//				sts = first;
//				completeTS.remove(first);
//				//removedTS.add(first);
//			} else {
//				break;
//			}
		}

		// see if we can advance STS further if the some of the subsequence transaction
		//  have been completed
		/*if(incompleteTS.size() > 0 ){
			long first = incompleteTS.getFirst();
			if(first-1 > sts)
				sts = first-1;			
		} else { // no more incomplete transaction 
			// all transactions for which gts was given are committed 
			sts = gts;
		}*/
		
		//System.out.println("updated STS to "+sts);	
	}
	
}




