/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

package beehive.workpool;

import java.io.*;
import java.util.*;
import beehive.util.*;


public class WorkStatus implements Serializable {


	// public static final int VALID_TASK = 1;
	// public static final int WORK_TERMINATED = 2;
	// public static final int NO_READY_TASK = 3;

	public StatusType status = StatusType.NO_READY_TASK;
	public Vector<Task> taskList = null; 
	public Task task;
	public long latestSTS;

	public WorkStatus(Vector<Task> taskList) {
		status = StatusType.VALID_TASK;
		this.taskList = taskList;
		/* Fill up the transaction id and start ts values */

	}
		
	public WorkStatus(Task t){
		
		status = StatusType.VALID_TASK;
		this.task = t;
	}

	public WorkStatus (StatusType status) {
		this.status = status;
	}
	
}
