namespace java beehive.thrift
typedef i32 int
typedef i64 long

struct Edge_thrift{
	//1: optional int weight;
}

struct Node_thrift{
	1: string nodeId;
	2: long TS;
	3: map<string,Edge_thrift> neighbors;
}

struct NodeData_thrift{
	1: string nodeId;
	2: long TS;
	3: byte nodeClassId;
	4: map<string, string> properties;
}

struct ResultObject_thrift{
	1: int status; // 0 means object is found, 1 means relocated, -1 means not found and no location information.
	2: string statuscode;		
	3: optional Node_thrift n;
	4: optional NodeData_thrift nd;
	5: string nodeId;
	6: string location;
}

struct LockRequest_thrift {
    1: required string nodeId;
    2: required long ts;
    3: required int lockMode;
}

service HashtableServer_thrift{
	ResultObject_thrift put_thrift(1: string key, 2: Node_thrift value);
	ResultObject_thrift get_thrift(1: string key, 2: long storageSystemThreadId);
	ResultObject_thrift getNodeProperties_thrift(1: NodeData_thrift n);
	ResultObject_thrift updateNodeProperties_thrift(1: NodeData_thrift n);
	
	list<ResultObject_thrift> getObjectsProperties_thrift(1: list<NodeData_thrift> keyList);
	list<ResultObject_thrift> updateNodePropertiesParallel_thrift(1: list<NodeData_thrift> objList);
	
	list<ResultObject_thrift> putObjects_thrift(1: map<string, Node_thrift> nodeList);
	list<ResultObject_thrift> getObjects_thrift(1: list<string> keyList);

	list<string> getAllKeys_thrift();
	
	ResultObject_thrift relocate_thrift(1: int nodeId, 2: string serverName);
	oneway void locationChange_thrift(1: int nodeId, 2: string serverName);
	ResultObject_thrift lock_thrift(1: int nodeId);

	// Validation Acquisition interfaces
	int acquireLocks_thrift(1: set<LockRequest_thrift> lockRequests);
	void releaseLocks_thrift(1: set<LockRequest_thrift> lockRequests);
	void commitChanges_thrift(1: set<NodeData_thrift> writeNd, 2: map<string, long> read);


	//int acquireLockForValidation_thrift(1: list<ValidationLockRequest_thrift> toLock);
	//oneway void releaseLockForValidation_thrift(1: list<ValidationLockRelease_thrift> toRelease);
	//list<ResultObject_thrift> putNodeDataAndReleaseLock_thrift(1: list<NodeData_thrift> toPutAndRelease);
	//list<ResultObject_thrift> releaseLocks_thrift(1: list<ValidationLockRelease_thrift> readLocks, 2: list<NodeData_thrift> writeLocks);

}
