namespace java beehive.thrift
typedef i32 int
typedef i64 long


struct RWSetInfo_thrift{
	1: set<string> readSet;
	2: set<string> writeSet;
	3: set<string> unusedSet;
}

/*
struct LoadInfo_thrift{
	1: int load;
	2: bool tsMatch;
	3: string hostname;
}
*/

struct ValidationRequest_thrift {
    1: string tid;
    2: RWSetInfo_thrift rwSet;
    3: long startTS;
}

struct ValidateResponse_thrift{
	1: bool commit;	// commit or abort status
	2: long commitTS;	// commit ts if the txn committed
	3: long latestSTS;	// latest value of sts
	4: set<string> refetchSet; 	// objects in the read-write-set which got modified
	5: bool localResponse=false;	// is the response from local validator
	6: bool speculativeAbort = false;	//in case of abort is the abort speculative
	//7: list<LoadInfo_thrift> loadVector;
	7: long conflictingTS;
}

struct PeerResponse_thrift{
	1: int responseType;
	2: int serverId;
}

service ValidationService_thrift{
	long getSTS_thrift();
	long reportCompletion_thrift(1: long commitTS);
	long reportCompletionBatch_thrift(1: list<long> commitTS);
    	ValidateResponse_thrift validate_thrift(1: long startTS, 2: RWSetInfo_thrift rwSet);
	map<string, ValidateResponse_thrift> batchValidate_thrift(1: list<ValidationRequest_thrift> requests);
}

service PeerInterface_thrift{

    long reportCompletion_peer_thrift(1: long commitTS);
	long reportCompletionBatch_peer_thrift(1: list<long> commitTS);
	PeerResponse_thrift validate_peer_thrift(1: long startTS, 2: RWSetInfo_thrift rwSet, 3: long transactionId);
	long getSTS_peer_thrift();
	list<long> getCtsSts_peer_thrift();
	PeerResponse_thrift commit_peer_thrift(1: long startTS, 2: long commitTS, 3: long transactionId);
	PeerResponse_thrift abort_peer_thrift(1: long startTS, 2: long transactionId, 3: bool bReleaseLock);
}
