package TestProgs.GraphColoring;

import beehive.util.*;
import java.util.*;

import java.io.*;

public class GCNode  extends Node implements Externalizable  {

    boolean marked;
	int color;
	
	public GCNode(){
		super();
		marked = false;
		color = 0;
	}
	
	public GCNode(String id) {
        super( id );
		marked = false;
		color = 0;
    }

	public GCNode(GCNode n) {
		super(n.nodeId);
		this.marked = n.marked;
		this.color = n.color;

		Enumeration edgeKeys = n.neighbors.keys();
		while(edgeKeys.hasMoreElements())
		{
			String ekey = (String)edgeKeys.nextElement();
			Edge f = (Edge)n.neighbors.get(ekey);
			neighbors.put(ekey,f);	
		}

	}	

    public String printNode () {
        StringBuffer str =  new StringBuffer();
        str.append("Node id: "+ nodeId +"=" + " Color "+color);
        return  str.toString();
    }

    public String toString() {
    	return printNode();
    }

    public String printNodeEdges () {
        StringBuffer str =  new StringBuffer();
        str.append("Node id: "+ nodeId +"=" + " Color: "+color);
        Enumeration edges = neighbors.keys();
        while (edges.hasMoreElements()) {
           String key = (String) edges.nextElement();
           Edge e = (Edge) neighbors.get(key);
           str.append(e.toString()+" ");
        }
        return  str.toString();
    }
    
    public Boolean getMarked() {
    	return marked;
    }
    
    public Integer getColor() {
    	return color;
    }
    
    public void setMarked(Boolean m) {
    	this.marked = m;
    }
    
    public void setColor(Integer c) {
    	this.color = c;
    }
    
    @Override  
	public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {  
    	super.readExternal(in);
    	this.marked = in.readBoolean();
    	this.color = in.readInt();
	}  

	@Override  
	public void writeExternal(ObjectOutput out) throws IOException {  
		super.writeExternal(out);
		out.writeBoolean(this.marked);
		out.writeInt(this.color);
	}
	
	public NodeData toNodeData(Map map, byte classNameID){
		//System.out.println("----> this :: "+this.nodeId+", keys in map : "+map.keySet().toString());
		NodeData nd = new NodeData(this.nodeId, this.TS, classNameID);
		Iterator it = map.keySet().iterator();
		while(it.hasNext()){
			String key = (String) it.next();
			switch (key){
			case "marked": nd.properties.put("marked", this.marked);
				break;
			case "color": nd.properties.put("color", this.color);
				break;
			default : System.out.println("Error (GCNode.toNodeData()) :: No string matched!!!");
				break;
			}
		}
		
		return nd;
	}

}





