/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

package TestProgs.KNearestNeighborsV2;

import java.io.*;

public class KNNData implements Serializable{

	public String nodeId;
	public int distance;
	public String pathThrough;
	
	public KNNData(String nodeId,int distance, String pathThrough){
		this.nodeId = nodeId;
		this.distance = distance;
		this.pathThrough = pathThrough;
	}
	
	public KNNData(KNNData d){
		this.nodeId = d.nodeId;
		this.distance = d.distance;
		this.pathThrough = d.pathThrough;
	}
	
	public String toString(){
		return nodeId+"(d="+distance+",path="+pathThrough+")";
	}
	
	@Override
	public boolean equals(Object o){
		//System.out.println(" -> "+this.nodeId+", "+((KNNData)o).nodeId+", "+this.nodeId.equals(((KNNData)o).nodeId));
		return this.nodeId.equals(((KNNData)o).nodeId);
	}
}
