package TestProgs.MaxClique;

import beehive.util.*;
import java.util.*;

import java.io.*;

public class MCNode extends Node implements Externalizable  {
	public HashSet<String> myTriplets = new HashSet<String>();
	public HashSet<String> maxClique = new HashSet<String>();
	
	public HashSet<String> getMyTriplets() {
		return myTriplets;
	}

	public void setMyTriplets(HashSet<String> myTriplets) {
		this.myTriplets = myTriplets;
	}

	public HashSet<String> getMaxClique() {
		return maxClique;
	}

	public void setMaxClique(HashSet<String> maxClique) {
		this.maxClique = maxClique;
	}

	public MCNode(){
		super();
	}

	public MCNode(String id) {
		super( id );
	}

	public MCNode(MCNode n) {
		super(n);

		myTriplets = new HashSet<String>(n.myTriplets);
		maxClique = new HashSet<String>();
	}	

	public String printNode () {
		StringBuffer str =  new StringBuffer();
		str.append("Node id: "+ nodeId +"=" + " myTriplets "+myTriplets);
		return  str.toString();
	}

	public String toString() {
		return printNode();
	}

	public String printNodeEdges () {
		StringBuffer str =  new StringBuffer();
		str.append("Node id: "+ nodeId +"=" + " myTriplets "+myTriplets);
		Enumeration edges = neighbors.keys();
		while (edges.hasMoreElements()) {
			String key = (String) edges.nextElement();
			Edge e = (Edge) neighbors.get(key);
			str.append(e.toString()+" ");
		}
		return  str.toString();
	}

//	public Boolean getMarked() {
//		return marked;
//	}

//	public void setMarked(Boolean m) {
//		this.marked = m;
//	}

	
	@Override  
	public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {  
		super.readExternal(in);
		this.myTriplets.addAll((HashSet<String>) in.readObject() );
		this.maxClique.addAll((HashSet<String>) in.readObject() );		
	}  

	@Override  
	public void writeExternal(ObjectOutput out) throws IOException {  
		super.writeExternal(out);
		out.writeObject(this.myTriplets);
		out.writeObject(this.maxClique);
	}

}
