package TestProgs.MaxClique;

import  beehive.server.*;
import  beehive.util.*;
import beehive.worker.*;

import java.util.*;

import TestProgs.util.BeehiveAppLoader;

public class MCTest extends BeehiveAppLoader {
	public static void main (String args[]) throws Exception {
		//All inherited Node classes used
		HashMap<Byte, String> nodeClassNameMap = new HashMap<Byte, String>();
		HashMap<Byte, Class> nodeClassMap = new HashMap<Byte, Class>();
		nodeClassNameMap.put((byte) 1, new MCNode().getClass().getName());
		nodeClassMap.put((byte) 1, new MCNode().getClass());
		nodeClassNameMap.put((byte) 2, new MetaDataNode().getClass().getName());
		nodeClassMap.put((byte) 2, new MetaDataNode().getClass());

		
		MCTest loader = new MCTest();
		loader.init(args, "MCTest", nodeClassNameMap, nodeClassMap);
		HashSet<String> computeCliqueNodesSet = new HashSet<String>();
		HashSet<String> allComputeCliqueNodes = new HashSet<String>();
		
		boolean master_thread = loader.isMaster();
		for (int i=0; i< loader.getNumThreads(); i++) {
			if (i> 0) {	
				master_thread = false;
			}
			Worker worker;
			worker = new MCWorkerReflection(loader.getHostlistFile(), loader.getWorkpool(), master_thread, loader.getDataStorage(), i, loader.getLocation(), loader.getNumNodes(), computeCliqueNodesSet, allComputeCliqueNodes);
			Thread workerThread = new Thread(worker);
			workerThread.start();
		}
	}
	
	public void loadGraphData(String input_file, HashtableServer server, int numNodes, StorageSystem  dataStorage) {
		try{
			InputFileReaderDistributed fileReader = new InputFileReaderDistributed(input_file, server);
			fileReader.readAndLoadData();
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
}
