package TestProgs.MaxClique;

import beehive.util.*;
import java.util.*;

import java.io.*;

public class MetaDataNode  extends Node implements Externalizable  {
    public HashSet<String> set;
    public HashMap<String, HashSet<String>> map;
	
	public MetaDataNode(){
		super();
		set = new HashSet<String>();
		map = new HashMap<String, HashSet<String>>();
	}
	
	public MetaDataNode(String nodeid){
		super(nodeid);
		set = new HashSet<String>();
		map = new HashMap<String, HashSet<String>>();
	}

	public MetaDataNode(String nodeid, HashSet hs){
		super(nodeid);
		set = new HashSet<String>(hs);
		map = new HashMap<String, HashSet<String>>();
	}
	
	public MetaDataNode(String nodeid, Vector<String> vec){
		super(nodeid);
		set = new HashSet(vec);
		map = new HashMap<String, HashSet<String>>();
	}
	
	public MetaDataNode(String nodeid, HashMap<String, HashSet<String>> hmap){
		super(nodeid);
		set = new HashSet();
		map = new HashMap<String, HashSet<String>>(hmap);
	}	

	public synchronized void addToMap(String labelNodeIdCommaSeparatedPair){
		String[] str = labelNodeIdCommaSeparatedPair.split(",");
		addToMap(str[0], str[1]);
	}
	
	public synchronized void addToMap(String label, String nodeId){
		HashSet<String> vec = map.get(label);
		if(vec==null)
			vec = new HashSet<String>();
		vec.add(nodeId);
		map.put(label, vec);
	}
	
	public synchronized void clearMap(){
		map.clear();
	}
	
	public synchronized void clearSet(){
		set.clear();
	}
	
	public synchronized boolean isSetEmpty(){
		return set.isEmpty();
	}
	
	public synchronized void addToSet(String str){
		set.add(str);
	}
	
	public synchronized void addAllToSet(HashSet s){
		set.addAll(s);
	}
	
	public synchronized void removeFromSet(String str){
		set.remove(str);
	}

	public synchronized void removeAllFromSet(HashSet s){
		set.removeAll(s);
	}

	public synchronized String printNode () {
        StringBuffer str =  new StringBuffer();
        str.append("Node id: "+ nodeId +"=" + " set "+set.toString());
        return  str.toString();
    }

    public synchronized String toString() {
    	return printNode();
    }

    @Override  
	public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {  
    	super.readExternal(in);
    	this.set = (HashSet) in.readObject();
	}  

	@Override  
	public void writeExternal(ObjectOutput out) throws IOException {  
		super.writeExternal(out);
		out.writeObject(this.set);
	}
}