/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

/**
 * Autogenerated by Thrift Compiler (0.9.3)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package beehive.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (0.9.3)", date = "2018-06-22")
public class HashtableServer_thrift {

  public interface Iface {

    public ResultObject_thrift put_thrift(String key, Node_thrift value) throws org.apache.thrift.TException;

    public ResultObject_thrift get_thrift(String key, long storageSystemThreadId) throws org.apache.thrift.TException;

    public ResultObject_thrift getNodeProperties_thrift(NodeData_thrift n) throws org.apache.thrift.TException;

    public ResultObject_thrift updateNodeProperties_thrift(NodeData_thrift n) throws org.apache.thrift.TException;

    public List<ResultObject_thrift> getObjectsProperties_thrift(List<NodeData_thrift> keyList) throws org.apache.thrift.TException;

    public List<ResultObject_thrift> updateNodePropertiesParallel_thrift(List<NodeData_thrift> objList) throws org.apache.thrift.TException;

    public List<ResultObject_thrift> putObjects_thrift(Map<String,Node_thrift> nodeList) throws org.apache.thrift.TException;

    public List<ResultObject_thrift> getObjects_thrift(List<String> keyList) throws org.apache.thrift.TException;

    public List<String> getAllKeys_thrift() throws org.apache.thrift.TException;

    public ResultObject_thrift relocate_thrift(int nodeId, String serverName) throws org.apache.thrift.TException;

    public void locationChange_thrift(int nodeId, String serverName) throws org.apache.thrift.TException;

    public ResultObject_thrift lock_thrift(int nodeId) throws org.apache.thrift.TException;

    public int acquireLocks_thrift(Set<LockRequest_thrift> lockRequests) throws org.apache.thrift.TException;

    public void releaseLocks_thrift(Set<LockRequest_thrift> lockRequests) throws org.apache.thrift.TException;

    public void commitChanges_thrift(Set<NodeData_thrift> writeNd, Map<String,Long> read) throws org.apache.thrift.TException;

  }

  public interface AsyncIface {

    public void put_thrift(String key, Node_thrift value, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void get_thrift(String key, long storageSystemThreadId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void getNodeProperties_thrift(NodeData_thrift n, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void updateNodeProperties_thrift(NodeData_thrift n, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void getObjectsProperties_thrift(List<NodeData_thrift> keyList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void updateNodePropertiesParallel_thrift(List<NodeData_thrift> objList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void putObjects_thrift(Map<String,Node_thrift> nodeList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void getObjects_thrift(List<String> keyList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void getAllKeys_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void relocate_thrift(int nodeId, String serverName, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void locationChange_thrift(int nodeId, String serverName, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void lock_thrift(int nodeId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void acquireLocks_thrift(Set<LockRequest_thrift> lockRequests, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void releaseLocks_thrift(Set<LockRequest_thrift> lockRequests, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void commitChanges_thrift(Set<NodeData_thrift> writeNd, Map<String,Long> read, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

  }

  public static class Client extends org.apache.thrift.TServiceClient implements Iface {
    public static class Factory implements org.apache.thrift.TServiceClientFactory<Client> {
      public Factory() {}
      public Client getClient(org.apache.thrift.protocol.TProtocol prot) {
        return new Client(prot);
      }
      public Client getClient(org.apache.thrift.protocol.TProtocol iprot, org.apache.thrift.protocol.TProtocol oprot) {
        return new Client(iprot, oprot);
      }
    }

    public Client(org.apache.thrift.protocol.TProtocol prot)
    {
      super(prot, prot);
    }

    public Client(org.apache.thrift.protocol.TProtocol iprot, org.apache.thrift.protocol.TProtocol oprot) {
      super(iprot, oprot);
    }

    public ResultObject_thrift put_thrift(String key, Node_thrift value) throws org.apache.thrift.TException
    {
      send_put_thrift(key, value);
      return recv_put_thrift();
    }

    public void send_put_thrift(String key, Node_thrift value) throws org.apache.thrift.TException
    {
      put_thrift_args args = new put_thrift_args();
      args.setKey(key);
      args.setValue(value);
      sendBase("put_thrift", args);
    }

    public ResultObject_thrift recv_put_thrift() throws org.apache.thrift.TException
    {
      put_thrift_result result = new put_thrift_result();
      receiveBase(result, "put_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "put_thrift failed: unknown result");
    }

    public ResultObject_thrift get_thrift(String key, long storageSystemThreadId) throws org.apache.thrift.TException
    {
      send_get_thrift(key, storageSystemThreadId);
      return recv_get_thrift();
    }

    public void send_get_thrift(String key, long storageSystemThreadId) throws org.apache.thrift.TException
    {
      get_thrift_args args = new get_thrift_args();
      args.setKey(key);
      args.setStorageSystemThreadId(storageSystemThreadId);
      sendBase("get_thrift", args);
    }

    public ResultObject_thrift recv_get_thrift() throws org.apache.thrift.TException
    {
      get_thrift_result result = new get_thrift_result();
      receiveBase(result, "get_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "get_thrift failed: unknown result");
    }

    public ResultObject_thrift getNodeProperties_thrift(NodeData_thrift n) throws org.apache.thrift.TException
    {
      send_getNodeProperties_thrift(n);
      return recv_getNodeProperties_thrift();
    }

    public void send_getNodeProperties_thrift(NodeData_thrift n) throws org.apache.thrift.TException
    {
      getNodeProperties_thrift_args args = new getNodeProperties_thrift_args();
      args.setN(n);
      sendBase("getNodeProperties_thrift", args);
    }

    public ResultObject_thrift recv_getNodeProperties_thrift() throws org.apache.thrift.TException
    {
      getNodeProperties_thrift_result result = new getNodeProperties_thrift_result();
      receiveBase(result, "getNodeProperties_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "getNodeProperties_thrift failed: unknown result");
    }

    public ResultObject_thrift updateNodeProperties_thrift(NodeData_thrift n) throws org.apache.thrift.TException
    {
      send_updateNodeProperties_thrift(n);
      return recv_updateNodeProperties_thrift();
    }

    public void send_updateNodeProperties_thrift(NodeData_thrift n) throws org.apache.thrift.TException
    {
      updateNodeProperties_thrift_args args = new updateNodeProperties_thrift_args();
      args.setN(n);
      sendBase("updateNodeProperties_thrift", args);
    }

    public ResultObject_thrift recv_updateNodeProperties_thrift() throws org.apache.thrift.TException
    {
      updateNodeProperties_thrift_result result = new updateNodeProperties_thrift_result();
      receiveBase(result, "updateNodeProperties_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "updateNodeProperties_thrift failed: unknown result");
    }

    public List<ResultObject_thrift> getObjectsProperties_thrift(List<NodeData_thrift> keyList) throws org.apache.thrift.TException
    {
      send_getObjectsProperties_thrift(keyList);
      return recv_getObjectsProperties_thrift();
    }

    public void send_getObjectsProperties_thrift(List<NodeData_thrift> keyList) throws org.apache.thrift.TException
    {
      getObjectsProperties_thrift_args args = new getObjectsProperties_thrift_args();
      args.setKeyList(keyList);
      sendBase("getObjectsProperties_thrift", args);
    }

    public List<ResultObject_thrift> recv_getObjectsProperties_thrift() throws org.apache.thrift.TException
    {
      getObjectsProperties_thrift_result result = new getObjectsProperties_thrift_result();
      receiveBase(result, "getObjectsProperties_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "getObjectsProperties_thrift failed: unknown result");
    }

    public List<ResultObject_thrift> updateNodePropertiesParallel_thrift(List<NodeData_thrift> objList) throws org.apache.thrift.TException
    {
      send_updateNodePropertiesParallel_thrift(objList);
      return recv_updateNodePropertiesParallel_thrift();
    }

    public void send_updateNodePropertiesParallel_thrift(List<NodeData_thrift> objList) throws org.apache.thrift.TException
    {
      updateNodePropertiesParallel_thrift_args args = new updateNodePropertiesParallel_thrift_args();
      args.setObjList(objList);
      sendBase("updateNodePropertiesParallel_thrift", args);
    }

    public List<ResultObject_thrift> recv_updateNodePropertiesParallel_thrift() throws org.apache.thrift.TException
    {
      updateNodePropertiesParallel_thrift_result result = new updateNodePropertiesParallel_thrift_result();
      receiveBase(result, "updateNodePropertiesParallel_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "updateNodePropertiesParallel_thrift failed: unknown result");
    }

    public List<ResultObject_thrift> putObjects_thrift(Map<String,Node_thrift> nodeList) throws org.apache.thrift.TException
    {
      send_putObjects_thrift(nodeList);
      return recv_putObjects_thrift();
    }

    public void send_putObjects_thrift(Map<String,Node_thrift> nodeList) throws org.apache.thrift.TException
    {
      putObjects_thrift_args args = new putObjects_thrift_args();
      args.setNodeList(nodeList);
      sendBase("putObjects_thrift", args);
    }

    public List<ResultObject_thrift> recv_putObjects_thrift() throws org.apache.thrift.TException
    {
      putObjects_thrift_result result = new putObjects_thrift_result();
      receiveBase(result, "putObjects_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "putObjects_thrift failed: unknown result");
    }

    public List<ResultObject_thrift> getObjects_thrift(List<String> keyList) throws org.apache.thrift.TException
    {
      send_getObjects_thrift(keyList);
      return recv_getObjects_thrift();
    }

    public void send_getObjects_thrift(List<String> keyList) throws org.apache.thrift.TException
    {
      getObjects_thrift_args args = new getObjects_thrift_args();
      args.setKeyList(keyList);
      sendBase("getObjects_thrift", args);
    }

    public List<ResultObject_thrift> recv_getObjects_thrift() throws org.apache.thrift.TException
    {
      getObjects_thrift_result result = new getObjects_thrift_result();
      receiveBase(result, "getObjects_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "getObjects_thrift failed: unknown result");
    }

    public List<String> getAllKeys_thrift() throws org.apache.thrift.TException
    {
      send_getAllKeys_thrift();
      return recv_getAllKeys_thrift();
    }

    public void send_getAllKeys_thrift() throws org.apache.thrift.TException
    {
      getAllKeys_thrift_args args = new getAllKeys_thrift_args();
      sendBase("getAllKeys_thrift", args);
    }

    public List<String> recv_getAllKeys_thrift() throws org.apache.thrift.TException
    {
      getAllKeys_thrift_result result = new getAllKeys_thrift_result();
      receiveBase(result, "getAllKeys_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "getAllKeys_thrift failed: unknown result");
    }

    public ResultObject_thrift relocate_thrift(int nodeId, String serverName) throws org.apache.thrift.TException
    {
      send_relocate_thrift(nodeId, serverName);
      return recv_relocate_thrift();
    }

    public void send_relocate_thrift(int nodeId, String serverName) throws org.apache.thrift.TException
    {
      relocate_thrift_args args = new relocate_thrift_args();
      args.setNodeId(nodeId);
      args.setServerName(serverName);
      sendBase("relocate_thrift", args);
    }

    public ResultObject_thrift recv_relocate_thrift() throws org.apache.thrift.TException
    {
      relocate_thrift_result result = new relocate_thrift_result();
      receiveBase(result, "relocate_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "relocate_thrift failed: unknown result");
    }

    public void locationChange_thrift(int nodeId, String serverName) throws org.apache.thrift.TException
    {
      send_locationChange_thrift(nodeId, serverName);
    }

    public void send_locationChange_thrift(int nodeId, String serverName) throws org.apache.thrift.TException
    {
      locationChange_thrift_args args = new locationChange_thrift_args();
      args.setNodeId(nodeId);
      args.setServerName(serverName);
      sendBaseOneway("locationChange_thrift", args);
    }

    public ResultObject_thrift lock_thrift(int nodeId) throws org.apache.thrift.TException
    {
      send_lock_thrift(nodeId);
      return recv_lock_thrift();
    }

    public void send_lock_thrift(int nodeId) throws org.apache.thrift.TException
    {
      lock_thrift_args args = new lock_thrift_args();
      args.setNodeId(nodeId);
      sendBase("lock_thrift", args);
    }

    public ResultObject_thrift recv_lock_thrift() throws org.apache.thrift.TException
    {
      lock_thrift_result result = new lock_thrift_result();
      receiveBase(result, "lock_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "lock_thrift failed: unknown result");
    }

    public int acquireLocks_thrift(Set<LockRequest_thrift> lockRequests) throws org.apache.thrift.TException
    {
      send_acquireLocks_thrift(lockRequests);
      return recv_acquireLocks_thrift();
    }

    public void send_acquireLocks_thrift(Set<LockRequest_thrift> lockRequests) throws org.apache.thrift.TException
    {
      acquireLocks_thrift_args args = new acquireLocks_thrift_args();
      args.setLockRequests(lockRequests);
      sendBase("acquireLocks_thrift", args);
    }

    public int recv_acquireLocks_thrift() throws org.apache.thrift.TException
    {
      acquireLocks_thrift_result result = new acquireLocks_thrift_result();
      receiveBase(result, "acquireLocks_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "acquireLocks_thrift failed: unknown result");
    }

    public void releaseLocks_thrift(Set<LockRequest_thrift> lockRequests) throws org.apache.thrift.TException
    {
      send_releaseLocks_thrift(lockRequests);
      recv_releaseLocks_thrift();
    }

    public void send_releaseLocks_thrift(Set<LockRequest_thrift> lockRequests) throws org.apache.thrift.TException
    {
      releaseLocks_thrift_args args = new releaseLocks_thrift_args();
      args.setLockRequests(lockRequests);
      sendBase("releaseLocks_thrift", args);
    }

    public void recv_releaseLocks_thrift() throws org.apache.thrift.TException
    {
      releaseLocks_thrift_result result = new releaseLocks_thrift_result();
      receiveBase(result, "releaseLocks_thrift");
      return;
    }

    public void commitChanges_thrift(Set<NodeData_thrift> writeNd, Map<String,Long> read) throws org.apache.thrift.TException
    {
      send_commitChanges_thrift(writeNd, read);
      recv_commitChanges_thrift();
    }

    public void send_commitChanges_thrift(Set<NodeData_thrift> writeNd, Map<String,Long> read) throws org.apache.thrift.TException
    {
      commitChanges_thrift_args args = new commitChanges_thrift_args();
      args.setWriteNd(writeNd);
      args.setRead(read);
      sendBase("commitChanges_thrift", args);
    }

    public void recv_commitChanges_thrift() throws org.apache.thrift.TException
    {
      commitChanges_thrift_result result = new commitChanges_thrift_result();
      receiveBase(result, "commitChanges_thrift");
      return;
    }

  }
  public static class AsyncClient extends org.apache.thrift.async.TAsyncClient implements AsyncIface {
    public static class Factory implements org.apache.thrift.async.TAsyncClientFactory<AsyncClient> {
      private org.apache.thrift.async.TAsyncClientManager clientManager;
      private org.apache.thrift.protocol.TProtocolFactory protocolFactory;
      public Factory(org.apache.thrift.async.TAsyncClientManager clientManager, org.apache.thrift.protocol.TProtocolFactory protocolFactory) {
        this.clientManager = clientManager;
        this.protocolFactory = protocolFactory;
      }
      public AsyncClient getAsyncClient(org.apache.thrift.transport.TNonblockingTransport transport) {
        return new AsyncClient(protocolFactory, clientManager, transport);
      }
    }

    public AsyncClient(org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.async.TAsyncClientManager clientManager, org.apache.thrift.transport.TNonblockingTransport transport) {
      super(protocolFactory, clientManager, transport);
    }

    public void put_thrift(String key, Node_thrift value, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      put_thrift_call method_call = new put_thrift_call(key, value, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class put_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private String key;
      private Node_thrift value;
      public put_thrift_call(String key, Node_thrift value, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.key = key;
        this.value = value;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("put_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        put_thrift_args args = new put_thrift_args();
        args.setKey(key);
        args.setValue(value);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public ResultObject_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_put_thrift();
      }
    }

    public void get_thrift(String key, long storageSystemThreadId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      get_thrift_call method_call = new get_thrift_call(key, storageSystemThreadId, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class get_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private String key;
      private long storageSystemThreadId;
      public get_thrift_call(String key, long storageSystemThreadId, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.key = key;
        this.storageSystemThreadId = storageSystemThreadId;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("get_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        get_thrift_args args = new get_thrift_args();
        args.setKey(key);
        args.setStorageSystemThreadId(storageSystemThreadId);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public ResultObject_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_get_thrift();
      }
    }

    public void getNodeProperties_thrift(NodeData_thrift n, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      getNodeProperties_thrift_call method_call = new getNodeProperties_thrift_call(n, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class getNodeProperties_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private NodeData_thrift n;
      public getNodeProperties_thrift_call(NodeData_thrift n, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.n = n;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("getNodeProperties_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        getNodeProperties_thrift_args args = new getNodeProperties_thrift_args();
        args.setN(n);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public ResultObject_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getNodeProperties_thrift();
      }
    }

    public void updateNodeProperties_thrift(NodeData_thrift n, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      updateNodeProperties_thrift_call method_call = new updateNodeProperties_thrift_call(n, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class updateNodeProperties_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private NodeData_thrift n;
      public updateNodeProperties_thrift_call(NodeData_thrift n, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.n = n;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("updateNodeProperties_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        updateNodeProperties_thrift_args args = new updateNodeProperties_thrift_args();
        args.setN(n);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public ResultObject_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_updateNodeProperties_thrift();
      }
    }

    public void getObjectsProperties_thrift(List<NodeData_thrift> keyList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      getObjectsProperties_thrift_call method_call = new getObjectsProperties_thrift_call(keyList, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class getObjectsProperties_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private List<NodeData_thrift> keyList;
      public getObjectsProperties_thrift_call(List<NodeData_thrift> keyList, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.keyList = keyList;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("getObjectsProperties_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        getObjectsProperties_thrift_args args = new getObjectsProperties_thrift_args();
        args.setKeyList(keyList);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public List<ResultObject_thrift> getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getObjectsProperties_thrift();
      }
    }

    public void updateNodePropertiesParallel_thrift(List<NodeData_thrift> objList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      updateNodePropertiesParallel_thrift_call method_call = new updateNodePropertiesParallel_thrift_call(objList, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class updateNodePropertiesParallel_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private List<NodeData_thrift> objList;
      public updateNodePropertiesParallel_thrift_call(List<NodeData_thrift> objList, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.objList = objList;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("updateNodePropertiesParallel_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        updateNodePropertiesParallel_thrift_args args = new updateNodePropertiesParallel_thrift_args();
        args.setObjList(objList);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public List<ResultObject_thrift> getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_updateNodePropertiesParallel_thrift();
      }
    }

    public void putObjects_thrift(Map<String,Node_thrift> nodeList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      putObjects_thrift_call method_call = new putObjects_thrift_call(nodeList, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class putObjects_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private Map<String,Node_thrift> nodeList;
      public putObjects_thrift_call(Map<String,Node_thrift> nodeList, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.nodeList = nodeList;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("putObjects_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        putObjects_thrift_args args = new putObjects_thrift_args();
        args.setNodeList(nodeList);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public List<ResultObject_thrift> getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_putObjects_thrift();
      }
    }

    public void getObjects_thrift(List<String> keyList, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      getObjects_thrift_call method_call = new getObjects_thrift_call(keyList, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class getObjects_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private List<String> keyList;
      public getObjects_thrift_call(List<String> keyList, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.keyList = keyList;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("getObjects_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        getObjects_thrift_args args = new getObjects_thrift_args();
        args.setKeyList(keyList);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public List<ResultObject_thrift> getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getObjects_thrift();
      }
    }

    public void getAllKeys_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      getAllKeys_thrift_call method_call = new getAllKeys_thrift_call(resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class getAllKeys_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      public getAllKeys_thrift_call(org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("getAllKeys_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        getAllKeys_thrift_args args = new getAllKeys_thrift_args();
        args.write(prot);
        prot.writeMessageEnd();
      }

      public List<String> getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getAllKeys_thrift();
      }
    }

    public void relocate_thrift(int nodeId, String serverName, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      relocate_thrift_call method_call = new relocate_thrift_call(nodeId, serverName, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class relocate_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private int nodeId;
      private String serverName;
      public relocate_thrift_call(int nodeId, String serverName, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.nodeId = nodeId;
        this.serverName = serverName;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("relocate_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        relocate_thrift_args args = new relocate_thrift_args();
        args.setNodeId(nodeId);
        args.setServerName(serverName);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public ResultObject_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_relocate_thrift();
      }
    }

    public void locationChange_thrift(int nodeId, String serverName, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      locationChange_thrift_call method_call = new locationChange_thrift_call(nodeId, serverName, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class locationChange_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private int nodeId;
      private String serverName;
      public locationChange_thrift_call(int nodeId, String serverName, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, true);
        this.nodeId = nodeId;
        this.serverName = serverName;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("locationChange_thrift", org.apache.thrift.protocol.TMessageType.ONEWAY, 0));
        locationChange_thrift_args args = new locationChange_thrift_args();
        args.setNodeId(nodeId);
        args.setServerName(serverName);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public void getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
      }
    }

    public void lock_thrift(int nodeId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      lock_thrift_call method_call = new lock_thrift_call(nodeId, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class lock_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private int nodeId;
      public lock_thrift_call(int nodeId, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.nodeId = nodeId;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("lock_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        lock_thrift_args args = new lock_thrift_args();
        args.setNodeId(nodeId);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public ResultObject_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_lock_thrift();
      }
    }

    public void acquireLocks_thrift(Set<LockRequest_thrift> lockRequests, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      acquireLocks_thrift_call method_call = new acquireLocks_thrift_call(lockRequests, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class acquireLocks_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private Set<LockRequest_thrift> lockRequests;
      public acquireLocks_thrift_call(Set<LockRequest_thrift> lockRequests, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.lockRequests = lockRequests;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("acquireLocks_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        acquireLocks_thrift_args args = new acquireLocks_thrift_args();
        args.setLockRequests(lockRequests);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public int getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_acquireLocks_thrift();
      }
    }

    public void releaseLocks_thrift(Set<LockRequest_thrift> lockRequests, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      releaseLocks_thrift_call method_call = new releaseLocks_thrift_call(lockRequests, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class releaseLocks_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private Set<LockRequest_thrift> lockRequests;
      public releaseLocks_thrift_call(Set<LockRequest_thrift> lockRequests, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.lockRequests = lockRequests;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("releaseLocks_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        releaseLocks_thrift_args args = new releaseLocks_thrift_args();
        args.setLockRequests(lockRequests);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public void getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        (new Client(prot)).recv_releaseLocks_thrift();
      }
    }

    public void commitChanges_thrift(Set<NodeData_thrift> writeNd, Map<String,Long> read, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      commitChanges_thrift_call method_call = new commitChanges_thrift_call(writeNd, read, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class commitChanges_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private Set<NodeData_thrift> writeNd;
      private Map<String,Long> read;
      public commitChanges_thrift_call(Set<NodeData_thrift> writeNd, Map<String,Long> read, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.writeNd = writeNd;
        this.read = read;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("commitChanges_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        commitChanges_thrift_args args = new commitChanges_thrift_args();
        args.setWriteNd(writeNd);
        args.setRead(read);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public void getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        (new Client(prot)).recv_commitChanges_thrift();
      }
    }

  }

  public static class Processor<I extends Iface> extends org.apache.thrift.TBaseProcessor<I> implements org.apache.thrift.TProcessor {
    private static final Logger LOGGER = LoggerFactory.getLogger(Processor.class.getName());
    public Processor(I iface) {
      super(iface, getProcessMap(new HashMap<String, org.apache.thrift.ProcessFunction<I, ? extends org.apache.thrift.TBase>>()));
    }

    protected Processor(I iface, Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> processMap) {
      super(iface, getProcessMap(processMap));
    }

    private static <I extends Iface> Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> getProcessMap(Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> processMap) {
      processMap.put("put_thrift", new put_thrift());
      processMap.put("get_thrift", new get_thrift());
      processMap.put("getNodeProperties_thrift", new getNodeProperties_thrift());
      processMap.put("updateNodeProperties_thrift", new updateNodeProperties_thrift());
      processMap.put("getObjectsProperties_thrift", new getObjectsProperties_thrift());
      processMap.put("updateNodePropertiesParallel_thrift", new updateNodePropertiesParallel_thrift());
      processMap.put("putObjects_thrift", new putObjects_thrift());
      processMap.put("getObjects_thrift", new getObjects_thrift());
      processMap.put("getAllKeys_thrift", new getAllKeys_thrift());
      processMap.put("relocate_thrift", new relocate_thrift());
      processMap.put("locationChange_thrift", new locationChange_thrift());
      processMap.put("lock_thrift", new lock_thrift());
      processMap.put("acquireLocks_thrift", new acquireLocks_thrift());
      processMap.put("releaseLocks_thrift", new releaseLocks_thrift());
      processMap.put("commitChanges_thrift", new commitChanges_thrift());
      return processMap;
    }

    public static class put_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, put_thrift_args> {
      public put_thrift() {
        super("put_thrift");
      }

      public put_thrift_args getEmptyArgsInstance() {
        return new put_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public put_thrift_result getResult(I iface, put_thrift_args args) throws org.apache.thrift.TException {
        put_thrift_result result = new put_thrift_result();
        result.success = iface.put_thrift(args.key, args.value);
        return result;
      }
    }

    public static class get_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, get_thrift_args> {
      public get_thrift() {
        super("get_thrift");
      }

      public get_thrift_args getEmptyArgsInstance() {
        return new get_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public get_thrift_result getResult(I iface, get_thrift_args args) throws org.apache.thrift.TException {
        get_thrift_result result = new get_thrift_result();
        result.success = iface.get_thrift(args.key, args.storageSystemThreadId);
        return result;
      }
    }

    public static class getNodeProperties_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, getNodeProperties_thrift_args> {
      public getNodeProperties_thrift() {
        super("getNodeProperties_thrift");
      }

      public getNodeProperties_thrift_args getEmptyArgsInstance() {
        return new getNodeProperties_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public getNodeProperties_thrift_result getResult(I iface, getNodeProperties_thrift_args args) throws org.apache.thrift.TException {
        getNodeProperties_thrift_result result = new getNodeProperties_thrift_result();
        result.success = iface.getNodeProperties_thrift(args.n);
        return result;
      }
    }

    public static class updateNodeProperties_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, updateNodeProperties_thrift_args> {
      public updateNodeProperties_thrift() {
        super("updateNodeProperties_thrift");
      }

      public updateNodeProperties_thrift_args getEmptyArgsInstance() {
        return new updateNodeProperties_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public updateNodeProperties_thrift_result getResult(I iface, updateNodeProperties_thrift_args args) throws org.apache.thrift.TException {
        updateNodeProperties_thrift_result result = new updateNodeProperties_thrift_result();
        result.success = iface.updateNodeProperties_thrift(args.n);
        return result;
      }
    }

    public static class getObjectsProperties_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, getObjectsProperties_thrift_args> {
      public getObjectsProperties_thrift() {
        super("getObjectsProperties_thrift");
      }

      public getObjectsProperties_thrift_args getEmptyArgsInstance() {
        return new getObjectsProperties_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public getObjectsProperties_thrift_result getResult(I iface, getObjectsProperties_thrift_args args) throws org.apache.thrift.TException {
        getObjectsProperties_thrift_result result = new getObjectsProperties_thrift_result();
        result.success = iface.getObjectsProperties_thrift(args.keyList);
        return result;
      }
    }

    public static class updateNodePropertiesParallel_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, updateNodePropertiesParallel_thrift_args> {
      public updateNodePropertiesParallel_thrift() {
        super("updateNodePropertiesParallel_thrift");
      }

      public updateNodePropertiesParallel_thrift_args getEmptyArgsInstance() {
        return new updateNodePropertiesParallel_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public updateNodePropertiesParallel_thrift_result getResult(I iface, updateNodePropertiesParallel_thrift_args args) throws org.apache.thrift.TException {
        updateNodePropertiesParallel_thrift_result result = new updateNodePropertiesParallel_thrift_result();
        result.success = iface.updateNodePropertiesParallel_thrift(args.objList);
        return result;
      }
    }

    public static class putObjects_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, putObjects_thrift_args> {
      public putObjects_thrift() {
        super("putObjects_thrift");
      }

      public putObjects_thrift_args getEmptyArgsInstance() {
        return new putObjects_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public putObjects_thrift_result getResult(I iface, putObjects_thrift_args args) throws org.apache.thrift.TException {
        putObjects_thrift_result result = new putObjects_thrift_result();
        result.success = iface.putObjects_thrift(args.nodeList);
        return result;
      }
    }

    public static class getObjects_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, getObjects_thrift_args> {
      public getObjects_thrift() {
        super("getObjects_thrift");
      }

      public getObjects_thrift_args getEmptyArgsInstance() {
        return new getObjects_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public getObjects_thrift_result getResult(I iface, getObjects_thrift_args args) throws org.apache.thrift.TException {
        getObjects_thrift_result result = new getObjects_thrift_result();
        result.success = iface.getObjects_thrift(args.keyList);
        return result;
      }
    }

    public static class getAllKeys_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, getAllKeys_thrift_args> {
      public getAllKeys_thrift() {
        super("getAllKeys_thrift");
      }

      public getAllKeys_thrift_args getEmptyArgsInstance() {
        return new getAllKeys_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public getAllKeys_thrift_result getResult(I iface, getAllKeys_thrift_args args) throws org.apache.thrift.TException {
        getAllKeys_thrift_result result = new getAllKeys_thrift_result();
        result.success = iface.getAllKeys_thrift();
        return result;
      }
    }

    public static class relocate_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, relocate_thrift_args> {
      public relocate_thrift() {
        super("relocate_thrift");
      }

      public relocate_thrift_args getEmptyArgsInstance() {
        return new relocate_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public relocate_thrift_result getResult(I iface, relocate_thrift_args args) throws org.apache.thrift.TException {
        relocate_thrift_result result = new relocate_thrift_result();
        result.success = iface.relocate_thrift(args.nodeId, args.serverName);
        return result;
      }
    }

    public static class locationChange_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, locationChange_thrift_args> {
      public locationChange_thrift() {
        super("locationChange_thrift");
      }

      public locationChange_thrift_args getEmptyArgsInstance() {
        return new locationChange_thrift_args();
      }

      protected boolean isOneway() {
        return true;
      }

      public org.apache.thrift.TBase getResult(I iface, locationChange_thrift_args args) throws org.apache.thrift.TException {
        iface.locationChange_thrift(args.nodeId, args.serverName);
        return null;
      }
    }

    public static class lock_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, lock_thrift_args> {
      public lock_thrift() {
        super("lock_thrift");
      }

      public lock_thrift_args getEmptyArgsInstance() {
        return new lock_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public lock_thrift_result getResult(I iface, lock_thrift_args args) throws org.apache.thrift.TException {
        lock_thrift_result result = new lock_thrift_result();
        result.success = iface.lock_thrift(args.nodeId);
        return result;
      }
    }

    public static class acquireLocks_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, acquireLocks_thrift_args> {
      public acquireLocks_thrift() {
        super("acquireLocks_thrift");
      }

      public acquireLocks_thrift_args getEmptyArgsInstance() {
        return new acquireLocks_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public acquireLocks_thrift_result getResult(I iface, acquireLocks_thrift_args args) throws org.apache.thrift.TException {
        acquireLocks_thrift_result result = new acquireLocks_thrift_result();
        result.success = iface.acquireLocks_thrift(args.lockRequests);
        result.setSuccessIsSet(true);
        return result;
      }
    }

    public static class releaseLocks_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, releaseLocks_thrift_args> {
      public releaseLocks_thrift() {
        super("releaseLocks_thrift");
      }

      public releaseLocks_thrift_args getEmptyArgsInstance() {
        return new releaseLocks_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public releaseLocks_thrift_result getResult(I iface, releaseLocks_thrift_args args) throws org.apache.thrift.TException {
        releaseLocks_thrift_result result = new releaseLocks_thrift_result();
        iface.releaseLocks_thrift(args.lockRequests);
        return result;
      }
    }

    public static class commitChanges_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, commitChanges_thrift_args> {
      public commitChanges_thrift() {
        super("commitChanges_thrift");
      }

      public commitChanges_thrift_args getEmptyArgsInstance() {
        return new commitChanges_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public commitChanges_thrift_result getResult(I iface, commitChanges_thrift_args args) throws org.apache.thrift.TException {
        commitChanges_thrift_result result = new commitChanges_thrift_result();
        iface.commitChanges_thrift(args.writeNd, args.read);
        return result;
      }
    }

  }

  public static class AsyncProcessor<I extends AsyncIface> extends org.apache.thrift.TBaseAsyncProcessor<I> {
    private static final Logger LOGGER = LoggerFactory.getLogger(AsyncProcessor.class.getName());
    public AsyncProcessor(I iface) {
      super(iface, getProcessMap(new HashMap<String, org.apache.thrift.AsyncProcessFunction<I, ? extends org.apache.thrift.TBase, ?>>()));
    }

    protected AsyncProcessor(I iface, Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase, ?>> processMap) {
      super(iface, getProcessMap(processMap));
    }

    private static <I extends AsyncIface> Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase,?>> getProcessMap(Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase, ?>> processMap) {
      processMap.put("put_thrift", new put_thrift());
      processMap.put("get_thrift", new get_thrift());
      processMap.put("getNodeProperties_thrift", new getNodeProperties_thrift());
      processMap.put("updateNodeProperties_thrift", new updateNodeProperties_thrift());
      processMap.put("getObjectsProperties_thrift", new getObjectsProperties_thrift());
      processMap.put("updateNodePropertiesParallel_thrift", new updateNodePropertiesParallel_thrift());
      processMap.put("putObjects_thrift", new putObjects_thrift());
      processMap.put("getObjects_thrift", new getObjects_thrift());
      processMap.put("getAllKeys_thrift", new getAllKeys_thrift());
      processMap.put("relocate_thrift", new relocate_thrift());
      processMap.put("locationChange_thrift", new locationChange_thrift());
      processMap.put("lock_thrift", new lock_thrift());
      processMap.put("acquireLocks_thrift", new acquireLocks_thrift());
      processMap.put("releaseLocks_thrift", new releaseLocks_thrift());
      processMap.put("commitChanges_thrift", new commitChanges_thrift());
      return processMap;
    }

    public static class put_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, put_thrift_args, ResultObject_thrift> {
      public put_thrift() {
        super("put_thrift");
      }

      public put_thrift_args getEmptyArgsInstance() {
        return new put_thrift_args();
      }

      public AsyncMethodCallback<ResultObject_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<ResultObject_thrift>() { 
          public void onComplete(ResultObject_thrift o) {
            put_thrift_result result = new put_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            put_thrift_result result = new put_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, put_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<ResultObject_thrift> resultHandler) throws TException {
        iface.put_thrift(args.key, args.value,resultHandler);
      }
    }

    public static class get_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, get_thrift_args, ResultObject_thrift> {
      public get_thrift() {
        super("get_thrift");
      }

      public get_thrift_args getEmptyArgsInstance() {
        return new get_thrift_args();
      }

      public AsyncMethodCallback<ResultObject_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<ResultObject_thrift>() { 
          public void onComplete(ResultObject_thrift o) {
            get_thrift_result result = new get_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            get_thrift_result result = new get_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, get_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<ResultObject_thrift> resultHandler) throws TException {
        iface.get_thrift(args.key, args.storageSystemThreadId,resultHandler);
      }
    }

    public static class getNodeProperties_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, getNodeProperties_thrift_args, ResultObject_thrift> {
      public getNodeProperties_thrift() {
        super("getNodeProperties_thrift");
      }

      public getNodeProperties_thrift_args getEmptyArgsInstance() {
        return new getNodeProperties_thrift_args();
      }

      public AsyncMethodCallback<ResultObject_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<ResultObject_thrift>() { 
          public void onComplete(ResultObject_thrift o) {
            getNodeProperties_thrift_result result = new getNodeProperties_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            getNodeProperties_thrift_result result = new getNodeProperties_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, getNodeProperties_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<ResultObject_thrift> resultHandler) throws TException {
        iface.getNodeProperties_thrift(args.n,resultHandler);
      }
    }

    public static class updateNodeProperties_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, updateNodeProperties_thrift_args, ResultObject_thrift> {
      public updateNodeProperties_thrift() {
        super("updateNodeProperties_thrift");
      }

      public updateNodeProperties_thrift_args getEmptyArgsInstance() {
        return new updateNodeProperties_thrift_args();
      }

      public AsyncMethodCallback<ResultObject_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<ResultObject_thrift>() { 
          public void onComplete(ResultObject_thrift o) {
            updateNodeProperties_thrift_result result = new updateNodeProperties_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            updateNodeProperties_thrift_result result = new updateNodeProperties_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, updateNodeProperties_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<ResultObject_thrift> resultHandler) throws TException {
        iface.updateNodeProperties_thrift(args.n,resultHandler);
      }
    }

    public static class getObjectsProperties_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, getObjectsProperties_thrift_args, List<ResultObject_thrift>> {
      public getObjectsProperties_thrift() {
        super("getObjectsProperties_thrift");
      }

      public getObjectsProperties_thrift_args getEmptyArgsInstance() {
        return new getObjectsProperties_thrift_args();
      }

      public AsyncMethodCallback<List<ResultObject_thrift>> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<List<ResultObject_thrift>>() { 
          public void onComplete(List<ResultObject_thrift> o) {
            getObjectsProperties_thrift_result result = new getObjectsProperties_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            getObjectsProperties_thrift_result result = new getObjectsProperties_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, getObjectsProperties_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<List<ResultObject_thrift>> resultHandler) throws TException {
        iface.getObjectsProperties_thrift(args.keyList,resultHandler);
      }
    }

    public static class updateNodePropertiesParallel_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, updateNodePropertiesParallel_thrift_args, List<ResultObject_thrift>> {
      public updateNodePropertiesParallel_thrift() {
        super("updateNodePropertiesParallel_thrift");
      }

      public updateNodePropertiesParallel_thrift_args getEmptyArgsInstance() {
        return new updateNodePropertiesParallel_thrift_args();
      }

      public AsyncMethodCallback<List<ResultObject_thrift>> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<List<ResultObject_thrift>>() { 
          public void onComplete(List<ResultObject_thrift> o) {
            updateNodePropertiesParallel_thrift_result result = new updateNodePropertiesParallel_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            updateNodePropertiesParallel_thrift_result result = new updateNodePropertiesParallel_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, updateNodePropertiesParallel_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<List<ResultObject_thrift>> resultHandler) throws TException {
        iface.updateNodePropertiesParallel_thrift(args.objList,resultHandler);
      }
    }

    public static class putObjects_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, putObjects_thrift_args, List<ResultObject_thrift>> {
      public putObjects_thrift() {
        super("putObjects_thrift");
      }

      public putObjects_thrift_args getEmptyArgsInstance() {
        return new putObjects_thrift_args();
      }

      public AsyncMethodCallback<List<ResultObject_thrift>> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<List<ResultObject_thrift>>() { 
          public void onComplete(List<ResultObject_thrift> o) {
            putObjects_thrift_result result = new putObjects_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            putObjects_thrift_result result = new putObjects_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, putObjects_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<List<ResultObject_thrift>> resultHandler) throws TException {
        iface.putObjects_thrift(args.nodeList,resultHandler);
      }
    }

    public static class getObjects_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, getObjects_thrift_args, List<ResultObject_thrift>> {
      public getObjects_thrift() {
        super("getObjects_thrift");
      }

      public getObjects_thrift_args getEmptyArgsInstance() {
        return new getObjects_thrift_args();
      }

      public AsyncMethodCallback<List<ResultObject_thrift>> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<List<ResultObject_thrift>>() { 
          public void onComplete(List<ResultObject_thrift> o) {
            getObjects_thrift_result result = new getObjects_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            getObjects_thrift_result result = new getObjects_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, getObjects_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<List<ResultObject_thrift>> resultHandler) throws TException {
        iface.getObjects_thrift(args.keyList,resultHandler);
      }
    }

    public static class getAllKeys_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, getAllKeys_thrift_args, List<String>> {
      public getAllKeys_thrift() {
        super("getAllKeys_thrift");
      }

      public getAllKeys_thrift_args getEmptyArgsInstance() {
        return new getAllKeys_thrift_args();
      }

      public AsyncMethodCallback<List<String>> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<List<String>>() { 
          public void onComplete(List<String> o) {
            getAllKeys_thrift_result result = new getAllKeys_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            getAllKeys_thrift_result result = new getAllKeys_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, getAllKeys_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<List<String>> resultHandler) throws TException {
        iface.getAllKeys_thrift(resultHandler);
      }
    }

    public static class relocate_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, relocate_thrift_args, ResultObject_thrift> {
      public relocate_thrift() {
        super("relocate_thrift");
      }

      public relocate_thrift_args getEmptyArgsInstance() {
        return new relocate_thrift_args();
      }

      public AsyncMethodCallback<ResultObject_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<ResultObject_thrift>() { 
          public void onComplete(ResultObject_thrift o) {
            relocate_thrift_result result = new relocate_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            relocate_thrift_result result = new relocate_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, relocate_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<ResultObject_thrift> resultHandler) throws TException {
        iface.relocate_thrift(args.nodeId, args.serverName,resultHandler);
      }
    }

    public static class locationChange_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, locationChange_thrift_args, Void> {
      public locationChange_thrift() {
        super("locationChange_thrift");
      }

      public locationChange_thrift_args getEmptyArgsInstance() {
        return new locationChange_thrift_args();
      }

      public AsyncMethodCallback<Void> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Void>() { 
          public void onComplete(Void o) {
          }
          public void onError(Exception e) {
          }
        };
      }

      protected boolean isOneway() {
        return true;
      }

      public void start(I iface, locationChange_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Void> resultHandler) throws TException {
        iface.locationChange_thrift(args.nodeId, args.serverName,resultHandler);
      }
    }

    public static class lock_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, lock_thrift_args, ResultObject_thrift> {
      public lock_thrift() {
        super("lock_thrift");
      }

      public lock_thrift_args getEmptyArgsInstance() {
        return new lock_thrift_args();
      }

      public AsyncMethodCallback<ResultObject_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<ResultObject_thrift>() { 
          public void onComplete(ResultObject_thrift o) {
            lock_thrift_result result = new lock_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            lock_thrift_result result = new lock_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, lock_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<ResultObject_thrift> resultHandler) throws TException {
        iface.lock_thrift(args.nodeId,resultHandler);
      }
    }

    public static class acquireLocks_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, acquireLocks_thrift_args, Integer> {
      public acquireLocks_thrift() {
        super("acquireLocks_thrift");
      }

      public acquireLocks_thrift_args getEmptyArgsInstance() {
        return new acquireLocks_thrift_args();
      }

      public AsyncMethodCallback<Integer> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Integer>() { 
          public void onComplete(Integer o) {
            acquireLocks_thrift_result result = new acquireLocks_thrift_result();
            result.success = o;
            result.setSuccessIsSet(true);
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            acquireLocks_thrift_result result = new acquireLocks_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, acquireLocks_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Integer> resultHandler) throws TException {
        iface.acquireLocks_thrift(args.lockRequests,resultHandler);
      }
    }

    public static class releaseLocks_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, releaseLocks_thrift_args, Void> {
      public releaseLocks_thrift() {
        super("releaseLocks_thrift");
      }

      public releaseLocks_thrift_args getEmptyArgsInstance() {
        return new releaseLocks_thrift_args();
      }

      public AsyncMethodCallback<Void> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Void>() { 
          public void onComplete(Void o) {
            releaseLocks_thrift_result result = new releaseLocks_thrift_result();
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            releaseLocks_thrift_result result = new releaseLocks_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, releaseLocks_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Void> resultHandler) throws TException {
        iface.releaseLocks_thrift(args.lockRequests,resultHandler);
      }
    }

    public static class commitChanges_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, commitChanges_thrift_args, Void> {
      public commitChanges_thrift() {
        super("commitChanges_thrift");
      }

      public commitChanges_thrift_args getEmptyArgsInstance() {
        return new commitChanges_thrift_args();
      }

      public AsyncMethodCallback<Void> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Void>() { 
          public void onComplete(Void o) {
            commitChanges_thrift_result result = new commitChanges_thrift_result();
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            commitChanges_thrift_result result = new commitChanges_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, commitChanges_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Void> resultHandler) throws TException {
        iface.commitChanges_thrift(args.writeNd, args.read,resultHandler);
      }
    }

  }

  public static class put_thrift_args implements org.apache.thrift.TBase<put_thrift_args, put_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<put_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("put_thrift_args");

    private static final org.apache.thrift.protocol.TField KEY_FIELD_DESC = new org.apache.thrift.protocol.TField("key", org.apache.thrift.protocol.TType.STRING, (short)1);
    private static final org.apache.thrift.protocol.TField VALUE_FIELD_DESC = new org.apache.thrift.protocol.TField("value", org.apache.thrift.protocol.TType.STRUCT, (short)2);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new put_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new put_thrift_argsTupleSchemeFactory());
    }

    public String key; // required
    public Node_thrift value; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      KEY((short)1, "key"),
      VALUE((short)2, "value");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // KEY
            return KEY;
          case 2: // VALUE
            return VALUE;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.KEY, new org.apache.thrift.meta_data.FieldMetaData("key", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
      tmpMap.put(_Fields.VALUE, new org.apache.thrift.meta_data.FieldMetaData("value", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, Node_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(put_thrift_args.class, metaDataMap);
    }

    public put_thrift_args() {
    }

    public put_thrift_args(
      String key,
      Node_thrift value)
    {
      this();
      this.key = key;
      this.value = value;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public put_thrift_args(put_thrift_args other) {
      if (other.isSetKey()) {
        this.key = other.key;
      }
      if (other.isSetValue()) {
        this.value = new Node_thrift(other.value);
      }
    }

    public put_thrift_args deepCopy() {
      return new put_thrift_args(this);
    }

    @Override
    public void clear() {
      this.key = null;
      this.value = null;
    }

    public String getKey() {
      return this.key;
    }

    public put_thrift_args setKey(String key) {
      this.key = key;
      return this;
    }

    public void unsetKey() {
      this.key = null;
    }

    /** Returns true if field key is set (has been assigned a value) and false otherwise */
    public boolean isSetKey() {
      return this.key != null;
    }

    public void setKeyIsSet(boolean value) {
      if (!value) {
        this.key = null;
      }
    }

    public Node_thrift getValue() {
      return this.value;
    }

    public put_thrift_args setValue(Node_thrift value) {
      this.value = value;
      return this;
    }

    public void unsetValue() {
      this.value = null;
    }

    /** Returns true if field value is set (has been assigned a value) and false otherwise */
    public boolean isSetValue() {
      return this.value != null;
    }

    public void setValueIsSet(boolean value) {
      if (!value) {
        this.value = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case KEY:
        if (value == null) {
          unsetKey();
        } else {
          setKey((String)value);
        }
        break;

      case VALUE:
        if (value == null) {
          unsetValue();
        } else {
          setValue((Node_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case KEY:
        return getKey();

      case VALUE:
        return getValue();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case KEY:
        return isSetKey();
      case VALUE:
        return isSetValue();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof put_thrift_args)
        return this.equals((put_thrift_args)that);
      return false;
    }

    public boolean equals(put_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_key = true && this.isSetKey();
      boolean that_present_key = true && that.isSetKey();
      if (this_present_key || that_present_key) {
        if (!(this_present_key && that_present_key))
          return false;
        if (!this.key.equals(that.key))
          return false;
      }

      boolean this_present_value = true && this.isSetValue();
      boolean that_present_value = true && that.isSetValue();
      if (this_present_value || that_present_value) {
        if (!(this_present_value && that_present_value))
          return false;
        if (!this.value.equals(that.value))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_key = true && (isSetKey());
      list.add(present_key);
      if (present_key)
        list.add(key);

      boolean present_value = true && (isSetValue());
      list.add(present_value);
      if (present_value)
        list.add(value);

      return list.hashCode();
    }

    @Override
    public int compareTo(put_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetKey()).compareTo(other.isSetKey());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetKey()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.key, other.key);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetValue()).compareTo(other.isSetValue());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetValue()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.value, other.value);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("put_thrift_args(");
      boolean first = true;

      sb.append("key:");
      if (this.key == null) {
        sb.append("null");
      } else {
        sb.append(this.key);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("value:");
      if (this.value == null) {
        sb.append("null");
      } else {
        sb.append(this.value);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (value != null) {
        value.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class put_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public put_thrift_argsStandardScheme getScheme() {
        return new put_thrift_argsStandardScheme();
      }
    }

    private static class put_thrift_argsStandardScheme extends StandardScheme<put_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, put_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // KEY
              if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
                struct.key = iprot.readString();
                struct.setKeyIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // VALUE
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.value = new Node_thrift();
                struct.value.read(iprot);
                struct.setValueIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, put_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.key != null) {
          oprot.writeFieldBegin(KEY_FIELD_DESC);
          oprot.writeString(struct.key);
          oprot.writeFieldEnd();
        }
        if (struct.value != null) {
          oprot.writeFieldBegin(VALUE_FIELD_DESC);
          struct.value.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class put_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public put_thrift_argsTupleScheme getScheme() {
        return new put_thrift_argsTupleScheme();
      }
    }

    private static class put_thrift_argsTupleScheme extends TupleScheme<put_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, put_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetKey()) {
          optionals.set(0);
        }
        if (struct.isSetValue()) {
          optionals.set(1);
        }
        oprot.writeBitSet(optionals, 2);
        if (struct.isSetKey()) {
          oprot.writeString(struct.key);
        }
        if (struct.isSetValue()) {
          struct.value.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, put_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(2);
        if (incoming.get(0)) {
          struct.key = iprot.readString();
          struct.setKeyIsSet(true);
        }
        if (incoming.get(1)) {
          struct.value = new Node_thrift();
          struct.value.read(iprot);
          struct.setValueIsSet(true);
        }
      }
    }

  }

  public static class put_thrift_result implements org.apache.thrift.TBase<put_thrift_result, put_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<put_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("put_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new put_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new put_thrift_resultTupleSchemeFactory());
    }

    public ResultObject_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(put_thrift_result.class, metaDataMap);
    }

    public put_thrift_result() {
    }

    public put_thrift_result(
      ResultObject_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public put_thrift_result(put_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new ResultObject_thrift(other.success);
      }
    }

    public put_thrift_result deepCopy() {
      return new put_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public ResultObject_thrift getSuccess() {
      return this.success;
    }

    public put_thrift_result setSuccess(ResultObject_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ResultObject_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof put_thrift_result)
        return this.equals((put_thrift_result)that);
      return false;
    }

    public boolean equals(put_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(put_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("put_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class put_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public put_thrift_resultStandardScheme getScheme() {
        return new put_thrift_resultStandardScheme();
      }
    }

    private static class put_thrift_resultStandardScheme extends StandardScheme<put_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, put_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new ResultObject_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, put_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class put_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public put_thrift_resultTupleScheme getScheme() {
        return new put_thrift_resultTupleScheme();
      }
    }

    private static class put_thrift_resultTupleScheme extends TupleScheme<put_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, put_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, put_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new ResultObject_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class get_thrift_args implements org.apache.thrift.TBase<get_thrift_args, get_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<get_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("get_thrift_args");

    private static final org.apache.thrift.protocol.TField KEY_FIELD_DESC = new org.apache.thrift.protocol.TField("key", org.apache.thrift.protocol.TType.STRING, (short)1);
    private static final org.apache.thrift.protocol.TField STORAGE_SYSTEM_THREAD_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("storageSystemThreadId", org.apache.thrift.protocol.TType.I64, (short)2);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new get_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new get_thrift_argsTupleSchemeFactory());
    }

    public String key; // required
    public long storageSystemThreadId; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      KEY((short)1, "key"),
      STORAGE_SYSTEM_THREAD_ID((short)2, "storageSystemThreadId");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // KEY
            return KEY;
          case 2: // STORAGE_SYSTEM_THREAD_ID
            return STORAGE_SYSTEM_THREAD_ID;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __STORAGESYSTEMTHREADID_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.KEY, new org.apache.thrift.meta_data.FieldMetaData("key", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
      tmpMap.put(_Fields.STORAGE_SYSTEM_THREAD_ID, new org.apache.thrift.meta_data.FieldMetaData("storageSystemThreadId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(get_thrift_args.class, metaDataMap);
    }

    public get_thrift_args() {
    }

    public get_thrift_args(
      String key,
      long storageSystemThreadId)
    {
      this();
      this.key = key;
      this.storageSystemThreadId = storageSystemThreadId;
      setStorageSystemThreadIdIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public get_thrift_args(get_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      if (other.isSetKey()) {
        this.key = other.key;
      }
      this.storageSystemThreadId = other.storageSystemThreadId;
    }

    public get_thrift_args deepCopy() {
      return new get_thrift_args(this);
    }

    @Override
    public void clear() {
      this.key = null;
      setStorageSystemThreadIdIsSet(false);
      this.storageSystemThreadId = 0;
    }

    public String getKey() {
      return this.key;
    }

    public get_thrift_args setKey(String key) {
      this.key = key;
      return this;
    }

    public void unsetKey() {
      this.key = null;
    }

    /** Returns true if field key is set (has been assigned a value) and false otherwise */
    public boolean isSetKey() {
      return this.key != null;
    }

    public void setKeyIsSet(boolean value) {
      if (!value) {
        this.key = null;
      }
    }

    public long getStorageSystemThreadId() {
      return this.storageSystemThreadId;
    }

    public get_thrift_args setStorageSystemThreadId(long storageSystemThreadId) {
      this.storageSystemThreadId = storageSystemThreadId;
      setStorageSystemThreadIdIsSet(true);
      return this;
    }

    public void unsetStorageSystemThreadId() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __STORAGESYSTEMTHREADID_ISSET_ID);
    }

    /** Returns true if field storageSystemThreadId is set (has been assigned a value) and false otherwise */
    public boolean isSetStorageSystemThreadId() {
      return EncodingUtils.testBit(__isset_bitfield, __STORAGESYSTEMTHREADID_ISSET_ID);
    }

    public void setStorageSystemThreadIdIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __STORAGESYSTEMTHREADID_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case KEY:
        if (value == null) {
          unsetKey();
        } else {
          setKey((String)value);
        }
        break;

      case STORAGE_SYSTEM_THREAD_ID:
        if (value == null) {
          unsetStorageSystemThreadId();
        } else {
          setStorageSystemThreadId((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case KEY:
        return getKey();

      case STORAGE_SYSTEM_THREAD_ID:
        return getStorageSystemThreadId();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case KEY:
        return isSetKey();
      case STORAGE_SYSTEM_THREAD_ID:
        return isSetStorageSystemThreadId();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof get_thrift_args)
        return this.equals((get_thrift_args)that);
      return false;
    }

    public boolean equals(get_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_key = true && this.isSetKey();
      boolean that_present_key = true && that.isSetKey();
      if (this_present_key || that_present_key) {
        if (!(this_present_key && that_present_key))
          return false;
        if (!this.key.equals(that.key))
          return false;
      }

      boolean this_present_storageSystemThreadId = true;
      boolean that_present_storageSystemThreadId = true;
      if (this_present_storageSystemThreadId || that_present_storageSystemThreadId) {
        if (!(this_present_storageSystemThreadId && that_present_storageSystemThreadId))
          return false;
        if (this.storageSystemThreadId != that.storageSystemThreadId)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_key = true && (isSetKey());
      list.add(present_key);
      if (present_key)
        list.add(key);

      boolean present_storageSystemThreadId = true;
      list.add(present_storageSystemThreadId);
      if (present_storageSystemThreadId)
        list.add(storageSystemThreadId);

      return list.hashCode();
    }

    @Override
    public int compareTo(get_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetKey()).compareTo(other.isSetKey());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetKey()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.key, other.key);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetStorageSystemThreadId()).compareTo(other.isSetStorageSystemThreadId());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetStorageSystemThreadId()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.storageSystemThreadId, other.storageSystemThreadId);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("get_thrift_args(");
      boolean first = true;

      sb.append("key:");
      if (this.key == null) {
        sb.append("null");
      } else {
        sb.append(this.key);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("storageSystemThreadId:");
      sb.append(this.storageSystemThreadId);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class get_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public get_thrift_argsStandardScheme getScheme() {
        return new get_thrift_argsStandardScheme();
      }
    }

    private static class get_thrift_argsStandardScheme extends StandardScheme<get_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, get_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // KEY
              if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
                struct.key = iprot.readString();
                struct.setKeyIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // STORAGE_SYSTEM_THREAD_ID
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.storageSystemThreadId = iprot.readI64();
                struct.setStorageSystemThreadIdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, get_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.key != null) {
          oprot.writeFieldBegin(KEY_FIELD_DESC);
          oprot.writeString(struct.key);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldBegin(STORAGE_SYSTEM_THREAD_ID_FIELD_DESC);
        oprot.writeI64(struct.storageSystemThreadId);
        oprot.writeFieldEnd();
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class get_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public get_thrift_argsTupleScheme getScheme() {
        return new get_thrift_argsTupleScheme();
      }
    }

    private static class get_thrift_argsTupleScheme extends TupleScheme<get_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, get_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetKey()) {
          optionals.set(0);
        }
        if (struct.isSetStorageSystemThreadId()) {
          optionals.set(1);
        }
        oprot.writeBitSet(optionals, 2);
        if (struct.isSetKey()) {
          oprot.writeString(struct.key);
        }
        if (struct.isSetStorageSystemThreadId()) {
          oprot.writeI64(struct.storageSystemThreadId);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, get_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(2);
        if (incoming.get(0)) {
          struct.key = iprot.readString();
          struct.setKeyIsSet(true);
        }
        if (incoming.get(1)) {
          struct.storageSystemThreadId = iprot.readI64();
          struct.setStorageSystemThreadIdIsSet(true);
        }
      }
    }

  }

  public static class get_thrift_result implements org.apache.thrift.TBase<get_thrift_result, get_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<get_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("get_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new get_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new get_thrift_resultTupleSchemeFactory());
    }

    public ResultObject_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(get_thrift_result.class, metaDataMap);
    }

    public get_thrift_result() {
    }

    public get_thrift_result(
      ResultObject_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public get_thrift_result(get_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new ResultObject_thrift(other.success);
      }
    }

    public get_thrift_result deepCopy() {
      return new get_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public ResultObject_thrift getSuccess() {
      return this.success;
    }

    public get_thrift_result setSuccess(ResultObject_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ResultObject_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof get_thrift_result)
        return this.equals((get_thrift_result)that);
      return false;
    }

    public boolean equals(get_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(get_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("get_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class get_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public get_thrift_resultStandardScheme getScheme() {
        return new get_thrift_resultStandardScheme();
      }
    }

    private static class get_thrift_resultStandardScheme extends StandardScheme<get_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, get_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new ResultObject_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, get_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class get_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public get_thrift_resultTupleScheme getScheme() {
        return new get_thrift_resultTupleScheme();
      }
    }

    private static class get_thrift_resultTupleScheme extends TupleScheme<get_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, get_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, get_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new ResultObject_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class getNodeProperties_thrift_args implements org.apache.thrift.TBase<getNodeProperties_thrift_args, getNodeProperties_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<getNodeProperties_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getNodeProperties_thrift_args");

    private static final org.apache.thrift.protocol.TField N_FIELD_DESC = new org.apache.thrift.protocol.TField("n", org.apache.thrift.protocol.TType.STRUCT, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getNodeProperties_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getNodeProperties_thrift_argsTupleSchemeFactory());
    }

    public NodeData_thrift n; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      N((short)1, "n");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // N
            return N;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.N, new org.apache.thrift.meta_data.FieldMetaData("n", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, NodeData_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getNodeProperties_thrift_args.class, metaDataMap);
    }

    public getNodeProperties_thrift_args() {
    }

    public getNodeProperties_thrift_args(
      NodeData_thrift n)
    {
      this();
      this.n = n;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodeProperties_thrift_args(getNodeProperties_thrift_args other) {
      if (other.isSetN()) {
        this.n = new NodeData_thrift(other.n);
      }
    }

    public getNodeProperties_thrift_args deepCopy() {
      return new getNodeProperties_thrift_args(this);
    }

    @Override
    public void clear() {
      this.n = null;
    }

    public NodeData_thrift getN() {
      return this.n;
    }

    public getNodeProperties_thrift_args setN(NodeData_thrift n) {
      this.n = n;
      return this;
    }

    public void unsetN() {
      this.n = null;
    }

    /** Returns true if field n is set (has been assigned a value) and false otherwise */
    public boolean isSetN() {
      return this.n != null;
    }

    public void setNIsSet(boolean value) {
      if (!value) {
        this.n = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case N:
        if (value == null) {
          unsetN();
        } else {
          setN((NodeData_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case N:
        return getN();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case N:
        return isSetN();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodeProperties_thrift_args)
        return this.equals((getNodeProperties_thrift_args)that);
      return false;
    }

    public boolean equals(getNodeProperties_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_n = true && this.isSetN();
      boolean that_present_n = true && that.isSetN();
      if (this_present_n || that_present_n) {
        if (!(this_present_n && that_present_n))
          return false;
        if (!this.n.equals(that.n))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_n = true && (isSetN());
      list.add(present_n);
      if (present_n)
        list.add(n);

      return list.hashCode();
    }

    @Override
    public int compareTo(getNodeProperties_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetN()).compareTo(other.isSetN());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetN()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.n, other.n);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodeProperties_thrift_args(");
      boolean first = true;

      sb.append("n:");
      if (this.n == null) {
        sb.append("null");
      } else {
        sb.append(this.n);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (n != null) {
        n.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getNodeProperties_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public getNodeProperties_thrift_argsStandardScheme getScheme() {
        return new getNodeProperties_thrift_argsStandardScheme();
      }
    }

    private static class getNodeProperties_thrift_argsStandardScheme extends StandardScheme<getNodeProperties_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // N
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.n = new NodeData_thrift();
                struct.n.read(iprot);
                struct.setNIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.n != null) {
          oprot.writeFieldBegin(N_FIELD_DESC);
          struct.n.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getNodeProperties_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public getNodeProperties_thrift_argsTupleScheme getScheme() {
        return new getNodeProperties_thrift_argsTupleScheme();
      }
    }

    private static class getNodeProperties_thrift_argsTupleScheme extends TupleScheme<getNodeProperties_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetN()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetN()) {
          struct.n.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.n = new NodeData_thrift();
          struct.n.read(iprot);
          struct.setNIsSet(true);
        }
      }
    }

  }

  public static class getNodeProperties_thrift_result implements org.apache.thrift.TBase<getNodeProperties_thrift_result, getNodeProperties_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<getNodeProperties_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getNodeProperties_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getNodeProperties_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getNodeProperties_thrift_resultTupleSchemeFactory());
    }

    public ResultObject_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getNodeProperties_thrift_result.class, metaDataMap);
    }

    public getNodeProperties_thrift_result() {
    }

    public getNodeProperties_thrift_result(
      ResultObject_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodeProperties_thrift_result(getNodeProperties_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new ResultObject_thrift(other.success);
      }
    }

    public getNodeProperties_thrift_result deepCopy() {
      return new getNodeProperties_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public ResultObject_thrift getSuccess() {
      return this.success;
    }

    public getNodeProperties_thrift_result setSuccess(ResultObject_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ResultObject_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodeProperties_thrift_result)
        return this.equals((getNodeProperties_thrift_result)that);
      return false;
    }

    public boolean equals(getNodeProperties_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(getNodeProperties_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodeProperties_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getNodeProperties_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public getNodeProperties_thrift_resultStandardScheme getScheme() {
        return new getNodeProperties_thrift_resultStandardScheme();
      }
    }

    private static class getNodeProperties_thrift_resultStandardScheme extends StandardScheme<getNodeProperties_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new ResultObject_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getNodeProperties_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public getNodeProperties_thrift_resultTupleScheme getScheme() {
        return new getNodeProperties_thrift_resultTupleScheme();
      }
    }

    private static class getNodeProperties_thrift_resultTupleScheme extends TupleScheme<getNodeProperties_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new ResultObject_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class updateNodeProperties_thrift_args implements org.apache.thrift.TBase<updateNodeProperties_thrift_args, updateNodeProperties_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<updateNodeProperties_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("updateNodeProperties_thrift_args");

    private static final org.apache.thrift.protocol.TField N_FIELD_DESC = new org.apache.thrift.protocol.TField("n", org.apache.thrift.protocol.TType.STRUCT, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new updateNodeProperties_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new updateNodeProperties_thrift_argsTupleSchemeFactory());
    }

    public NodeData_thrift n; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      N((short)1, "n");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // N
            return N;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.N, new org.apache.thrift.meta_data.FieldMetaData("n", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, NodeData_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(updateNodeProperties_thrift_args.class, metaDataMap);
    }

    public updateNodeProperties_thrift_args() {
    }

    public updateNodeProperties_thrift_args(
      NodeData_thrift n)
    {
      this();
      this.n = n;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public updateNodeProperties_thrift_args(updateNodeProperties_thrift_args other) {
      if (other.isSetN()) {
        this.n = new NodeData_thrift(other.n);
      }
    }

    public updateNodeProperties_thrift_args deepCopy() {
      return new updateNodeProperties_thrift_args(this);
    }

    @Override
    public void clear() {
      this.n = null;
    }

    public NodeData_thrift getN() {
      return this.n;
    }

    public updateNodeProperties_thrift_args setN(NodeData_thrift n) {
      this.n = n;
      return this;
    }

    public void unsetN() {
      this.n = null;
    }

    /** Returns true if field n is set (has been assigned a value) and false otherwise */
    public boolean isSetN() {
      return this.n != null;
    }

    public void setNIsSet(boolean value) {
      if (!value) {
        this.n = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case N:
        if (value == null) {
          unsetN();
        } else {
          setN((NodeData_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case N:
        return getN();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case N:
        return isSetN();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof updateNodeProperties_thrift_args)
        return this.equals((updateNodeProperties_thrift_args)that);
      return false;
    }

    public boolean equals(updateNodeProperties_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_n = true && this.isSetN();
      boolean that_present_n = true && that.isSetN();
      if (this_present_n || that_present_n) {
        if (!(this_present_n && that_present_n))
          return false;
        if (!this.n.equals(that.n))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_n = true && (isSetN());
      list.add(present_n);
      if (present_n)
        list.add(n);

      return list.hashCode();
    }

    @Override
    public int compareTo(updateNodeProperties_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetN()).compareTo(other.isSetN());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetN()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.n, other.n);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("updateNodeProperties_thrift_args(");
      boolean first = true;

      sb.append("n:");
      if (this.n == null) {
        sb.append("null");
      } else {
        sb.append(this.n);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (n != null) {
        n.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class updateNodeProperties_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public updateNodeProperties_thrift_argsStandardScheme getScheme() {
        return new updateNodeProperties_thrift_argsStandardScheme();
      }
    }

    private static class updateNodeProperties_thrift_argsStandardScheme extends StandardScheme<updateNodeProperties_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, updateNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // N
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.n = new NodeData_thrift();
                struct.n.read(iprot);
                struct.setNIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, updateNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.n != null) {
          oprot.writeFieldBegin(N_FIELD_DESC);
          struct.n.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class updateNodeProperties_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public updateNodeProperties_thrift_argsTupleScheme getScheme() {
        return new updateNodeProperties_thrift_argsTupleScheme();
      }
    }

    private static class updateNodeProperties_thrift_argsTupleScheme extends TupleScheme<updateNodeProperties_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, updateNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetN()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetN()) {
          struct.n.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, updateNodeProperties_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.n = new NodeData_thrift();
          struct.n.read(iprot);
          struct.setNIsSet(true);
        }
      }
    }

  }

  public static class updateNodeProperties_thrift_result implements org.apache.thrift.TBase<updateNodeProperties_thrift_result, updateNodeProperties_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<updateNodeProperties_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("updateNodeProperties_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new updateNodeProperties_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new updateNodeProperties_thrift_resultTupleSchemeFactory());
    }

    public ResultObject_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(updateNodeProperties_thrift_result.class, metaDataMap);
    }

    public updateNodeProperties_thrift_result() {
    }

    public updateNodeProperties_thrift_result(
      ResultObject_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public updateNodeProperties_thrift_result(updateNodeProperties_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new ResultObject_thrift(other.success);
      }
    }

    public updateNodeProperties_thrift_result deepCopy() {
      return new updateNodeProperties_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public ResultObject_thrift getSuccess() {
      return this.success;
    }

    public updateNodeProperties_thrift_result setSuccess(ResultObject_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ResultObject_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof updateNodeProperties_thrift_result)
        return this.equals((updateNodeProperties_thrift_result)that);
      return false;
    }

    public boolean equals(updateNodeProperties_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(updateNodeProperties_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("updateNodeProperties_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class updateNodeProperties_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public updateNodeProperties_thrift_resultStandardScheme getScheme() {
        return new updateNodeProperties_thrift_resultStandardScheme();
      }
    }

    private static class updateNodeProperties_thrift_resultStandardScheme extends StandardScheme<updateNodeProperties_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, updateNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new ResultObject_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, updateNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class updateNodeProperties_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public updateNodeProperties_thrift_resultTupleScheme getScheme() {
        return new updateNodeProperties_thrift_resultTupleScheme();
      }
    }

    private static class updateNodeProperties_thrift_resultTupleScheme extends TupleScheme<updateNodeProperties_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, updateNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, updateNodeProperties_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new ResultObject_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class getObjectsProperties_thrift_args implements org.apache.thrift.TBase<getObjectsProperties_thrift_args, getObjectsProperties_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<getObjectsProperties_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getObjectsProperties_thrift_args");

    private static final org.apache.thrift.protocol.TField KEY_LIST_FIELD_DESC = new org.apache.thrift.protocol.TField("keyList", org.apache.thrift.protocol.TType.LIST, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getObjectsProperties_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getObjectsProperties_thrift_argsTupleSchemeFactory());
    }

    public List<NodeData_thrift> keyList; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      KEY_LIST((short)1, "keyList");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // KEY_LIST
            return KEY_LIST;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.KEY_LIST, new org.apache.thrift.meta_data.FieldMetaData("keyList", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, NodeData_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getObjectsProperties_thrift_args.class, metaDataMap);
    }

    public getObjectsProperties_thrift_args() {
    }

    public getObjectsProperties_thrift_args(
      List<NodeData_thrift> keyList)
    {
      this();
      this.keyList = keyList;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getObjectsProperties_thrift_args(getObjectsProperties_thrift_args other) {
      if (other.isSetKeyList()) {
        List<NodeData_thrift> __this__keyList = new ArrayList<NodeData_thrift>(other.keyList.size());
        for (NodeData_thrift other_element : other.keyList) {
          __this__keyList.add(new NodeData_thrift(other_element));
        }
        this.keyList = __this__keyList;
      }
    }

    public getObjectsProperties_thrift_args deepCopy() {
      return new getObjectsProperties_thrift_args(this);
    }

    @Override
    public void clear() {
      this.keyList = null;
    }

    public int getKeyListSize() {
      return (this.keyList == null) ? 0 : this.keyList.size();
    }

    public java.util.Iterator<NodeData_thrift> getKeyListIterator() {
      return (this.keyList == null) ? null : this.keyList.iterator();
    }

    public void addToKeyList(NodeData_thrift elem) {
      if (this.keyList == null) {
        this.keyList = new ArrayList<NodeData_thrift>();
      }
      this.keyList.add(elem);
    }

    public List<NodeData_thrift> getKeyList() {
      return this.keyList;
    }

    public getObjectsProperties_thrift_args setKeyList(List<NodeData_thrift> keyList) {
      this.keyList = keyList;
      return this;
    }

    public void unsetKeyList() {
      this.keyList = null;
    }

    /** Returns true if field keyList is set (has been assigned a value) and false otherwise */
    public boolean isSetKeyList() {
      return this.keyList != null;
    }

    public void setKeyListIsSet(boolean value) {
      if (!value) {
        this.keyList = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case KEY_LIST:
        if (value == null) {
          unsetKeyList();
        } else {
          setKeyList((List<NodeData_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case KEY_LIST:
        return getKeyList();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case KEY_LIST:
        return isSetKeyList();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getObjectsProperties_thrift_args)
        return this.equals((getObjectsProperties_thrift_args)that);
      return false;
    }

    public boolean equals(getObjectsProperties_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_keyList = true && this.isSetKeyList();
      boolean that_present_keyList = true && that.isSetKeyList();
      if (this_present_keyList || that_present_keyList) {
        if (!(this_present_keyList && that_present_keyList))
          return false;
        if (!this.keyList.equals(that.keyList))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_keyList = true && (isSetKeyList());
      list.add(present_keyList);
      if (present_keyList)
        list.add(keyList);

      return list.hashCode();
    }

    @Override
    public int compareTo(getObjectsProperties_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetKeyList()).compareTo(other.isSetKeyList());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetKeyList()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.keyList, other.keyList);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getObjectsProperties_thrift_args(");
      boolean first = true;

      sb.append("keyList:");
      if (this.keyList == null) {
        sb.append("null");
      } else {
        sb.append(this.keyList);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getObjectsProperties_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public getObjectsProperties_thrift_argsStandardScheme getScheme() {
        return new getObjectsProperties_thrift_argsStandardScheme();
      }
    }

    private static class getObjectsProperties_thrift_argsStandardScheme extends StandardScheme<getObjectsProperties_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getObjectsProperties_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // KEY_LIST
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list20 = iprot.readListBegin();
                  struct.keyList = new ArrayList<NodeData_thrift>(_list20.size);
                  NodeData_thrift _elem21;
                  for (int _i22 = 0; _i22 < _list20.size; ++_i22)
                  {
                    _elem21 = new NodeData_thrift();
                    _elem21.read(iprot);
                    struct.keyList.add(_elem21);
                  }
                  iprot.readListEnd();
                }
                struct.setKeyListIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getObjectsProperties_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.keyList != null) {
          oprot.writeFieldBegin(KEY_LIST_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.keyList.size()));
            for (NodeData_thrift _iter23 : struct.keyList)
            {
              _iter23.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getObjectsProperties_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public getObjectsProperties_thrift_argsTupleScheme getScheme() {
        return new getObjectsProperties_thrift_argsTupleScheme();
      }
    }

    private static class getObjectsProperties_thrift_argsTupleScheme extends TupleScheme<getObjectsProperties_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getObjectsProperties_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetKeyList()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetKeyList()) {
          {
            oprot.writeI32(struct.keyList.size());
            for (NodeData_thrift _iter24 : struct.keyList)
            {
              _iter24.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getObjectsProperties_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list25 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.keyList = new ArrayList<NodeData_thrift>(_list25.size);
            NodeData_thrift _elem26;
            for (int _i27 = 0; _i27 < _list25.size; ++_i27)
            {
              _elem26 = new NodeData_thrift();
              _elem26.read(iprot);
              struct.keyList.add(_elem26);
            }
          }
          struct.setKeyListIsSet(true);
        }
      }
    }

  }

  public static class getObjectsProperties_thrift_result implements org.apache.thrift.TBase<getObjectsProperties_thrift_result, getObjectsProperties_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<getObjectsProperties_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getObjectsProperties_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.LIST, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getObjectsProperties_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getObjectsProperties_thrift_resultTupleSchemeFactory());
    }

    public List<ResultObject_thrift> success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getObjectsProperties_thrift_result.class, metaDataMap);
    }

    public getObjectsProperties_thrift_result() {
    }

    public getObjectsProperties_thrift_result(
      List<ResultObject_thrift> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getObjectsProperties_thrift_result(getObjectsProperties_thrift_result other) {
      if (other.isSetSuccess()) {
        List<ResultObject_thrift> __this__success = new ArrayList<ResultObject_thrift>(other.success.size());
        for (ResultObject_thrift other_element : other.success) {
          __this__success.add(new ResultObject_thrift(other_element));
        }
        this.success = __this__success;
      }
    }

    public getObjectsProperties_thrift_result deepCopy() {
      return new getObjectsProperties_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<ResultObject_thrift> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(ResultObject_thrift elem) {
      if (this.success == null) {
        this.success = new ArrayList<ResultObject_thrift>();
      }
      this.success.add(elem);
    }

    public List<ResultObject_thrift> getSuccess() {
      return this.success;
    }

    public getObjectsProperties_thrift_result setSuccess(List<ResultObject_thrift> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<ResultObject_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getObjectsProperties_thrift_result)
        return this.equals((getObjectsProperties_thrift_result)that);
      return false;
    }

    public boolean equals(getObjectsProperties_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(getObjectsProperties_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getObjectsProperties_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getObjectsProperties_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public getObjectsProperties_thrift_resultStandardScheme getScheme() {
        return new getObjectsProperties_thrift_resultStandardScheme();
      }
    }

    private static class getObjectsProperties_thrift_resultStandardScheme extends StandardScheme<getObjectsProperties_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getObjectsProperties_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list28 = iprot.readListBegin();
                  struct.success = new ArrayList<ResultObject_thrift>(_list28.size);
                  ResultObject_thrift _elem29;
                  for (int _i30 = 0; _i30 < _list28.size; ++_i30)
                  {
                    _elem29 = new ResultObject_thrift();
                    _elem29.read(iprot);
                    struct.success.add(_elem29);
                  }
                  iprot.readListEnd();
                }
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getObjectsProperties_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.success.size()));
            for (ResultObject_thrift _iter31 : struct.success)
            {
              _iter31.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getObjectsProperties_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public getObjectsProperties_thrift_resultTupleScheme getScheme() {
        return new getObjectsProperties_thrift_resultTupleScheme();
      }
    }

    private static class getObjectsProperties_thrift_resultTupleScheme extends TupleScheme<getObjectsProperties_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getObjectsProperties_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          {
            oprot.writeI32(struct.success.size());
            for (ResultObject_thrift _iter32 : struct.success)
            {
              _iter32.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getObjectsProperties_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list33 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.success = new ArrayList<ResultObject_thrift>(_list33.size);
            ResultObject_thrift _elem34;
            for (int _i35 = 0; _i35 < _list33.size; ++_i35)
            {
              _elem34 = new ResultObject_thrift();
              _elem34.read(iprot);
              struct.success.add(_elem34);
            }
          }
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class updateNodePropertiesParallel_thrift_args implements org.apache.thrift.TBase<updateNodePropertiesParallel_thrift_args, updateNodePropertiesParallel_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<updateNodePropertiesParallel_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("updateNodePropertiesParallel_thrift_args");

    private static final org.apache.thrift.protocol.TField OBJ_LIST_FIELD_DESC = new org.apache.thrift.protocol.TField("objList", org.apache.thrift.protocol.TType.LIST, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new updateNodePropertiesParallel_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new updateNodePropertiesParallel_thrift_argsTupleSchemeFactory());
    }

    public List<NodeData_thrift> objList; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      OBJ_LIST((short)1, "objList");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // OBJ_LIST
            return OBJ_LIST;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.OBJ_LIST, new org.apache.thrift.meta_data.FieldMetaData("objList", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, NodeData_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(updateNodePropertiesParallel_thrift_args.class, metaDataMap);
    }

    public updateNodePropertiesParallel_thrift_args() {
    }

    public updateNodePropertiesParallel_thrift_args(
      List<NodeData_thrift> objList)
    {
      this();
      this.objList = objList;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public updateNodePropertiesParallel_thrift_args(updateNodePropertiesParallel_thrift_args other) {
      if (other.isSetObjList()) {
        List<NodeData_thrift> __this__objList = new ArrayList<NodeData_thrift>(other.objList.size());
        for (NodeData_thrift other_element : other.objList) {
          __this__objList.add(new NodeData_thrift(other_element));
        }
        this.objList = __this__objList;
      }
    }

    public updateNodePropertiesParallel_thrift_args deepCopy() {
      return new updateNodePropertiesParallel_thrift_args(this);
    }

    @Override
    public void clear() {
      this.objList = null;
    }

    public int getObjListSize() {
      return (this.objList == null) ? 0 : this.objList.size();
    }

    public java.util.Iterator<NodeData_thrift> getObjListIterator() {
      return (this.objList == null) ? null : this.objList.iterator();
    }

    public void addToObjList(NodeData_thrift elem) {
      if (this.objList == null) {
        this.objList = new ArrayList<NodeData_thrift>();
      }
      this.objList.add(elem);
    }

    public List<NodeData_thrift> getObjList() {
      return this.objList;
    }

    public updateNodePropertiesParallel_thrift_args setObjList(List<NodeData_thrift> objList) {
      this.objList = objList;
      return this;
    }

    public void unsetObjList() {
      this.objList = null;
    }

    /** Returns true if field objList is set (has been assigned a value) and false otherwise */
    public boolean isSetObjList() {
      return this.objList != null;
    }

    public void setObjListIsSet(boolean value) {
      if (!value) {
        this.objList = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case OBJ_LIST:
        if (value == null) {
          unsetObjList();
        } else {
          setObjList((List<NodeData_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case OBJ_LIST:
        return getObjList();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case OBJ_LIST:
        return isSetObjList();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof updateNodePropertiesParallel_thrift_args)
        return this.equals((updateNodePropertiesParallel_thrift_args)that);
      return false;
    }

    public boolean equals(updateNodePropertiesParallel_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_objList = true && this.isSetObjList();
      boolean that_present_objList = true && that.isSetObjList();
      if (this_present_objList || that_present_objList) {
        if (!(this_present_objList && that_present_objList))
          return false;
        if (!this.objList.equals(that.objList))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_objList = true && (isSetObjList());
      list.add(present_objList);
      if (present_objList)
        list.add(objList);

      return list.hashCode();
    }

    @Override
    public int compareTo(updateNodePropertiesParallel_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetObjList()).compareTo(other.isSetObjList());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetObjList()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.objList, other.objList);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("updateNodePropertiesParallel_thrift_args(");
      boolean first = true;

      sb.append("objList:");
      if (this.objList == null) {
        sb.append("null");
      } else {
        sb.append(this.objList);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class updateNodePropertiesParallel_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public updateNodePropertiesParallel_thrift_argsStandardScheme getScheme() {
        return new updateNodePropertiesParallel_thrift_argsStandardScheme();
      }
    }

    private static class updateNodePropertiesParallel_thrift_argsStandardScheme extends StandardScheme<updateNodePropertiesParallel_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, updateNodePropertiesParallel_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // OBJ_LIST
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list36 = iprot.readListBegin();
                  struct.objList = new ArrayList<NodeData_thrift>(_list36.size);
                  NodeData_thrift _elem37;
                  for (int _i38 = 0; _i38 < _list36.size; ++_i38)
                  {
                    _elem37 = new NodeData_thrift();
                    _elem37.read(iprot);
                    struct.objList.add(_elem37);
                  }
                  iprot.readListEnd();
                }
                struct.setObjListIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, updateNodePropertiesParallel_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.objList != null) {
          oprot.writeFieldBegin(OBJ_LIST_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.objList.size()));
            for (NodeData_thrift _iter39 : struct.objList)
            {
              _iter39.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class updateNodePropertiesParallel_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public updateNodePropertiesParallel_thrift_argsTupleScheme getScheme() {
        return new updateNodePropertiesParallel_thrift_argsTupleScheme();
      }
    }

    private static class updateNodePropertiesParallel_thrift_argsTupleScheme extends TupleScheme<updateNodePropertiesParallel_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, updateNodePropertiesParallel_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetObjList()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetObjList()) {
          {
            oprot.writeI32(struct.objList.size());
            for (NodeData_thrift _iter40 : struct.objList)
            {
              _iter40.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, updateNodePropertiesParallel_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list41 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.objList = new ArrayList<NodeData_thrift>(_list41.size);
            NodeData_thrift _elem42;
            for (int _i43 = 0; _i43 < _list41.size; ++_i43)
            {
              _elem42 = new NodeData_thrift();
              _elem42.read(iprot);
              struct.objList.add(_elem42);
            }
          }
          struct.setObjListIsSet(true);
        }
      }
    }

  }

  public static class updateNodePropertiesParallel_thrift_result implements org.apache.thrift.TBase<updateNodePropertiesParallel_thrift_result, updateNodePropertiesParallel_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<updateNodePropertiesParallel_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("updateNodePropertiesParallel_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.LIST, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new updateNodePropertiesParallel_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new updateNodePropertiesParallel_thrift_resultTupleSchemeFactory());
    }

    public List<ResultObject_thrift> success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(updateNodePropertiesParallel_thrift_result.class, metaDataMap);
    }

    public updateNodePropertiesParallel_thrift_result() {
    }

    public updateNodePropertiesParallel_thrift_result(
      List<ResultObject_thrift> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public updateNodePropertiesParallel_thrift_result(updateNodePropertiesParallel_thrift_result other) {
      if (other.isSetSuccess()) {
        List<ResultObject_thrift> __this__success = new ArrayList<ResultObject_thrift>(other.success.size());
        for (ResultObject_thrift other_element : other.success) {
          __this__success.add(new ResultObject_thrift(other_element));
        }
        this.success = __this__success;
      }
    }

    public updateNodePropertiesParallel_thrift_result deepCopy() {
      return new updateNodePropertiesParallel_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<ResultObject_thrift> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(ResultObject_thrift elem) {
      if (this.success == null) {
        this.success = new ArrayList<ResultObject_thrift>();
      }
      this.success.add(elem);
    }

    public List<ResultObject_thrift> getSuccess() {
      return this.success;
    }

    public updateNodePropertiesParallel_thrift_result setSuccess(List<ResultObject_thrift> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<ResultObject_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof updateNodePropertiesParallel_thrift_result)
        return this.equals((updateNodePropertiesParallel_thrift_result)that);
      return false;
    }

    public boolean equals(updateNodePropertiesParallel_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(updateNodePropertiesParallel_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("updateNodePropertiesParallel_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class updateNodePropertiesParallel_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public updateNodePropertiesParallel_thrift_resultStandardScheme getScheme() {
        return new updateNodePropertiesParallel_thrift_resultStandardScheme();
      }
    }

    private static class updateNodePropertiesParallel_thrift_resultStandardScheme extends StandardScheme<updateNodePropertiesParallel_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, updateNodePropertiesParallel_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list44 = iprot.readListBegin();
                  struct.success = new ArrayList<ResultObject_thrift>(_list44.size);
                  ResultObject_thrift _elem45;
                  for (int _i46 = 0; _i46 < _list44.size; ++_i46)
                  {
                    _elem45 = new ResultObject_thrift();
                    _elem45.read(iprot);
                    struct.success.add(_elem45);
                  }
                  iprot.readListEnd();
                }
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, updateNodePropertiesParallel_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.success.size()));
            for (ResultObject_thrift _iter47 : struct.success)
            {
              _iter47.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class updateNodePropertiesParallel_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public updateNodePropertiesParallel_thrift_resultTupleScheme getScheme() {
        return new updateNodePropertiesParallel_thrift_resultTupleScheme();
      }
    }

    private static class updateNodePropertiesParallel_thrift_resultTupleScheme extends TupleScheme<updateNodePropertiesParallel_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, updateNodePropertiesParallel_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          {
            oprot.writeI32(struct.success.size());
            for (ResultObject_thrift _iter48 : struct.success)
            {
              _iter48.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, updateNodePropertiesParallel_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list49 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.success = new ArrayList<ResultObject_thrift>(_list49.size);
            ResultObject_thrift _elem50;
            for (int _i51 = 0; _i51 < _list49.size; ++_i51)
            {
              _elem50 = new ResultObject_thrift();
              _elem50.read(iprot);
              struct.success.add(_elem50);
            }
          }
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class putObjects_thrift_args implements org.apache.thrift.TBase<putObjects_thrift_args, putObjects_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<putObjects_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("putObjects_thrift_args");

    private static final org.apache.thrift.protocol.TField NODE_LIST_FIELD_DESC = new org.apache.thrift.protocol.TField("nodeList", org.apache.thrift.protocol.TType.MAP, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new putObjects_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new putObjects_thrift_argsTupleSchemeFactory());
    }

    public Map<String,Node_thrift> nodeList; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      NODE_LIST((short)1, "nodeList");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // NODE_LIST
            return NODE_LIST;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.NODE_LIST, new org.apache.thrift.meta_data.FieldMetaData("nodeList", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.MapMetaData(org.apache.thrift.protocol.TType.MAP, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING), 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, Node_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(putObjects_thrift_args.class, metaDataMap);
    }

    public putObjects_thrift_args() {
    }

    public putObjects_thrift_args(
      Map<String,Node_thrift> nodeList)
    {
      this();
      this.nodeList = nodeList;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public putObjects_thrift_args(putObjects_thrift_args other) {
      if (other.isSetNodeList()) {
        Map<String,Node_thrift> __this__nodeList = new HashMap<String,Node_thrift>(other.nodeList.size());
        for (Map.Entry<String, Node_thrift> other_element : other.nodeList.entrySet()) {

          String other_element_key = other_element.getKey();
          Node_thrift other_element_value = other_element.getValue();

          String __this__nodeList_copy_key = other_element_key;

          Node_thrift __this__nodeList_copy_value = new Node_thrift(other_element_value);

          __this__nodeList.put(__this__nodeList_copy_key, __this__nodeList_copy_value);
        }
        this.nodeList = __this__nodeList;
      }
    }

    public putObjects_thrift_args deepCopy() {
      return new putObjects_thrift_args(this);
    }

    @Override
    public void clear() {
      this.nodeList = null;
    }

    public int getNodeListSize() {
      return (this.nodeList == null) ? 0 : this.nodeList.size();
    }

    public void putToNodeList(String key, Node_thrift val) {
      if (this.nodeList == null) {
        this.nodeList = new HashMap<String,Node_thrift>();
      }
      this.nodeList.put(key, val);
    }

    public Map<String,Node_thrift> getNodeList() {
      return this.nodeList;
    }

    public putObjects_thrift_args setNodeList(Map<String,Node_thrift> nodeList) {
      this.nodeList = nodeList;
      return this;
    }

    public void unsetNodeList() {
      this.nodeList = null;
    }

    /** Returns true if field nodeList is set (has been assigned a value) and false otherwise */
    public boolean isSetNodeList() {
      return this.nodeList != null;
    }

    public void setNodeListIsSet(boolean value) {
      if (!value) {
        this.nodeList = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case NODE_LIST:
        if (value == null) {
          unsetNodeList();
        } else {
          setNodeList((Map<String,Node_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case NODE_LIST:
        return getNodeList();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case NODE_LIST:
        return isSetNodeList();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof putObjects_thrift_args)
        return this.equals((putObjects_thrift_args)that);
      return false;
    }

    public boolean equals(putObjects_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_nodeList = true && this.isSetNodeList();
      boolean that_present_nodeList = true && that.isSetNodeList();
      if (this_present_nodeList || that_present_nodeList) {
        if (!(this_present_nodeList && that_present_nodeList))
          return false;
        if (!this.nodeList.equals(that.nodeList))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_nodeList = true && (isSetNodeList());
      list.add(present_nodeList);
      if (present_nodeList)
        list.add(nodeList);

      return list.hashCode();
    }

    @Override
    public int compareTo(putObjects_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetNodeList()).compareTo(other.isSetNodeList());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetNodeList()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.nodeList, other.nodeList);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("putObjects_thrift_args(");
      boolean first = true;

      sb.append("nodeList:");
      if (this.nodeList == null) {
        sb.append("null");
      } else {
        sb.append(this.nodeList);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class putObjects_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public putObjects_thrift_argsStandardScheme getScheme() {
        return new putObjects_thrift_argsStandardScheme();
      }
    }

    private static class putObjects_thrift_argsStandardScheme extends StandardScheme<putObjects_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, putObjects_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // NODE_LIST
              if (schemeField.type == org.apache.thrift.protocol.TType.MAP) {
                {
                  org.apache.thrift.protocol.TMap _map52 = iprot.readMapBegin();
                  struct.nodeList = new HashMap<String,Node_thrift>(2*_map52.size);
                  String _key53;
                  Node_thrift _val54;
                  for (int _i55 = 0; _i55 < _map52.size; ++_i55)
                  {
                    _key53 = iprot.readString();
                    _val54 = new Node_thrift();
                    _val54.read(iprot);
                    struct.nodeList.put(_key53, _val54);
                  }
                  iprot.readMapEnd();
                }
                struct.setNodeListIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, putObjects_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.nodeList != null) {
          oprot.writeFieldBegin(NODE_LIST_FIELD_DESC);
          {
            oprot.writeMapBegin(new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.STRUCT, struct.nodeList.size()));
            for (Map.Entry<String, Node_thrift> _iter56 : struct.nodeList.entrySet())
            {
              oprot.writeString(_iter56.getKey());
              _iter56.getValue().write(oprot);
            }
            oprot.writeMapEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class putObjects_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public putObjects_thrift_argsTupleScheme getScheme() {
        return new putObjects_thrift_argsTupleScheme();
      }
    }

    private static class putObjects_thrift_argsTupleScheme extends TupleScheme<putObjects_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, putObjects_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetNodeList()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetNodeList()) {
          {
            oprot.writeI32(struct.nodeList.size());
            for (Map.Entry<String, Node_thrift> _iter57 : struct.nodeList.entrySet())
            {
              oprot.writeString(_iter57.getKey());
              _iter57.getValue().write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, putObjects_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TMap _map58 = new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.nodeList = new HashMap<String,Node_thrift>(2*_map58.size);
            String _key59;
            Node_thrift _val60;
            for (int _i61 = 0; _i61 < _map58.size; ++_i61)
            {
              _key59 = iprot.readString();
              _val60 = new Node_thrift();
              _val60.read(iprot);
              struct.nodeList.put(_key59, _val60);
            }
          }
          struct.setNodeListIsSet(true);
        }
      }
    }

  }

  public static class putObjects_thrift_result implements org.apache.thrift.TBase<putObjects_thrift_result, putObjects_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<putObjects_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("putObjects_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.LIST, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new putObjects_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new putObjects_thrift_resultTupleSchemeFactory());
    }

    public List<ResultObject_thrift> success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(putObjects_thrift_result.class, metaDataMap);
    }

    public putObjects_thrift_result() {
    }

    public putObjects_thrift_result(
      List<ResultObject_thrift> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public putObjects_thrift_result(putObjects_thrift_result other) {
      if (other.isSetSuccess()) {
        List<ResultObject_thrift> __this__success = new ArrayList<ResultObject_thrift>(other.success.size());
        for (ResultObject_thrift other_element : other.success) {
          __this__success.add(new ResultObject_thrift(other_element));
        }
        this.success = __this__success;
      }
    }

    public putObjects_thrift_result deepCopy() {
      return new putObjects_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<ResultObject_thrift> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(ResultObject_thrift elem) {
      if (this.success == null) {
        this.success = new ArrayList<ResultObject_thrift>();
      }
      this.success.add(elem);
    }

    public List<ResultObject_thrift> getSuccess() {
      return this.success;
    }

    public putObjects_thrift_result setSuccess(List<ResultObject_thrift> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<ResultObject_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof putObjects_thrift_result)
        return this.equals((putObjects_thrift_result)that);
      return false;
    }

    public boolean equals(putObjects_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(putObjects_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("putObjects_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class putObjects_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public putObjects_thrift_resultStandardScheme getScheme() {
        return new putObjects_thrift_resultStandardScheme();
      }
    }

    private static class putObjects_thrift_resultStandardScheme extends StandardScheme<putObjects_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, putObjects_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list62 = iprot.readListBegin();
                  struct.success = new ArrayList<ResultObject_thrift>(_list62.size);
                  ResultObject_thrift _elem63;
                  for (int _i64 = 0; _i64 < _list62.size; ++_i64)
                  {
                    _elem63 = new ResultObject_thrift();
                    _elem63.read(iprot);
                    struct.success.add(_elem63);
                  }
                  iprot.readListEnd();
                }
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, putObjects_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.success.size()));
            for (ResultObject_thrift _iter65 : struct.success)
            {
              _iter65.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class putObjects_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public putObjects_thrift_resultTupleScheme getScheme() {
        return new putObjects_thrift_resultTupleScheme();
      }
    }

    private static class putObjects_thrift_resultTupleScheme extends TupleScheme<putObjects_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, putObjects_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          {
            oprot.writeI32(struct.success.size());
            for (ResultObject_thrift _iter66 : struct.success)
            {
              _iter66.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, putObjects_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list67 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.success = new ArrayList<ResultObject_thrift>(_list67.size);
            ResultObject_thrift _elem68;
            for (int _i69 = 0; _i69 < _list67.size; ++_i69)
            {
              _elem68 = new ResultObject_thrift();
              _elem68.read(iprot);
              struct.success.add(_elem68);
            }
          }
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class getObjects_thrift_args implements org.apache.thrift.TBase<getObjects_thrift_args, getObjects_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<getObjects_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getObjects_thrift_args");

    private static final org.apache.thrift.protocol.TField KEY_LIST_FIELD_DESC = new org.apache.thrift.protocol.TField("keyList", org.apache.thrift.protocol.TType.LIST, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getObjects_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getObjects_thrift_argsTupleSchemeFactory());
    }

    public List<String> keyList; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      KEY_LIST((short)1, "keyList");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // KEY_LIST
            return KEY_LIST;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.KEY_LIST, new org.apache.thrift.meta_data.FieldMetaData("keyList", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getObjects_thrift_args.class, metaDataMap);
    }

    public getObjects_thrift_args() {
    }

    public getObjects_thrift_args(
      List<String> keyList)
    {
      this();
      this.keyList = keyList;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getObjects_thrift_args(getObjects_thrift_args other) {
      if (other.isSetKeyList()) {
        List<String> __this__keyList = new ArrayList<String>(other.keyList);
        this.keyList = __this__keyList;
      }
    }

    public getObjects_thrift_args deepCopy() {
      return new getObjects_thrift_args(this);
    }

    @Override
    public void clear() {
      this.keyList = null;
    }

    public int getKeyListSize() {
      return (this.keyList == null) ? 0 : this.keyList.size();
    }

    public java.util.Iterator<String> getKeyListIterator() {
      return (this.keyList == null) ? null : this.keyList.iterator();
    }

    public void addToKeyList(String elem) {
      if (this.keyList == null) {
        this.keyList = new ArrayList<String>();
      }
      this.keyList.add(elem);
    }

    public List<String> getKeyList() {
      return this.keyList;
    }

    public getObjects_thrift_args setKeyList(List<String> keyList) {
      this.keyList = keyList;
      return this;
    }

    public void unsetKeyList() {
      this.keyList = null;
    }

    /** Returns true if field keyList is set (has been assigned a value) and false otherwise */
    public boolean isSetKeyList() {
      return this.keyList != null;
    }

    public void setKeyListIsSet(boolean value) {
      if (!value) {
        this.keyList = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case KEY_LIST:
        if (value == null) {
          unsetKeyList();
        } else {
          setKeyList((List<String>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case KEY_LIST:
        return getKeyList();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case KEY_LIST:
        return isSetKeyList();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getObjects_thrift_args)
        return this.equals((getObjects_thrift_args)that);
      return false;
    }

    public boolean equals(getObjects_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_keyList = true && this.isSetKeyList();
      boolean that_present_keyList = true && that.isSetKeyList();
      if (this_present_keyList || that_present_keyList) {
        if (!(this_present_keyList && that_present_keyList))
          return false;
        if (!this.keyList.equals(that.keyList))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_keyList = true && (isSetKeyList());
      list.add(present_keyList);
      if (present_keyList)
        list.add(keyList);

      return list.hashCode();
    }

    @Override
    public int compareTo(getObjects_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetKeyList()).compareTo(other.isSetKeyList());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetKeyList()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.keyList, other.keyList);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getObjects_thrift_args(");
      boolean first = true;

      sb.append("keyList:");
      if (this.keyList == null) {
        sb.append("null");
      } else {
        sb.append(this.keyList);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getObjects_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public getObjects_thrift_argsStandardScheme getScheme() {
        return new getObjects_thrift_argsStandardScheme();
      }
    }

    private static class getObjects_thrift_argsStandardScheme extends StandardScheme<getObjects_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getObjects_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // KEY_LIST
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list70 = iprot.readListBegin();
                  struct.keyList = new ArrayList<String>(_list70.size);
                  String _elem71;
                  for (int _i72 = 0; _i72 < _list70.size; ++_i72)
                  {
                    _elem71 = iprot.readString();
                    struct.keyList.add(_elem71);
                  }
                  iprot.readListEnd();
                }
                struct.setKeyListIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getObjects_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.keyList != null) {
          oprot.writeFieldBegin(KEY_LIST_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, struct.keyList.size()));
            for (String _iter73 : struct.keyList)
            {
              oprot.writeString(_iter73);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getObjects_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public getObjects_thrift_argsTupleScheme getScheme() {
        return new getObjects_thrift_argsTupleScheme();
      }
    }

    private static class getObjects_thrift_argsTupleScheme extends TupleScheme<getObjects_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getObjects_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetKeyList()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetKeyList()) {
          {
            oprot.writeI32(struct.keyList.size());
            for (String _iter74 : struct.keyList)
            {
              oprot.writeString(_iter74);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getObjects_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list75 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, iprot.readI32());
            struct.keyList = new ArrayList<String>(_list75.size);
            String _elem76;
            for (int _i77 = 0; _i77 < _list75.size; ++_i77)
            {
              _elem76 = iprot.readString();
              struct.keyList.add(_elem76);
            }
          }
          struct.setKeyListIsSet(true);
        }
      }
    }

  }

  public static class getObjects_thrift_result implements org.apache.thrift.TBase<getObjects_thrift_result, getObjects_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<getObjects_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getObjects_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.LIST, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getObjects_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getObjects_thrift_resultTupleSchemeFactory());
    }

    public List<ResultObject_thrift> success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getObjects_thrift_result.class, metaDataMap);
    }

    public getObjects_thrift_result() {
    }

    public getObjects_thrift_result(
      List<ResultObject_thrift> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getObjects_thrift_result(getObjects_thrift_result other) {
      if (other.isSetSuccess()) {
        List<ResultObject_thrift> __this__success = new ArrayList<ResultObject_thrift>(other.success.size());
        for (ResultObject_thrift other_element : other.success) {
          __this__success.add(new ResultObject_thrift(other_element));
        }
        this.success = __this__success;
      }
    }

    public getObjects_thrift_result deepCopy() {
      return new getObjects_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<ResultObject_thrift> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(ResultObject_thrift elem) {
      if (this.success == null) {
        this.success = new ArrayList<ResultObject_thrift>();
      }
      this.success.add(elem);
    }

    public List<ResultObject_thrift> getSuccess() {
      return this.success;
    }

    public getObjects_thrift_result setSuccess(List<ResultObject_thrift> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<ResultObject_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getObjects_thrift_result)
        return this.equals((getObjects_thrift_result)that);
      return false;
    }

    public boolean equals(getObjects_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(getObjects_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getObjects_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getObjects_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public getObjects_thrift_resultStandardScheme getScheme() {
        return new getObjects_thrift_resultStandardScheme();
      }
    }

    private static class getObjects_thrift_resultStandardScheme extends StandardScheme<getObjects_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getObjects_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list78 = iprot.readListBegin();
                  struct.success = new ArrayList<ResultObject_thrift>(_list78.size);
                  ResultObject_thrift _elem79;
                  for (int _i80 = 0; _i80 < _list78.size; ++_i80)
                  {
                    _elem79 = new ResultObject_thrift();
                    _elem79.read(iprot);
                    struct.success.add(_elem79);
                  }
                  iprot.readListEnd();
                }
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getObjects_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.success.size()));
            for (ResultObject_thrift _iter81 : struct.success)
            {
              _iter81.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getObjects_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public getObjects_thrift_resultTupleScheme getScheme() {
        return new getObjects_thrift_resultTupleScheme();
      }
    }

    private static class getObjects_thrift_resultTupleScheme extends TupleScheme<getObjects_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getObjects_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          {
            oprot.writeI32(struct.success.size());
            for (ResultObject_thrift _iter82 : struct.success)
            {
              _iter82.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getObjects_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list83 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.success = new ArrayList<ResultObject_thrift>(_list83.size);
            ResultObject_thrift _elem84;
            for (int _i85 = 0; _i85 < _list83.size; ++_i85)
            {
              _elem84 = new ResultObject_thrift();
              _elem84.read(iprot);
              struct.success.add(_elem84);
            }
          }
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class getAllKeys_thrift_args implements org.apache.thrift.TBase<getAllKeys_thrift_args, getAllKeys_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<getAllKeys_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getAllKeys_thrift_args");


    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getAllKeys_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getAllKeys_thrift_argsTupleSchemeFactory());
    }


    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getAllKeys_thrift_args.class, metaDataMap);
    }

    public getAllKeys_thrift_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getAllKeys_thrift_args(getAllKeys_thrift_args other) {
    }

    public getAllKeys_thrift_args deepCopy() {
      return new getAllKeys_thrift_args(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getAllKeys_thrift_args)
        return this.equals((getAllKeys_thrift_args)that);
      return false;
    }

    public boolean equals(getAllKeys_thrift_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      return list.hashCode();
    }

    @Override
    public int compareTo(getAllKeys_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getAllKeys_thrift_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getAllKeys_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public getAllKeys_thrift_argsStandardScheme getScheme() {
        return new getAllKeys_thrift_argsStandardScheme();
      }
    }

    private static class getAllKeys_thrift_argsStandardScheme extends StandardScheme<getAllKeys_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getAllKeys_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getAllKeys_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getAllKeys_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public getAllKeys_thrift_argsTupleScheme getScheme() {
        return new getAllKeys_thrift_argsTupleScheme();
      }
    }

    private static class getAllKeys_thrift_argsTupleScheme extends TupleScheme<getAllKeys_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getAllKeys_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getAllKeys_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
      }
    }

  }

  public static class getAllKeys_thrift_result implements org.apache.thrift.TBase<getAllKeys_thrift_result, getAllKeys_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<getAllKeys_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getAllKeys_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.LIST, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getAllKeys_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getAllKeys_thrift_resultTupleSchemeFactory());
    }

    public List<String> success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getAllKeys_thrift_result.class, metaDataMap);
    }

    public getAllKeys_thrift_result() {
    }

    public getAllKeys_thrift_result(
      List<String> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getAllKeys_thrift_result(getAllKeys_thrift_result other) {
      if (other.isSetSuccess()) {
        List<String> __this__success = new ArrayList<String>(other.success);
        this.success = __this__success;
      }
    }

    public getAllKeys_thrift_result deepCopy() {
      return new getAllKeys_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<String> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(String elem) {
      if (this.success == null) {
        this.success = new ArrayList<String>();
      }
      this.success.add(elem);
    }

    public List<String> getSuccess() {
      return this.success;
    }

    public getAllKeys_thrift_result setSuccess(List<String> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<String>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getAllKeys_thrift_result)
        return this.equals((getAllKeys_thrift_result)that);
      return false;
    }

    public boolean equals(getAllKeys_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(getAllKeys_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getAllKeys_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getAllKeys_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public getAllKeys_thrift_resultStandardScheme getScheme() {
        return new getAllKeys_thrift_resultStandardScheme();
      }
    }

    private static class getAllKeys_thrift_resultStandardScheme extends StandardScheme<getAllKeys_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getAllKeys_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list86 = iprot.readListBegin();
                  struct.success = new ArrayList<String>(_list86.size);
                  String _elem87;
                  for (int _i88 = 0; _i88 < _list86.size; ++_i88)
                  {
                    _elem87 = iprot.readString();
                    struct.success.add(_elem87);
                  }
                  iprot.readListEnd();
                }
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getAllKeys_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, struct.success.size()));
            for (String _iter89 : struct.success)
            {
              oprot.writeString(_iter89);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getAllKeys_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public getAllKeys_thrift_resultTupleScheme getScheme() {
        return new getAllKeys_thrift_resultTupleScheme();
      }
    }

    private static class getAllKeys_thrift_resultTupleScheme extends TupleScheme<getAllKeys_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getAllKeys_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          {
            oprot.writeI32(struct.success.size());
            for (String _iter90 : struct.success)
            {
              oprot.writeString(_iter90);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getAllKeys_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list91 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, iprot.readI32());
            struct.success = new ArrayList<String>(_list91.size);
            String _elem92;
            for (int _i93 = 0; _i93 < _list91.size; ++_i93)
            {
              _elem92 = iprot.readString();
              struct.success.add(_elem92);
            }
          }
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class relocate_thrift_args implements org.apache.thrift.TBase<relocate_thrift_args, relocate_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<relocate_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("relocate_thrift_args");

    private static final org.apache.thrift.protocol.TField NODE_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("nodeId", org.apache.thrift.protocol.TType.I32, (short)1);
    private static final org.apache.thrift.protocol.TField SERVER_NAME_FIELD_DESC = new org.apache.thrift.protocol.TField("serverName", org.apache.thrift.protocol.TType.STRING, (short)2);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new relocate_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new relocate_thrift_argsTupleSchemeFactory());
    }

    public int nodeId; // required
    public String serverName; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      NODE_ID((short)1, "nodeId"),
      SERVER_NAME((short)2, "serverName");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // NODE_ID
            return NODE_ID;
          case 2: // SERVER_NAME
            return SERVER_NAME;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __NODEID_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.NODE_ID, new org.apache.thrift.meta_data.FieldMetaData("nodeId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32          , "int")));
      tmpMap.put(_Fields.SERVER_NAME, new org.apache.thrift.meta_data.FieldMetaData("serverName", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(relocate_thrift_args.class, metaDataMap);
    }

    public relocate_thrift_args() {
    }

    public relocate_thrift_args(
      int nodeId,
      String serverName)
    {
      this();
      this.nodeId = nodeId;
      setNodeIdIsSet(true);
      this.serverName = serverName;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public relocate_thrift_args(relocate_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.nodeId = other.nodeId;
      if (other.isSetServerName()) {
        this.serverName = other.serverName;
      }
    }

    public relocate_thrift_args deepCopy() {
      return new relocate_thrift_args(this);
    }

    @Override
    public void clear() {
      setNodeIdIsSet(false);
      this.nodeId = 0;
      this.serverName = null;
    }

    public int getNodeId() {
      return this.nodeId;
    }

    public relocate_thrift_args setNodeId(int nodeId) {
      this.nodeId = nodeId;
      setNodeIdIsSet(true);
      return this;
    }

    public void unsetNodeId() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __NODEID_ISSET_ID);
    }

    /** Returns true if field nodeId is set (has been assigned a value) and false otherwise */
    public boolean isSetNodeId() {
      return EncodingUtils.testBit(__isset_bitfield, __NODEID_ISSET_ID);
    }

    public void setNodeIdIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __NODEID_ISSET_ID, value);
    }

    public String getServerName() {
      return this.serverName;
    }

    public relocate_thrift_args setServerName(String serverName) {
      this.serverName = serverName;
      return this;
    }

    public void unsetServerName() {
      this.serverName = null;
    }

    /** Returns true if field serverName is set (has been assigned a value) and false otherwise */
    public boolean isSetServerName() {
      return this.serverName != null;
    }

    public void setServerNameIsSet(boolean value) {
      if (!value) {
        this.serverName = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case NODE_ID:
        if (value == null) {
          unsetNodeId();
        } else {
          setNodeId((Integer)value);
        }
        break;

      case SERVER_NAME:
        if (value == null) {
          unsetServerName();
        } else {
          setServerName((String)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case NODE_ID:
        return getNodeId();

      case SERVER_NAME:
        return getServerName();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case NODE_ID:
        return isSetNodeId();
      case SERVER_NAME:
        return isSetServerName();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof relocate_thrift_args)
        return this.equals((relocate_thrift_args)that);
      return false;
    }

    public boolean equals(relocate_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_nodeId = true;
      boolean that_present_nodeId = true;
      if (this_present_nodeId || that_present_nodeId) {
        if (!(this_present_nodeId && that_present_nodeId))
          return false;
        if (this.nodeId != that.nodeId)
          return false;
      }

      boolean this_present_serverName = true && this.isSetServerName();
      boolean that_present_serverName = true && that.isSetServerName();
      if (this_present_serverName || that_present_serverName) {
        if (!(this_present_serverName && that_present_serverName))
          return false;
        if (!this.serverName.equals(that.serverName))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_nodeId = true;
      list.add(present_nodeId);
      if (present_nodeId)
        list.add(nodeId);

      boolean present_serverName = true && (isSetServerName());
      list.add(present_serverName);
      if (present_serverName)
        list.add(serverName);

      return list.hashCode();
    }

    @Override
    public int compareTo(relocate_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetNodeId()).compareTo(other.isSetNodeId());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetNodeId()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.nodeId, other.nodeId);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetServerName()).compareTo(other.isSetServerName());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetServerName()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.serverName, other.serverName);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("relocate_thrift_args(");
      boolean first = true;

      sb.append("nodeId:");
      sb.append(this.nodeId);
      first = false;
      if (!first) sb.append(", ");
      sb.append("serverName:");
      if (this.serverName == null) {
        sb.append("null");
      } else {
        sb.append(this.serverName);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class relocate_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public relocate_thrift_argsStandardScheme getScheme() {
        return new relocate_thrift_argsStandardScheme();
      }
    }

    private static class relocate_thrift_argsStandardScheme extends StandardScheme<relocate_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, relocate_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // NODE_ID
              if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
                struct.nodeId = iprot.readI32();
                struct.setNodeIdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // SERVER_NAME
              if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
                struct.serverName = iprot.readString();
                struct.setServerNameIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, relocate_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(NODE_ID_FIELD_DESC);
        oprot.writeI32(struct.nodeId);
        oprot.writeFieldEnd();
        if (struct.serverName != null) {
          oprot.writeFieldBegin(SERVER_NAME_FIELD_DESC);
          oprot.writeString(struct.serverName);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class relocate_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public relocate_thrift_argsTupleScheme getScheme() {
        return new relocate_thrift_argsTupleScheme();
      }
    }

    private static class relocate_thrift_argsTupleScheme extends TupleScheme<relocate_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, relocate_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetNodeId()) {
          optionals.set(0);
        }
        if (struct.isSetServerName()) {
          optionals.set(1);
        }
        oprot.writeBitSet(optionals, 2);
        if (struct.isSetNodeId()) {
          oprot.writeI32(struct.nodeId);
        }
        if (struct.isSetServerName()) {
          oprot.writeString(struct.serverName);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, relocate_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(2);
        if (incoming.get(0)) {
          struct.nodeId = iprot.readI32();
          struct.setNodeIdIsSet(true);
        }
        if (incoming.get(1)) {
          struct.serverName = iprot.readString();
          struct.setServerNameIsSet(true);
        }
      }
    }

  }

  public static class relocate_thrift_result implements org.apache.thrift.TBase<relocate_thrift_result, relocate_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<relocate_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("relocate_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new relocate_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new relocate_thrift_resultTupleSchemeFactory());
    }

    public ResultObject_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(relocate_thrift_result.class, metaDataMap);
    }

    public relocate_thrift_result() {
    }

    public relocate_thrift_result(
      ResultObject_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public relocate_thrift_result(relocate_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new ResultObject_thrift(other.success);
      }
    }

    public relocate_thrift_result deepCopy() {
      return new relocate_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public ResultObject_thrift getSuccess() {
      return this.success;
    }

    public relocate_thrift_result setSuccess(ResultObject_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ResultObject_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof relocate_thrift_result)
        return this.equals((relocate_thrift_result)that);
      return false;
    }

    public boolean equals(relocate_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(relocate_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("relocate_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class relocate_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public relocate_thrift_resultStandardScheme getScheme() {
        return new relocate_thrift_resultStandardScheme();
      }
    }

    private static class relocate_thrift_resultStandardScheme extends StandardScheme<relocate_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, relocate_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new ResultObject_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, relocate_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class relocate_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public relocate_thrift_resultTupleScheme getScheme() {
        return new relocate_thrift_resultTupleScheme();
      }
    }

    private static class relocate_thrift_resultTupleScheme extends TupleScheme<relocate_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, relocate_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, relocate_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new ResultObject_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class locationChange_thrift_args implements org.apache.thrift.TBase<locationChange_thrift_args, locationChange_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<locationChange_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("locationChange_thrift_args");

    private static final org.apache.thrift.protocol.TField NODE_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("nodeId", org.apache.thrift.protocol.TType.I32, (short)1);
    private static final org.apache.thrift.protocol.TField SERVER_NAME_FIELD_DESC = new org.apache.thrift.protocol.TField("serverName", org.apache.thrift.protocol.TType.STRING, (short)2);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new locationChange_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new locationChange_thrift_argsTupleSchemeFactory());
    }

    public int nodeId; // required
    public String serverName; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      NODE_ID((short)1, "nodeId"),
      SERVER_NAME((short)2, "serverName");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // NODE_ID
            return NODE_ID;
          case 2: // SERVER_NAME
            return SERVER_NAME;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __NODEID_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.NODE_ID, new org.apache.thrift.meta_data.FieldMetaData("nodeId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32          , "int")));
      tmpMap.put(_Fields.SERVER_NAME, new org.apache.thrift.meta_data.FieldMetaData("serverName", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(locationChange_thrift_args.class, metaDataMap);
    }

    public locationChange_thrift_args() {
    }

    public locationChange_thrift_args(
      int nodeId,
      String serverName)
    {
      this();
      this.nodeId = nodeId;
      setNodeIdIsSet(true);
      this.serverName = serverName;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public locationChange_thrift_args(locationChange_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.nodeId = other.nodeId;
      if (other.isSetServerName()) {
        this.serverName = other.serverName;
      }
    }

    public locationChange_thrift_args deepCopy() {
      return new locationChange_thrift_args(this);
    }

    @Override
    public void clear() {
      setNodeIdIsSet(false);
      this.nodeId = 0;
      this.serverName = null;
    }

    public int getNodeId() {
      return this.nodeId;
    }

    public locationChange_thrift_args setNodeId(int nodeId) {
      this.nodeId = nodeId;
      setNodeIdIsSet(true);
      return this;
    }

    public void unsetNodeId() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __NODEID_ISSET_ID);
    }

    /** Returns true if field nodeId is set (has been assigned a value) and false otherwise */
    public boolean isSetNodeId() {
      return EncodingUtils.testBit(__isset_bitfield, __NODEID_ISSET_ID);
    }

    public void setNodeIdIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __NODEID_ISSET_ID, value);
    }

    public String getServerName() {
      return this.serverName;
    }

    public locationChange_thrift_args setServerName(String serverName) {
      this.serverName = serverName;
      return this;
    }

    public void unsetServerName() {
      this.serverName = null;
    }

    /** Returns true if field serverName is set (has been assigned a value) and false otherwise */
    public boolean isSetServerName() {
      return this.serverName != null;
    }

    public void setServerNameIsSet(boolean value) {
      if (!value) {
        this.serverName = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case NODE_ID:
        if (value == null) {
          unsetNodeId();
        } else {
          setNodeId((Integer)value);
        }
        break;

      case SERVER_NAME:
        if (value == null) {
          unsetServerName();
        } else {
          setServerName((String)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case NODE_ID:
        return getNodeId();

      case SERVER_NAME:
        return getServerName();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case NODE_ID:
        return isSetNodeId();
      case SERVER_NAME:
        return isSetServerName();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof locationChange_thrift_args)
        return this.equals((locationChange_thrift_args)that);
      return false;
    }

    public boolean equals(locationChange_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_nodeId = true;
      boolean that_present_nodeId = true;
      if (this_present_nodeId || that_present_nodeId) {
        if (!(this_present_nodeId && that_present_nodeId))
          return false;
        if (this.nodeId != that.nodeId)
          return false;
      }

      boolean this_present_serverName = true && this.isSetServerName();
      boolean that_present_serverName = true && that.isSetServerName();
      if (this_present_serverName || that_present_serverName) {
        if (!(this_present_serverName && that_present_serverName))
          return false;
        if (!this.serverName.equals(that.serverName))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_nodeId = true;
      list.add(present_nodeId);
      if (present_nodeId)
        list.add(nodeId);

      boolean present_serverName = true && (isSetServerName());
      list.add(present_serverName);
      if (present_serverName)
        list.add(serverName);

      return list.hashCode();
    }

    @Override
    public int compareTo(locationChange_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetNodeId()).compareTo(other.isSetNodeId());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetNodeId()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.nodeId, other.nodeId);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetServerName()).compareTo(other.isSetServerName());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetServerName()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.serverName, other.serverName);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("locationChange_thrift_args(");
      boolean first = true;

      sb.append("nodeId:");
      sb.append(this.nodeId);
      first = false;
      if (!first) sb.append(", ");
      sb.append("serverName:");
      if (this.serverName == null) {
        sb.append("null");
      } else {
        sb.append(this.serverName);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class locationChange_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public locationChange_thrift_argsStandardScheme getScheme() {
        return new locationChange_thrift_argsStandardScheme();
      }
    }

    private static class locationChange_thrift_argsStandardScheme extends StandardScheme<locationChange_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, locationChange_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // NODE_ID
              if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
                struct.nodeId = iprot.readI32();
                struct.setNodeIdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // SERVER_NAME
              if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
                struct.serverName = iprot.readString();
                struct.setServerNameIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, locationChange_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(NODE_ID_FIELD_DESC);
        oprot.writeI32(struct.nodeId);
        oprot.writeFieldEnd();
        if (struct.serverName != null) {
          oprot.writeFieldBegin(SERVER_NAME_FIELD_DESC);
          oprot.writeString(struct.serverName);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class locationChange_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public locationChange_thrift_argsTupleScheme getScheme() {
        return new locationChange_thrift_argsTupleScheme();
      }
    }

    private static class locationChange_thrift_argsTupleScheme extends TupleScheme<locationChange_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, locationChange_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetNodeId()) {
          optionals.set(0);
        }
        if (struct.isSetServerName()) {
          optionals.set(1);
        }
        oprot.writeBitSet(optionals, 2);
        if (struct.isSetNodeId()) {
          oprot.writeI32(struct.nodeId);
        }
        if (struct.isSetServerName()) {
          oprot.writeString(struct.serverName);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, locationChange_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(2);
        if (incoming.get(0)) {
          struct.nodeId = iprot.readI32();
          struct.setNodeIdIsSet(true);
        }
        if (incoming.get(1)) {
          struct.serverName = iprot.readString();
          struct.setServerNameIsSet(true);
        }
      }
    }

  }

  public static class lock_thrift_args implements org.apache.thrift.TBase<lock_thrift_args, lock_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<lock_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("lock_thrift_args");

    private static final org.apache.thrift.protocol.TField NODE_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("nodeId", org.apache.thrift.protocol.TType.I32, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new lock_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new lock_thrift_argsTupleSchemeFactory());
    }

    public int nodeId; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      NODE_ID((short)1, "nodeId");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // NODE_ID
            return NODE_ID;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __NODEID_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.NODE_ID, new org.apache.thrift.meta_data.FieldMetaData("nodeId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32          , "int")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(lock_thrift_args.class, metaDataMap);
    }

    public lock_thrift_args() {
    }

    public lock_thrift_args(
      int nodeId)
    {
      this();
      this.nodeId = nodeId;
      setNodeIdIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public lock_thrift_args(lock_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.nodeId = other.nodeId;
    }

    public lock_thrift_args deepCopy() {
      return new lock_thrift_args(this);
    }

    @Override
    public void clear() {
      setNodeIdIsSet(false);
      this.nodeId = 0;
    }

    public int getNodeId() {
      return this.nodeId;
    }

    public lock_thrift_args setNodeId(int nodeId) {
      this.nodeId = nodeId;
      setNodeIdIsSet(true);
      return this;
    }

    public void unsetNodeId() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __NODEID_ISSET_ID);
    }

    /** Returns true if field nodeId is set (has been assigned a value) and false otherwise */
    public boolean isSetNodeId() {
      return EncodingUtils.testBit(__isset_bitfield, __NODEID_ISSET_ID);
    }

    public void setNodeIdIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __NODEID_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case NODE_ID:
        if (value == null) {
          unsetNodeId();
        } else {
          setNodeId((Integer)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case NODE_ID:
        return getNodeId();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case NODE_ID:
        return isSetNodeId();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof lock_thrift_args)
        return this.equals((lock_thrift_args)that);
      return false;
    }

    public boolean equals(lock_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_nodeId = true;
      boolean that_present_nodeId = true;
      if (this_present_nodeId || that_present_nodeId) {
        if (!(this_present_nodeId && that_present_nodeId))
          return false;
        if (this.nodeId != that.nodeId)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_nodeId = true;
      list.add(present_nodeId);
      if (present_nodeId)
        list.add(nodeId);

      return list.hashCode();
    }

    @Override
    public int compareTo(lock_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetNodeId()).compareTo(other.isSetNodeId());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetNodeId()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.nodeId, other.nodeId);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("lock_thrift_args(");
      boolean first = true;

      sb.append("nodeId:");
      sb.append(this.nodeId);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class lock_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public lock_thrift_argsStandardScheme getScheme() {
        return new lock_thrift_argsStandardScheme();
      }
    }

    private static class lock_thrift_argsStandardScheme extends StandardScheme<lock_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, lock_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // NODE_ID
              if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
                struct.nodeId = iprot.readI32();
                struct.setNodeIdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, lock_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(NODE_ID_FIELD_DESC);
        oprot.writeI32(struct.nodeId);
        oprot.writeFieldEnd();
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class lock_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public lock_thrift_argsTupleScheme getScheme() {
        return new lock_thrift_argsTupleScheme();
      }
    }

    private static class lock_thrift_argsTupleScheme extends TupleScheme<lock_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, lock_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetNodeId()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetNodeId()) {
          oprot.writeI32(struct.nodeId);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, lock_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.nodeId = iprot.readI32();
          struct.setNodeIdIsSet(true);
        }
      }
    }

  }

  public static class lock_thrift_result implements org.apache.thrift.TBase<lock_thrift_result, lock_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<lock_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("lock_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new lock_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new lock_thrift_resultTupleSchemeFactory());
    }

    public ResultObject_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ResultObject_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(lock_thrift_result.class, metaDataMap);
    }

    public lock_thrift_result() {
    }

    public lock_thrift_result(
      ResultObject_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public lock_thrift_result(lock_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new ResultObject_thrift(other.success);
      }
    }

    public lock_thrift_result deepCopy() {
      return new lock_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public ResultObject_thrift getSuccess() {
      return this.success;
    }

    public lock_thrift_result setSuccess(ResultObject_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ResultObject_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof lock_thrift_result)
        return this.equals((lock_thrift_result)that);
      return false;
    }

    public boolean equals(lock_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(lock_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("lock_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class lock_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public lock_thrift_resultStandardScheme getScheme() {
        return new lock_thrift_resultStandardScheme();
      }
    }

    private static class lock_thrift_resultStandardScheme extends StandardScheme<lock_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, lock_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new ResultObject_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, lock_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class lock_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public lock_thrift_resultTupleScheme getScheme() {
        return new lock_thrift_resultTupleScheme();
      }
    }

    private static class lock_thrift_resultTupleScheme extends TupleScheme<lock_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, lock_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, lock_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new ResultObject_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class acquireLocks_thrift_args implements org.apache.thrift.TBase<acquireLocks_thrift_args, acquireLocks_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<acquireLocks_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("acquireLocks_thrift_args");

    private static final org.apache.thrift.protocol.TField LOCK_REQUESTS_FIELD_DESC = new org.apache.thrift.protocol.TField("lockRequests", org.apache.thrift.protocol.TType.SET, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new acquireLocks_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new acquireLocks_thrift_argsTupleSchemeFactory());
    }

    public Set<LockRequest_thrift> lockRequests; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      LOCK_REQUESTS((short)1, "lockRequests");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // LOCK_REQUESTS
            return LOCK_REQUESTS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.LOCK_REQUESTS, new org.apache.thrift.meta_data.FieldMetaData("lockRequests", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.SetMetaData(org.apache.thrift.protocol.TType.SET, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, LockRequest_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(acquireLocks_thrift_args.class, metaDataMap);
    }

    public acquireLocks_thrift_args() {
    }

    public acquireLocks_thrift_args(
      Set<LockRequest_thrift> lockRequests)
    {
      this();
      this.lockRequests = lockRequests;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public acquireLocks_thrift_args(acquireLocks_thrift_args other) {
      if (other.isSetLockRequests()) {
        Set<LockRequest_thrift> __this__lockRequests = new HashSet<LockRequest_thrift>(other.lockRequests.size());
        for (LockRequest_thrift other_element : other.lockRequests) {
          __this__lockRequests.add(new LockRequest_thrift(other_element));
        }
        this.lockRequests = __this__lockRequests;
      }
    }

    public acquireLocks_thrift_args deepCopy() {
      return new acquireLocks_thrift_args(this);
    }

    @Override
    public void clear() {
      this.lockRequests = null;
    }

    public int getLockRequestsSize() {
      return (this.lockRequests == null) ? 0 : this.lockRequests.size();
    }

    public java.util.Iterator<LockRequest_thrift> getLockRequestsIterator() {
      return (this.lockRequests == null) ? null : this.lockRequests.iterator();
    }

    public void addToLockRequests(LockRequest_thrift elem) {
      if (this.lockRequests == null) {
        this.lockRequests = new HashSet<LockRequest_thrift>();
      }
      this.lockRequests.add(elem);
    }

    public Set<LockRequest_thrift> getLockRequests() {
      return this.lockRequests;
    }

    public acquireLocks_thrift_args setLockRequests(Set<LockRequest_thrift> lockRequests) {
      this.lockRequests = lockRequests;
      return this;
    }

    public void unsetLockRequests() {
      this.lockRequests = null;
    }

    /** Returns true if field lockRequests is set (has been assigned a value) and false otherwise */
    public boolean isSetLockRequests() {
      return this.lockRequests != null;
    }

    public void setLockRequestsIsSet(boolean value) {
      if (!value) {
        this.lockRequests = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case LOCK_REQUESTS:
        if (value == null) {
          unsetLockRequests();
        } else {
          setLockRequests((Set<LockRequest_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case LOCK_REQUESTS:
        return getLockRequests();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case LOCK_REQUESTS:
        return isSetLockRequests();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof acquireLocks_thrift_args)
        return this.equals((acquireLocks_thrift_args)that);
      return false;
    }

    public boolean equals(acquireLocks_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_lockRequests = true && this.isSetLockRequests();
      boolean that_present_lockRequests = true && that.isSetLockRequests();
      if (this_present_lockRequests || that_present_lockRequests) {
        if (!(this_present_lockRequests && that_present_lockRequests))
          return false;
        if (!this.lockRequests.equals(that.lockRequests))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_lockRequests = true && (isSetLockRequests());
      list.add(present_lockRequests);
      if (present_lockRequests)
        list.add(lockRequests);

      return list.hashCode();
    }

    @Override
    public int compareTo(acquireLocks_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetLockRequests()).compareTo(other.isSetLockRequests());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetLockRequests()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.lockRequests, other.lockRequests);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("acquireLocks_thrift_args(");
      boolean first = true;

      sb.append("lockRequests:");
      if (this.lockRequests == null) {
        sb.append("null");
      } else {
        sb.append(this.lockRequests);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class acquireLocks_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public acquireLocks_thrift_argsStandardScheme getScheme() {
        return new acquireLocks_thrift_argsStandardScheme();
      }
    }

    private static class acquireLocks_thrift_argsStandardScheme extends StandardScheme<acquireLocks_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, acquireLocks_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // LOCK_REQUESTS
              if (schemeField.type == org.apache.thrift.protocol.TType.SET) {
                {
                  org.apache.thrift.protocol.TSet _set94 = iprot.readSetBegin();
                  struct.lockRequests = new HashSet<LockRequest_thrift>(2*_set94.size);
                  LockRequest_thrift _elem95;
                  for (int _i96 = 0; _i96 < _set94.size; ++_i96)
                  {
                    _elem95 = new LockRequest_thrift();
                    _elem95.read(iprot);
                    struct.lockRequests.add(_elem95);
                  }
                  iprot.readSetEnd();
                }
                struct.setLockRequestsIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, acquireLocks_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.lockRequests != null) {
          oprot.writeFieldBegin(LOCK_REQUESTS_FIELD_DESC);
          {
            oprot.writeSetBegin(new org.apache.thrift.protocol.TSet(org.apache.thrift.protocol.TType.STRUCT, struct.lockRequests.size()));
            for (LockRequest_thrift _iter97 : struct.lockRequests)
            {
              _iter97.write(oprot);
            }
            oprot.writeSetEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class acquireLocks_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public acquireLocks_thrift_argsTupleScheme getScheme() {
        return new acquireLocks_thrift_argsTupleScheme();
      }
    }

    private static class acquireLocks_thrift_argsTupleScheme extends TupleScheme<acquireLocks_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, acquireLocks_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetLockRequests()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetLockRequests()) {
          {
            oprot.writeI32(struct.lockRequests.size());
            for (LockRequest_thrift _iter98 : struct.lockRequests)
            {
              _iter98.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, acquireLocks_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TSet _set99 = new org.apache.thrift.protocol.TSet(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.lockRequests = new HashSet<LockRequest_thrift>(2*_set99.size);
            LockRequest_thrift _elem100;
            for (int _i101 = 0; _i101 < _set99.size; ++_i101)
            {
              _elem100 = new LockRequest_thrift();
              _elem100.read(iprot);
              struct.lockRequests.add(_elem100);
            }
          }
          struct.setLockRequestsIsSet(true);
        }
      }
    }

  }

  public static class acquireLocks_thrift_result implements org.apache.thrift.TBase<acquireLocks_thrift_result, acquireLocks_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<acquireLocks_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("acquireLocks_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.I32, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new acquireLocks_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new acquireLocks_thrift_resultTupleSchemeFactory());
    }

    public int success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32          , "int")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(acquireLocks_thrift_result.class, metaDataMap);
    }

    public acquireLocks_thrift_result() {
    }

    public acquireLocks_thrift_result(
      int success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public acquireLocks_thrift_result(acquireLocks_thrift_result other) {
      __isset_bitfield = other.__isset_bitfield;
      this.success = other.success;
    }

    public acquireLocks_thrift_result deepCopy() {
      return new acquireLocks_thrift_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = 0;
    }

    public int getSuccess() {
      return this.success;
    }

    public acquireLocks_thrift_result setSuccess(int success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return EncodingUtils.testBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Integer)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof acquireLocks_thrift_result)
        return this.equals((acquireLocks_thrift_result)that);
      return false;
    }

    public boolean equals(acquireLocks_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true;
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(acquireLocks_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("acquireLocks_thrift_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class acquireLocks_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public acquireLocks_thrift_resultStandardScheme getScheme() {
        return new acquireLocks_thrift_resultStandardScheme();
      }
    }

    private static class acquireLocks_thrift_resultStandardScheme extends StandardScheme<acquireLocks_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, acquireLocks_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
                struct.success = iprot.readI32();
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, acquireLocks_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.isSetSuccess()) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          oprot.writeI32(struct.success);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class acquireLocks_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public acquireLocks_thrift_resultTupleScheme getScheme() {
        return new acquireLocks_thrift_resultTupleScheme();
      }
    }

    private static class acquireLocks_thrift_resultTupleScheme extends TupleScheme<acquireLocks_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, acquireLocks_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          oprot.writeI32(struct.success);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, acquireLocks_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = iprot.readI32();
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class releaseLocks_thrift_args implements org.apache.thrift.TBase<releaseLocks_thrift_args, releaseLocks_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<releaseLocks_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("releaseLocks_thrift_args");

    private static final org.apache.thrift.protocol.TField LOCK_REQUESTS_FIELD_DESC = new org.apache.thrift.protocol.TField("lockRequests", org.apache.thrift.protocol.TType.SET, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new releaseLocks_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new releaseLocks_thrift_argsTupleSchemeFactory());
    }

    public Set<LockRequest_thrift> lockRequests; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      LOCK_REQUESTS((short)1, "lockRequests");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // LOCK_REQUESTS
            return LOCK_REQUESTS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.LOCK_REQUESTS, new org.apache.thrift.meta_data.FieldMetaData("lockRequests", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.SetMetaData(org.apache.thrift.protocol.TType.SET, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, LockRequest_thrift.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(releaseLocks_thrift_args.class, metaDataMap);
    }

    public releaseLocks_thrift_args() {
    }

    public releaseLocks_thrift_args(
      Set<LockRequest_thrift> lockRequests)
    {
      this();
      this.lockRequests = lockRequests;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public releaseLocks_thrift_args(releaseLocks_thrift_args other) {
      if (other.isSetLockRequests()) {
        Set<LockRequest_thrift> __this__lockRequests = new HashSet<LockRequest_thrift>(other.lockRequests.size());
        for (LockRequest_thrift other_element : other.lockRequests) {
          __this__lockRequests.add(new LockRequest_thrift(other_element));
        }
        this.lockRequests = __this__lockRequests;
      }
    }

    public releaseLocks_thrift_args deepCopy() {
      return new releaseLocks_thrift_args(this);
    }

    @Override
    public void clear() {
      this.lockRequests = null;
    }

    public int getLockRequestsSize() {
      return (this.lockRequests == null) ? 0 : this.lockRequests.size();
    }

    public java.util.Iterator<LockRequest_thrift> getLockRequestsIterator() {
      return (this.lockRequests == null) ? null : this.lockRequests.iterator();
    }

    public void addToLockRequests(LockRequest_thrift elem) {
      if (this.lockRequests == null) {
        this.lockRequests = new HashSet<LockRequest_thrift>();
      }
      this.lockRequests.add(elem);
    }

    public Set<LockRequest_thrift> getLockRequests() {
      return this.lockRequests;
    }

    public releaseLocks_thrift_args setLockRequests(Set<LockRequest_thrift> lockRequests) {
      this.lockRequests = lockRequests;
      return this;
    }

    public void unsetLockRequests() {
      this.lockRequests = null;
    }

    /** Returns true if field lockRequests is set (has been assigned a value) and false otherwise */
    public boolean isSetLockRequests() {
      return this.lockRequests != null;
    }

    public void setLockRequestsIsSet(boolean value) {
      if (!value) {
        this.lockRequests = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case LOCK_REQUESTS:
        if (value == null) {
          unsetLockRequests();
        } else {
          setLockRequests((Set<LockRequest_thrift>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case LOCK_REQUESTS:
        return getLockRequests();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case LOCK_REQUESTS:
        return isSetLockRequests();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof releaseLocks_thrift_args)
        return this.equals((releaseLocks_thrift_args)that);
      return false;
    }

    public boolean equals(releaseLocks_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_lockRequests = true && this.isSetLockRequests();
      boolean that_present_lockRequests = true && that.isSetLockRequests();
      if (this_present_lockRequests || that_present_lockRequests) {
        if (!(this_present_lockRequests && that_present_lockRequests))
          return false;
        if (!this.lockRequests.equals(that.lockRequests))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_lockRequests = true && (isSetLockRequests());
      list.add(present_lockRequests);
      if (present_lockRequests)
        list.add(lockRequests);

      return list.hashCode();
    }

    @Override
    public int compareTo(releaseLocks_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetLockRequests()).compareTo(other.isSetLockRequests());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetLockRequests()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.lockRequests, other.lockRequests);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("releaseLocks_thrift_args(");
      boolean first = true;

      sb.append("lockRequests:");
      if (this.lockRequests == null) {
        sb.append("null");
      } else {
        sb.append(this.lockRequests);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class releaseLocks_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public releaseLocks_thrift_argsStandardScheme getScheme() {
        return new releaseLocks_thrift_argsStandardScheme();
      }
    }

    private static class releaseLocks_thrift_argsStandardScheme extends StandardScheme<releaseLocks_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, releaseLocks_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // LOCK_REQUESTS
              if (schemeField.type == org.apache.thrift.protocol.TType.SET) {
                {
                  org.apache.thrift.protocol.TSet _set102 = iprot.readSetBegin();
                  struct.lockRequests = new HashSet<LockRequest_thrift>(2*_set102.size);
                  LockRequest_thrift _elem103;
                  for (int _i104 = 0; _i104 < _set102.size; ++_i104)
                  {
                    _elem103 = new LockRequest_thrift();
                    _elem103.read(iprot);
                    struct.lockRequests.add(_elem103);
                  }
                  iprot.readSetEnd();
                }
                struct.setLockRequestsIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, releaseLocks_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.lockRequests != null) {
          oprot.writeFieldBegin(LOCK_REQUESTS_FIELD_DESC);
          {
            oprot.writeSetBegin(new org.apache.thrift.protocol.TSet(org.apache.thrift.protocol.TType.STRUCT, struct.lockRequests.size()));
            for (LockRequest_thrift _iter105 : struct.lockRequests)
            {
              _iter105.write(oprot);
            }
            oprot.writeSetEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class releaseLocks_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public releaseLocks_thrift_argsTupleScheme getScheme() {
        return new releaseLocks_thrift_argsTupleScheme();
      }
    }

    private static class releaseLocks_thrift_argsTupleScheme extends TupleScheme<releaseLocks_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, releaseLocks_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetLockRequests()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetLockRequests()) {
          {
            oprot.writeI32(struct.lockRequests.size());
            for (LockRequest_thrift _iter106 : struct.lockRequests)
            {
              _iter106.write(oprot);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, releaseLocks_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TSet _set107 = new org.apache.thrift.protocol.TSet(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.lockRequests = new HashSet<LockRequest_thrift>(2*_set107.size);
            LockRequest_thrift _elem108;
            for (int _i109 = 0; _i109 < _set107.size; ++_i109)
            {
              _elem108 = new LockRequest_thrift();
              _elem108.read(iprot);
              struct.lockRequests.add(_elem108);
            }
          }
          struct.setLockRequestsIsSet(true);
        }
      }
    }

  }

  public static class releaseLocks_thrift_result implements org.apache.thrift.TBase<releaseLocks_thrift_result, releaseLocks_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<releaseLocks_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("releaseLocks_thrift_result");


    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new releaseLocks_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new releaseLocks_thrift_resultTupleSchemeFactory());
    }


    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(releaseLocks_thrift_result.class, metaDataMap);
    }

    public releaseLocks_thrift_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public releaseLocks_thrift_result(releaseLocks_thrift_result other) {
    }

    public releaseLocks_thrift_result deepCopy() {
      return new releaseLocks_thrift_result(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof releaseLocks_thrift_result)
        return this.equals((releaseLocks_thrift_result)that);
      return false;
    }

    public boolean equals(releaseLocks_thrift_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      return list.hashCode();
    }

    @Override
    public int compareTo(releaseLocks_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("releaseLocks_thrift_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class releaseLocks_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public releaseLocks_thrift_resultStandardScheme getScheme() {
        return new releaseLocks_thrift_resultStandardScheme();
      }
    }

    private static class releaseLocks_thrift_resultStandardScheme extends StandardScheme<releaseLocks_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, releaseLocks_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, releaseLocks_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class releaseLocks_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public releaseLocks_thrift_resultTupleScheme getScheme() {
        return new releaseLocks_thrift_resultTupleScheme();
      }
    }

    private static class releaseLocks_thrift_resultTupleScheme extends TupleScheme<releaseLocks_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, releaseLocks_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, releaseLocks_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
      }
    }

  }

  public static class commitChanges_thrift_args implements org.apache.thrift.TBase<commitChanges_thrift_args, commitChanges_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<commitChanges_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("commitChanges_thrift_args");

    private static final org.apache.thrift.protocol.TField WRITE_ND_FIELD_DESC = new org.apache.thrift.protocol.TField("writeNd", org.apache.thrift.protocol.TType.SET, (short)1);
    private static final org.apache.thrift.protocol.TField READ_FIELD_DESC = new org.apache.thrift.protocol.TField("read", org.apache.thrift.protocol.TType.MAP, (short)2);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new commitChanges_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new commitChanges_thrift_argsTupleSchemeFactory());
    }

    public Set<NodeData_thrift> writeNd; // required
    public Map<String,Long> read; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      WRITE_ND((short)1, "writeNd"),
      READ((short)2, "read");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // WRITE_ND
            return WRITE_ND;
          case 2: // READ
            return READ;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.WRITE_ND, new org.apache.thrift.meta_data.FieldMetaData("writeNd", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.SetMetaData(org.apache.thrift.protocol.TType.SET, 
              new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, NodeData_thrift.class))));
      tmpMap.put(_Fields.READ, new org.apache.thrift.meta_data.FieldMetaData("read", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.MapMetaData(org.apache.thrift.protocol.TType.MAP, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING), 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64              , "long"))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(commitChanges_thrift_args.class, metaDataMap);
    }

    public commitChanges_thrift_args() {
    }

    public commitChanges_thrift_args(
      Set<NodeData_thrift> writeNd,
      Map<String,Long> read)
    {
      this();
      this.writeNd = writeNd;
      this.read = read;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public commitChanges_thrift_args(commitChanges_thrift_args other) {
      if (other.isSetWriteNd()) {
        Set<NodeData_thrift> __this__writeNd = new HashSet<NodeData_thrift>(other.writeNd.size());
        for (NodeData_thrift other_element : other.writeNd) {
          __this__writeNd.add(new NodeData_thrift(other_element));
        }
        this.writeNd = __this__writeNd;
      }
      if (other.isSetRead()) {
        Map<String,Long> __this__read = new HashMap<String,Long>(other.read.size());
        for (Map.Entry<String, Long> other_element : other.read.entrySet()) {

          String other_element_key = other_element.getKey();
          Long other_element_value = other_element.getValue();

          String __this__read_copy_key = other_element_key;

          Long __this__read_copy_value = other_element_value;

          __this__read.put(__this__read_copy_key, __this__read_copy_value);
        }
        this.read = __this__read;
      }
    }

    public commitChanges_thrift_args deepCopy() {
      return new commitChanges_thrift_args(this);
    }

    @Override
    public void clear() {
      this.writeNd = null;
      this.read = null;
    }

    public int getWriteNdSize() {
      return (this.writeNd == null) ? 0 : this.writeNd.size();
    }

    public java.util.Iterator<NodeData_thrift> getWriteNdIterator() {
      return (this.writeNd == null) ? null : this.writeNd.iterator();
    }

    public void addToWriteNd(NodeData_thrift elem) {
      if (this.writeNd == null) {
        this.writeNd = new HashSet<NodeData_thrift>();
      }
      this.writeNd.add(elem);
    }

    public Set<NodeData_thrift> getWriteNd() {
      return this.writeNd;
    }

    public commitChanges_thrift_args setWriteNd(Set<NodeData_thrift> writeNd) {
      this.writeNd = writeNd;
      return this;
    }

    public void unsetWriteNd() {
      this.writeNd = null;
    }

    /** Returns true if field writeNd is set (has been assigned a value) and false otherwise */
    public boolean isSetWriteNd() {
      return this.writeNd != null;
    }

    public void setWriteNdIsSet(boolean value) {
      if (!value) {
        this.writeNd = null;
      }
    }

    public int getReadSize() {
      return (this.read == null) ? 0 : this.read.size();
    }

    public void putToRead(String key, long val) {
      if (this.read == null) {
        this.read = new HashMap<String,Long>();
      }
      this.read.put(key, val);
    }

    public Map<String,Long> getRead() {
      return this.read;
    }

    public commitChanges_thrift_args setRead(Map<String,Long> read) {
      this.read = read;
      return this;
    }

    public void unsetRead() {
      this.read = null;
    }

    /** Returns true if field read is set (has been assigned a value) and false otherwise */
    public boolean isSetRead() {
      return this.read != null;
    }

    public void setReadIsSet(boolean value) {
      if (!value) {
        this.read = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case WRITE_ND:
        if (value == null) {
          unsetWriteNd();
        } else {
          setWriteNd((Set<NodeData_thrift>)value);
        }
        break;

      case READ:
        if (value == null) {
          unsetRead();
        } else {
          setRead((Map<String,Long>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case WRITE_ND:
        return getWriteNd();

      case READ:
        return getRead();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case WRITE_ND:
        return isSetWriteNd();
      case READ:
        return isSetRead();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof commitChanges_thrift_args)
        return this.equals((commitChanges_thrift_args)that);
      return false;
    }

    public boolean equals(commitChanges_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_writeNd = true && this.isSetWriteNd();
      boolean that_present_writeNd = true && that.isSetWriteNd();
      if (this_present_writeNd || that_present_writeNd) {
        if (!(this_present_writeNd && that_present_writeNd))
          return false;
        if (!this.writeNd.equals(that.writeNd))
          return false;
      }

      boolean this_present_read = true && this.isSetRead();
      boolean that_present_read = true && that.isSetRead();
      if (this_present_read || that_present_read) {
        if (!(this_present_read && that_present_read))
          return false;
        if (!this.read.equals(that.read))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_writeNd = true && (isSetWriteNd());
      list.add(present_writeNd);
      if (present_writeNd)
        list.add(writeNd);

      boolean present_read = true && (isSetRead());
      list.add(present_read);
      if (present_read)
        list.add(read);

      return list.hashCode();
    }

    @Override
    public int compareTo(commitChanges_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetWriteNd()).compareTo(other.isSetWriteNd());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetWriteNd()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.writeNd, other.writeNd);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetRead()).compareTo(other.isSetRead());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetRead()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.read, other.read);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("commitChanges_thrift_args(");
      boolean first = true;

      sb.append("writeNd:");
      if (this.writeNd == null) {
        sb.append("null");
      } else {
        sb.append(this.writeNd);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("read:");
      if (this.read == null) {
        sb.append("null");
      } else {
        sb.append(this.read);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class commitChanges_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public commitChanges_thrift_argsStandardScheme getScheme() {
        return new commitChanges_thrift_argsStandardScheme();
      }
    }

    private static class commitChanges_thrift_argsStandardScheme extends StandardScheme<commitChanges_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, commitChanges_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // WRITE_ND
              if (schemeField.type == org.apache.thrift.protocol.TType.SET) {
                {
                  org.apache.thrift.protocol.TSet _set110 = iprot.readSetBegin();
                  struct.writeNd = new HashSet<NodeData_thrift>(2*_set110.size);
                  NodeData_thrift _elem111;
                  for (int _i112 = 0; _i112 < _set110.size; ++_i112)
                  {
                    _elem111 = new NodeData_thrift();
                    _elem111.read(iprot);
                    struct.writeNd.add(_elem111);
                  }
                  iprot.readSetEnd();
                }
                struct.setWriteNdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // READ
              if (schemeField.type == org.apache.thrift.protocol.TType.MAP) {
                {
                  org.apache.thrift.protocol.TMap _map113 = iprot.readMapBegin();
                  struct.read = new HashMap<String,Long>(2*_map113.size);
                  String _key114;
                  long _val115;
                  for (int _i116 = 0; _i116 < _map113.size; ++_i116)
                  {
                    _key114 = iprot.readString();
                    _val115 = iprot.readI64();
                    struct.read.put(_key114, _val115);
                  }
                  iprot.readMapEnd();
                }
                struct.setReadIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, commitChanges_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.writeNd != null) {
          oprot.writeFieldBegin(WRITE_ND_FIELD_DESC);
          {
            oprot.writeSetBegin(new org.apache.thrift.protocol.TSet(org.apache.thrift.protocol.TType.STRUCT, struct.writeNd.size()));
            for (NodeData_thrift _iter117 : struct.writeNd)
            {
              _iter117.write(oprot);
            }
            oprot.writeSetEnd();
          }
          oprot.writeFieldEnd();
        }
        if (struct.read != null) {
          oprot.writeFieldBegin(READ_FIELD_DESC);
          {
            oprot.writeMapBegin(new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.I64, struct.read.size()));
            for (Map.Entry<String, Long> _iter118 : struct.read.entrySet())
            {
              oprot.writeString(_iter118.getKey());
              oprot.writeI64(_iter118.getValue());
            }
            oprot.writeMapEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class commitChanges_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public commitChanges_thrift_argsTupleScheme getScheme() {
        return new commitChanges_thrift_argsTupleScheme();
      }
    }

    private static class commitChanges_thrift_argsTupleScheme extends TupleScheme<commitChanges_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, commitChanges_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetWriteNd()) {
          optionals.set(0);
        }
        if (struct.isSetRead()) {
          optionals.set(1);
        }
        oprot.writeBitSet(optionals, 2);
        if (struct.isSetWriteNd()) {
          {
            oprot.writeI32(struct.writeNd.size());
            for (NodeData_thrift _iter119 : struct.writeNd)
            {
              _iter119.write(oprot);
            }
          }
        }
        if (struct.isSetRead()) {
          {
            oprot.writeI32(struct.read.size());
            for (Map.Entry<String, Long> _iter120 : struct.read.entrySet())
            {
              oprot.writeString(_iter120.getKey());
              oprot.writeI64(_iter120.getValue());
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, commitChanges_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(2);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TSet _set121 = new org.apache.thrift.protocol.TSet(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
            struct.writeNd = new HashSet<NodeData_thrift>(2*_set121.size);
            NodeData_thrift _elem122;
            for (int _i123 = 0; _i123 < _set121.size; ++_i123)
            {
              _elem122 = new NodeData_thrift();
              _elem122.read(iprot);
              struct.writeNd.add(_elem122);
            }
          }
          struct.setWriteNdIsSet(true);
        }
        if (incoming.get(1)) {
          {
            org.apache.thrift.protocol.TMap _map124 = new org.apache.thrift.protocol.TMap(org.apache.thrift.protocol.TType.STRING, org.apache.thrift.protocol.TType.I64, iprot.readI32());
            struct.read = new HashMap<String,Long>(2*_map124.size);
            String _key125;
            long _val126;
            for (int _i127 = 0; _i127 < _map124.size; ++_i127)
            {
              _key125 = iprot.readString();
              _val126 = iprot.readI64();
              struct.read.put(_key125, _val126);
            }
          }
          struct.setReadIsSet(true);
        }
      }
    }

  }

  public static class commitChanges_thrift_result implements org.apache.thrift.TBase<commitChanges_thrift_result, commitChanges_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<commitChanges_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("commitChanges_thrift_result");


    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new commitChanges_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new commitChanges_thrift_resultTupleSchemeFactory());
    }


    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(commitChanges_thrift_result.class, metaDataMap);
    }

    public commitChanges_thrift_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public commitChanges_thrift_result(commitChanges_thrift_result other) {
    }

    public commitChanges_thrift_result deepCopy() {
      return new commitChanges_thrift_result(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof commitChanges_thrift_result)
        return this.equals((commitChanges_thrift_result)that);
      return false;
    }

    public boolean equals(commitChanges_thrift_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      return list.hashCode();
    }

    @Override
    public int compareTo(commitChanges_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("commitChanges_thrift_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class commitChanges_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public commitChanges_thrift_resultStandardScheme getScheme() {
        return new commitChanges_thrift_resultStandardScheme();
      }
    }

    private static class commitChanges_thrift_resultStandardScheme extends StandardScheme<commitChanges_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, commitChanges_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, commitChanges_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class commitChanges_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public commitChanges_thrift_resultTupleScheme getScheme() {
        return new commitChanges_thrift_resultTupleScheme();
      }
    }

    private static class commitChanges_thrift_resultTupleScheme extends TupleScheme<commitChanges_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, commitChanges_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, commitChanges_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
      }
    }

  }

}
