/*
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * % Beehive Parallel Programming Framework
 * % © Regents of the University of Minnesota.
 * % This software is licensed under GPL v3.0 (https://www.gnu.org/licenses/gpl-3.0.en.html) open source license.
 * %     For an alternative license please contact the Office for Technology Commercialization at the University of Minnesota.
 * %
 * % How to cite:
 * %     If you use this software for your work, please use the following citation:
 * %   Anand Tripathi, Vinit Padhye, Tara Sasank Sunkara, Jeremy Tucker, Bhagavathi Dhass Thirunavukarasu, Varun Pandey, Rahul R. Sharma,
 * %   "A Transactional Model for Parallel Programming of Graph Applications on Computing Clusters,"
 * %   2017 IEEE 10th International Conference on Cloud Computing (CLOUD), Honolulu, HI, USA, June 25-30, 2017.
 * %
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */

/**
 * Autogenerated by Thrift Compiler (0.9.3)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package beehive.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (0.9.3)", date = "2017-12-22")
public class PeerInterface_thrift {

  public interface Iface {

    public long reportCompletion_peer_thrift(long commitTS) throws org.apache.thrift.TException;

    public long reportCompletionBatch_peer_thrift(List<Long> commitTS) throws org.apache.thrift.TException;

    public PeerResponse_thrift validate_peer_thrift(long startTS, RWSetInfo_thrift rwSet, long transactionId) throws org.apache.thrift.TException;

    public long getSTS_peer_thrift() throws org.apache.thrift.TException;

    public List<Long> getCtsSts_peer_thrift() throws org.apache.thrift.TException;

    public PeerResponse_thrift commit_peer_thrift(long startTS, long commitTS, long transactionId) throws org.apache.thrift.TException;

    public PeerResponse_thrift abort_peer_thrift(long startTS, long transactionId, boolean bReleaseLock) throws org.apache.thrift.TException;

  }

  public interface AsyncIface {

    public void reportCompletion_peer_thrift(long commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void reportCompletionBatch_peer_thrift(List<Long> commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void validate_peer_thrift(long startTS, RWSetInfo_thrift rwSet, long transactionId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void getSTS_peer_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void getCtsSts_peer_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void commit_peer_thrift(long startTS, long commitTS, long transactionId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

    public void abort_peer_thrift(long startTS, long transactionId, boolean bReleaseLock, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException;

  }

  public static class Client extends org.apache.thrift.TServiceClient implements Iface {
    public static class Factory implements org.apache.thrift.TServiceClientFactory<Client> {
      public Factory() {}
      public Client getClient(org.apache.thrift.protocol.TProtocol prot) {
        return new Client(prot);
      }
      public Client getClient(org.apache.thrift.protocol.TProtocol iprot, org.apache.thrift.protocol.TProtocol oprot) {
        return new Client(iprot, oprot);
      }
    }

    public Client(org.apache.thrift.protocol.TProtocol prot)
    {
      super(prot, prot);
    }

    public Client(org.apache.thrift.protocol.TProtocol iprot, org.apache.thrift.protocol.TProtocol oprot) {
      super(iprot, oprot);
    }

    public long reportCompletion_peer_thrift(long commitTS) throws org.apache.thrift.TException
    {
      send_reportCompletion_peer_thrift(commitTS);
      return recv_reportCompletion_peer_thrift();
    }

    public void send_reportCompletion_peer_thrift(long commitTS) throws org.apache.thrift.TException
    {
      reportCompletion_peer_thrift_args args = new reportCompletion_peer_thrift_args();
      args.setCommitTS(commitTS);
      sendBase("reportCompletion_peer_thrift", args);
    }

    public long recv_reportCompletion_peer_thrift() throws org.apache.thrift.TException
    {
      reportCompletion_peer_thrift_result result = new reportCompletion_peer_thrift_result();
      receiveBase(result, "reportCompletion_peer_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "reportCompletion_peer_thrift failed: unknown result");
    }

    public long reportCompletionBatch_peer_thrift(List<Long> commitTS) throws org.apache.thrift.TException
    {
      send_reportCompletionBatch_peer_thrift(commitTS);
      return recv_reportCompletionBatch_peer_thrift();
    }

    public void send_reportCompletionBatch_peer_thrift(List<Long> commitTS) throws org.apache.thrift.TException
    {
      reportCompletionBatch_peer_thrift_args args = new reportCompletionBatch_peer_thrift_args();
      args.setCommitTS(commitTS);
      sendBase("reportCompletionBatch_peer_thrift", args);
    }

    public long recv_reportCompletionBatch_peer_thrift() throws org.apache.thrift.TException
    {
      reportCompletionBatch_peer_thrift_result result = new reportCompletionBatch_peer_thrift_result();
      receiveBase(result, "reportCompletionBatch_peer_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "reportCompletionBatch_peer_thrift failed: unknown result");
    }

    public PeerResponse_thrift validate_peer_thrift(long startTS, RWSetInfo_thrift rwSet, long transactionId) throws org.apache.thrift.TException
    {
      send_validate_peer_thrift(startTS, rwSet, transactionId);
      return recv_validate_peer_thrift();
    }

    public void send_validate_peer_thrift(long startTS, RWSetInfo_thrift rwSet, long transactionId) throws org.apache.thrift.TException
    {
      validate_peer_thrift_args args = new validate_peer_thrift_args();
      args.setStartTS(startTS);
      args.setRwSet(rwSet);
      args.setTransactionId(transactionId);
      sendBase("validate_peer_thrift", args);
    }

    public PeerResponse_thrift recv_validate_peer_thrift() throws org.apache.thrift.TException
    {
      validate_peer_thrift_result result = new validate_peer_thrift_result();
      receiveBase(result, "validate_peer_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "validate_peer_thrift failed: unknown result");
    }

    public long getSTS_peer_thrift() throws org.apache.thrift.TException
    {
      send_getSTS_peer_thrift();
      return recv_getSTS_peer_thrift();
    }

    public void send_getSTS_peer_thrift() throws org.apache.thrift.TException
    {
      getSTS_peer_thrift_args args = new getSTS_peer_thrift_args();
      sendBase("getSTS_peer_thrift", args);
    }

    public long recv_getSTS_peer_thrift() throws org.apache.thrift.TException
    {
      getSTS_peer_thrift_result result = new getSTS_peer_thrift_result();
      receiveBase(result, "getSTS_peer_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "getSTS_peer_thrift failed: unknown result");
    }

    public List<Long> getCtsSts_peer_thrift() throws org.apache.thrift.TException
    {
      send_getCtsSts_peer_thrift();
      return recv_getCtsSts_peer_thrift();
    }

    public void send_getCtsSts_peer_thrift() throws org.apache.thrift.TException
    {
      getCtsSts_peer_thrift_args args = new getCtsSts_peer_thrift_args();
      sendBase("getCtsSts_peer_thrift", args);
    }

    public List<Long> recv_getCtsSts_peer_thrift() throws org.apache.thrift.TException
    {
      getCtsSts_peer_thrift_result result = new getCtsSts_peer_thrift_result();
      receiveBase(result, "getCtsSts_peer_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "getCtsSts_peer_thrift failed: unknown result");
    }

    public PeerResponse_thrift commit_peer_thrift(long startTS, long commitTS, long transactionId) throws org.apache.thrift.TException
    {
      send_commit_peer_thrift(startTS, commitTS, transactionId);
      return recv_commit_peer_thrift();
    }

    public void send_commit_peer_thrift(long startTS, long commitTS, long transactionId) throws org.apache.thrift.TException
    {
      commit_peer_thrift_args args = new commit_peer_thrift_args();
      args.setStartTS(startTS);
      args.setCommitTS(commitTS);
      args.setTransactionId(transactionId);
      sendBase("commit_peer_thrift", args);
    }

    public PeerResponse_thrift recv_commit_peer_thrift() throws org.apache.thrift.TException
    {
      commit_peer_thrift_result result = new commit_peer_thrift_result();
      receiveBase(result, "commit_peer_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "commit_peer_thrift failed: unknown result");
    }

    public PeerResponse_thrift abort_peer_thrift(long startTS, long transactionId, boolean bReleaseLock) throws org.apache.thrift.TException
    {
      send_abort_peer_thrift(startTS, transactionId, bReleaseLock);
      return recv_abort_peer_thrift();
    }

    public void send_abort_peer_thrift(long startTS, long transactionId, boolean bReleaseLock) throws org.apache.thrift.TException
    {
      abort_peer_thrift_args args = new abort_peer_thrift_args();
      args.setStartTS(startTS);
      args.setTransactionId(transactionId);
      args.setBReleaseLock(bReleaseLock);
      sendBase("abort_peer_thrift", args);
    }

    public PeerResponse_thrift recv_abort_peer_thrift() throws org.apache.thrift.TException
    {
      abort_peer_thrift_result result = new abort_peer_thrift_result();
      receiveBase(result, "abort_peer_thrift");
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.MISSING_RESULT, "abort_peer_thrift failed: unknown result");
    }

  }
  public static class AsyncClient extends org.apache.thrift.async.TAsyncClient implements AsyncIface {
    public static class Factory implements org.apache.thrift.async.TAsyncClientFactory<AsyncClient> {
      private org.apache.thrift.async.TAsyncClientManager clientManager;
      private org.apache.thrift.protocol.TProtocolFactory protocolFactory;
      public Factory(org.apache.thrift.async.TAsyncClientManager clientManager, org.apache.thrift.protocol.TProtocolFactory protocolFactory) {
        this.clientManager = clientManager;
        this.protocolFactory = protocolFactory;
      }
      public AsyncClient getAsyncClient(org.apache.thrift.transport.TNonblockingTransport transport) {
        return new AsyncClient(protocolFactory, clientManager, transport);
      }
    }

    public AsyncClient(org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.async.TAsyncClientManager clientManager, org.apache.thrift.transport.TNonblockingTransport transport) {
      super(protocolFactory, clientManager, transport);
    }

    public void reportCompletion_peer_thrift(long commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      reportCompletion_peer_thrift_call method_call = new reportCompletion_peer_thrift_call(commitTS, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class reportCompletion_peer_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private long commitTS;
      public reportCompletion_peer_thrift_call(long commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.commitTS = commitTS;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("reportCompletion_peer_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        reportCompletion_peer_thrift_args args = new reportCompletion_peer_thrift_args();
        args.setCommitTS(commitTS);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public long getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_reportCompletion_peer_thrift();
      }
    }

    public void reportCompletionBatch_peer_thrift(List<Long> commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      reportCompletionBatch_peer_thrift_call method_call = new reportCompletionBatch_peer_thrift_call(commitTS, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class reportCompletionBatch_peer_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private List<Long> commitTS;
      public reportCompletionBatch_peer_thrift_call(List<Long> commitTS, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.commitTS = commitTS;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("reportCompletionBatch_peer_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        reportCompletionBatch_peer_thrift_args args = new reportCompletionBatch_peer_thrift_args();
        args.setCommitTS(commitTS);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public long getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_reportCompletionBatch_peer_thrift();
      }
    }

    public void validate_peer_thrift(long startTS, RWSetInfo_thrift rwSet, long transactionId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      validate_peer_thrift_call method_call = new validate_peer_thrift_call(startTS, rwSet, transactionId, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class validate_peer_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private long startTS;
      private RWSetInfo_thrift rwSet;
      private long transactionId;
      public validate_peer_thrift_call(long startTS, RWSetInfo_thrift rwSet, long transactionId, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.startTS = startTS;
        this.rwSet = rwSet;
        this.transactionId = transactionId;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("validate_peer_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        validate_peer_thrift_args args = new validate_peer_thrift_args();
        args.setStartTS(startTS);
        args.setRwSet(rwSet);
        args.setTransactionId(transactionId);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public PeerResponse_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_validate_peer_thrift();
      }
    }

    public void getSTS_peer_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      getSTS_peer_thrift_call method_call = new getSTS_peer_thrift_call(resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class getSTS_peer_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      public getSTS_peer_thrift_call(org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("getSTS_peer_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        getSTS_peer_thrift_args args = new getSTS_peer_thrift_args();
        args.write(prot);
        prot.writeMessageEnd();
      }

      public long getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getSTS_peer_thrift();
      }
    }

    public void getCtsSts_peer_thrift(org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      getCtsSts_peer_thrift_call method_call = new getCtsSts_peer_thrift_call(resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class getCtsSts_peer_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      public getCtsSts_peer_thrift_call(org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("getCtsSts_peer_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        getCtsSts_peer_thrift_args args = new getCtsSts_peer_thrift_args();
        args.write(prot);
        prot.writeMessageEnd();
      }

      public List<Long> getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getCtsSts_peer_thrift();
      }
    }

    public void commit_peer_thrift(long startTS, long commitTS, long transactionId, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      commit_peer_thrift_call method_call = new commit_peer_thrift_call(startTS, commitTS, transactionId, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class commit_peer_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private long startTS;
      private long commitTS;
      private long transactionId;
      public commit_peer_thrift_call(long startTS, long commitTS, long transactionId, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.startTS = startTS;
        this.commitTS = commitTS;
        this.transactionId = transactionId;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("commit_peer_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        commit_peer_thrift_args args = new commit_peer_thrift_args();
        args.setStartTS(startTS);
        args.setCommitTS(commitTS);
        args.setTransactionId(transactionId);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public PeerResponse_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_commit_peer_thrift();
      }
    }

    public void abort_peer_thrift(long startTS, long transactionId, boolean bReleaseLock, org.apache.thrift.async.AsyncMethodCallback resultHandler) throws org.apache.thrift.TException {
      checkReady();
      abort_peer_thrift_call method_call = new abort_peer_thrift_call(startTS, transactionId, bReleaseLock, resultHandler, this, ___protocolFactory, ___transport);
      this.___currentMethod = method_call;
      ___manager.call(method_call);
    }

    public static class abort_peer_thrift_call extends org.apache.thrift.async.TAsyncMethodCall {
      private long startTS;
      private long transactionId;
      private boolean bReleaseLock;
      public abort_peer_thrift_call(long startTS, long transactionId, boolean bReleaseLock, org.apache.thrift.async.AsyncMethodCallback resultHandler, org.apache.thrift.async.TAsyncClient client, org.apache.thrift.protocol.TProtocolFactory protocolFactory, org.apache.thrift.transport.TNonblockingTransport transport) throws org.apache.thrift.TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.startTS = startTS;
        this.transactionId = transactionId;
        this.bReleaseLock = bReleaseLock;
      }

      public void write_args(org.apache.thrift.protocol.TProtocol prot) throws org.apache.thrift.TException {
        prot.writeMessageBegin(new org.apache.thrift.protocol.TMessage("abort_peer_thrift", org.apache.thrift.protocol.TMessageType.CALL, 0));
        abort_peer_thrift_args args = new abort_peer_thrift_args();
        args.setStartTS(startTS);
        args.setTransactionId(transactionId);
        args.setBReleaseLock(bReleaseLock);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public PeerResponse_thrift getResult() throws org.apache.thrift.TException {
        if (getState() != org.apache.thrift.async.TAsyncMethodCall.State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        org.apache.thrift.transport.TMemoryInputTransport memoryTransport = new org.apache.thrift.transport.TMemoryInputTransport(getFrameBuffer().array());
        org.apache.thrift.protocol.TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_abort_peer_thrift();
      }
    }

  }

  public static class Processor<I extends Iface> extends org.apache.thrift.TBaseProcessor<I> implements org.apache.thrift.TProcessor {
    private static final Logger LOGGER = LoggerFactory.getLogger(Processor.class.getName());
    public Processor(I iface) {
      super(iface, getProcessMap(new HashMap<String, org.apache.thrift.ProcessFunction<I, ? extends org.apache.thrift.TBase>>()));
    }

    protected Processor(I iface, Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> processMap) {
      super(iface, getProcessMap(processMap));
    }

    private static <I extends Iface> Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> getProcessMap(Map<String,  org.apache.thrift.ProcessFunction<I, ? extends  org.apache.thrift.TBase>> processMap) {
      processMap.put("reportCompletion_peer_thrift", new reportCompletion_peer_thrift());
      processMap.put("reportCompletionBatch_peer_thrift", new reportCompletionBatch_peer_thrift());
      processMap.put("validate_peer_thrift", new validate_peer_thrift());
      processMap.put("getSTS_peer_thrift", new getSTS_peer_thrift());
      processMap.put("getCtsSts_peer_thrift", new getCtsSts_peer_thrift());
      processMap.put("commit_peer_thrift", new commit_peer_thrift());
      processMap.put("abort_peer_thrift", new abort_peer_thrift());
      return processMap;
    }

    public static class reportCompletion_peer_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, reportCompletion_peer_thrift_args> {
      public reportCompletion_peer_thrift() {
        super("reportCompletion_peer_thrift");
      }

      public reportCompletion_peer_thrift_args getEmptyArgsInstance() {
        return new reportCompletion_peer_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public reportCompletion_peer_thrift_result getResult(I iface, reportCompletion_peer_thrift_args args) throws org.apache.thrift.TException {
        reportCompletion_peer_thrift_result result = new reportCompletion_peer_thrift_result();
        result.success = iface.reportCompletion_peer_thrift(args.commitTS);
        result.setSuccessIsSet(true);
        return result;
      }
    }

    public static class reportCompletionBatch_peer_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, reportCompletionBatch_peer_thrift_args> {
      public reportCompletionBatch_peer_thrift() {
        super("reportCompletionBatch_peer_thrift");
      }

      public reportCompletionBatch_peer_thrift_args getEmptyArgsInstance() {
        return new reportCompletionBatch_peer_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public reportCompletionBatch_peer_thrift_result getResult(I iface, reportCompletionBatch_peer_thrift_args args) throws org.apache.thrift.TException {
        reportCompletionBatch_peer_thrift_result result = new reportCompletionBatch_peer_thrift_result();
        result.success = iface.reportCompletionBatch_peer_thrift(args.commitTS);
        result.setSuccessIsSet(true);
        return result;
      }
    }

    public static class validate_peer_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, validate_peer_thrift_args> {
      public validate_peer_thrift() {
        super("validate_peer_thrift");
      }

      public validate_peer_thrift_args getEmptyArgsInstance() {
        return new validate_peer_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public validate_peer_thrift_result getResult(I iface, validate_peer_thrift_args args) throws org.apache.thrift.TException {
        validate_peer_thrift_result result = new validate_peer_thrift_result();
        result.success = iface.validate_peer_thrift(args.startTS, args.rwSet, args.transactionId);
        return result;
      }
    }

    public static class getSTS_peer_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, getSTS_peer_thrift_args> {
      public getSTS_peer_thrift() {
        super("getSTS_peer_thrift");
      }

      public getSTS_peer_thrift_args getEmptyArgsInstance() {
        return new getSTS_peer_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public getSTS_peer_thrift_result getResult(I iface, getSTS_peer_thrift_args args) throws org.apache.thrift.TException {
        getSTS_peer_thrift_result result = new getSTS_peer_thrift_result();
        result.success = iface.getSTS_peer_thrift();
        result.setSuccessIsSet(true);
        return result;
      }
    }

    public static class getCtsSts_peer_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, getCtsSts_peer_thrift_args> {
      public getCtsSts_peer_thrift() {
        super("getCtsSts_peer_thrift");
      }

      public getCtsSts_peer_thrift_args getEmptyArgsInstance() {
        return new getCtsSts_peer_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public getCtsSts_peer_thrift_result getResult(I iface, getCtsSts_peer_thrift_args args) throws org.apache.thrift.TException {
        getCtsSts_peer_thrift_result result = new getCtsSts_peer_thrift_result();
        result.success = iface.getCtsSts_peer_thrift();
        return result;
      }
    }

    public static class commit_peer_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, commit_peer_thrift_args> {
      public commit_peer_thrift() {
        super("commit_peer_thrift");
      }

      public commit_peer_thrift_args getEmptyArgsInstance() {
        return new commit_peer_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public commit_peer_thrift_result getResult(I iface, commit_peer_thrift_args args) throws org.apache.thrift.TException {
        commit_peer_thrift_result result = new commit_peer_thrift_result();
        result.success = iface.commit_peer_thrift(args.startTS, args.commitTS, args.transactionId);
        return result;
      }
    }

    public static class abort_peer_thrift<I extends Iface> extends org.apache.thrift.ProcessFunction<I, abort_peer_thrift_args> {
      public abort_peer_thrift() {
        super("abort_peer_thrift");
      }

      public abort_peer_thrift_args getEmptyArgsInstance() {
        return new abort_peer_thrift_args();
      }

      protected boolean isOneway() {
        return false;
      }

      public abort_peer_thrift_result getResult(I iface, abort_peer_thrift_args args) throws org.apache.thrift.TException {
        abort_peer_thrift_result result = new abort_peer_thrift_result();
        result.success = iface.abort_peer_thrift(args.startTS, args.transactionId, args.bReleaseLock);
        return result;
      }
    }

  }

  public static class AsyncProcessor<I extends AsyncIface> extends org.apache.thrift.TBaseAsyncProcessor<I> {
    private static final Logger LOGGER = LoggerFactory.getLogger(AsyncProcessor.class.getName());
    public AsyncProcessor(I iface) {
      super(iface, getProcessMap(new HashMap<String, org.apache.thrift.AsyncProcessFunction<I, ? extends org.apache.thrift.TBase, ?>>()));
    }

    protected AsyncProcessor(I iface, Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase, ?>> processMap) {
      super(iface, getProcessMap(processMap));
    }

    private static <I extends AsyncIface> Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase,?>> getProcessMap(Map<String,  org.apache.thrift.AsyncProcessFunction<I, ? extends  org.apache.thrift.TBase, ?>> processMap) {
      processMap.put("reportCompletion_peer_thrift", new reportCompletion_peer_thrift());
      processMap.put("reportCompletionBatch_peer_thrift", new reportCompletionBatch_peer_thrift());
      processMap.put("validate_peer_thrift", new validate_peer_thrift());
      processMap.put("getSTS_peer_thrift", new getSTS_peer_thrift());
      processMap.put("getCtsSts_peer_thrift", new getCtsSts_peer_thrift());
      processMap.put("commit_peer_thrift", new commit_peer_thrift());
      processMap.put("abort_peer_thrift", new abort_peer_thrift());
      return processMap;
    }

    public static class reportCompletion_peer_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, reportCompletion_peer_thrift_args, Long> {
      public reportCompletion_peer_thrift() {
        super("reportCompletion_peer_thrift");
      }

      public reportCompletion_peer_thrift_args getEmptyArgsInstance() {
        return new reportCompletion_peer_thrift_args();
      }

      public AsyncMethodCallback<Long> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Long>() { 
          public void onComplete(Long o) {
            reportCompletion_peer_thrift_result result = new reportCompletion_peer_thrift_result();
            result.success = o;
            result.setSuccessIsSet(true);
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            reportCompletion_peer_thrift_result result = new reportCompletion_peer_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, reportCompletion_peer_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Long> resultHandler) throws TException {
        iface.reportCompletion_peer_thrift(args.commitTS,resultHandler);
      }
    }

    public static class reportCompletionBatch_peer_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, reportCompletionBatch_peer_thrift_args, Long> {
      public reportCompletionBatch_peer_thrift() {
        super("reportCompletionBatch_peer_thrift");
      }

      public reportCompletionBatch_peer_thrift_args getEmptyArgsInstance() {
        return new reportCompletionBatch_peer_thrift_args();
      }

      public AsyncMethodCallback<Long> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Long>() { 
          public void onComplete(Long o) {
            reportCompletionBatch_peer_thrift_result result = new reportCompletionBatch_peer_thrift_result();
            result.success = o;
            result.setSuccessIsSet(true);
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            reportCompletionBatch_peer_thrift_result result = new reportCompletionBatch_peer_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, reportCompletionBatch_peer_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Long> resultHandler) throws TException {
        iface.reportCompletionBatch_peer_thrift(args.commitTS,resultHandler);
      }
    }

    public static class validate_peer_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, validate_peer_thrift_args, PeerResponse_thrift> {
      public validate_peer_thrift() {
        super("validate_peer_thrift");
      }

      public validate_peer_thrift_args getEmptyArgsInstance() {
        return new validate_peer_thrift_args();
      }

      public AsyncMethodCallback<PeerResponse_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<PeerResponse_thrift>() { 
          public void onComplete(PeerResponse_thrift o) {
            validate_peer_thrift_result result = new validate_peer_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            validate_peer_thrift_result result = new validate_peer_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, validate_peer_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<PeerResponse_thrift> resultHandler) throws TException {
        iface.validate_peer_thrift(args.startTS, args.rwSet, args.transactionId,resultHandler);
      }
    }

    public static class getSTS_peer_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, getSTS_peer_thrift_args, Long> {
      public getSTS_peer_thrift() {
        super("getSTS_peer_thrift");
      }

      public getSTS_peer_thrift_args getEmptyArgsInstance() {
        return new getSTS_peer_thrift_args();
      }

      public AsyncMethodCallback<Long> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<Long>() { 
          public void onComplete(Long o) {
            getSTS_peer_thrift_result result = new getSTS_peer_thrift_result();
            result.success = o;
            result.setSuccessIsSet(true);
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            getSTS_peer_thrift_result result = new getSTS_peer_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, getSTS_peer_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<Long> resultHandler) throws TException {
        iface.getSTS_peer_thrift(resultHandler);
      }
    }

    public static class getCtsSts_peer_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, getCtsSts_peer_thrift_args, List<Long>> {
      public getCtsSts_peer_thrift() {
        super("getCtsSts_peer_thrift");
      }

      public getCtsSts_peer_thrift_args getEmptyArgsInstance() {
        return new getCtsSts_peer_thrift_args();
      }

      public AsyncMethodCallback<List<Long>> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<List<Long>>() { 
          public void onComplete(List<Long> o) {
            getCtsSts_peer_thrift_result result = new getCtsSts_peer_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            getCtsSts_peer_thrift_result result = new getCtsSts_peer_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, getCtsSts_peer_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<List<Long>> resultHandler) throws TException {
        iface.getCtsSts_peer_thrift(resultHandler);
      }
    }

    public static class commit_peer_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, commit_peer_thrift_args, PeerResponse_thrift> {
      public commit_peer_thrift() {
        super("commit_peer_thrift");
      }

      public commit_peer_thrift_args getEmptyArgsInstance() {
        return new commit_peer_thrift_args();
      }

      public AsyncMethodCallback<PeerResponse_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<PeerResponse_thrift>() { 
          public void onComplete(PeerResponse_thrift o) {
            commit_peer_thrift_result result = new commit_peer_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            commit_peer_thrift_result result = new commit_peer_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, commit_peer_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<PeerResponse_thrift> resultHandler) throws TException {
        iface.commit_peer_thrift(args.startTS, args.commitTS, args.transactionId,resultHandler);
      }
    }

    public static class abort_peer_thrift<I extends AsyncIface> extends org.apache.thrift.AsyncProcessFunction<I, abort_peer_thrift_args, PeerResponse_thrift> {
      public abort_peer_thrift() {
        super("abort_peer_thrift");
      }

      public abort_peer_thrift_args getEmptyArgsInstance() {
        return new abort_peer_thrift_args();
      }

      public AsyncMethodCallback<PeerResponse_thrift> getResultHandler(final AsyncFrameBuffer fb, final int seqid) {
        final org.apache.thrift.AsyncProcessFunction fcall = this;
        return new AsyncMethodCallback<PeerResponse_thrift>() { 
          public void onComplete(PeerResponse_thrift o) {
            abort_peer_thrift_result result = new abort_peer_thrift_result();
            result.success = o;
            try {
              fcall.sendResponse(fb,result, org.apache.thrift.protocol.TMessageType.REPLY,seqid);
              return;
            } catch (Exception e) {
              LOGGER.error("Exception writing to internal frame buffer", e);
            }
            fb.close();
          }
          public void onError(Exception e) {
            byte msgType = org.apache.thrift.protocol.TMessageType.REPLY;
            org.apache.thrift.TBase msg;
            abort_peer_thrift_result result = new abort_peer_thrift_result();
            {
              msgType = org.apache.thrift.protocol.TMessageType.EXCEPTION;
              msg = (org.apache.thrift.TBase)new org.apache.thrift.TApplicationException(org.apache.thrift.TApplicationException.INTERNAL_ERROR, e.getMessage());
            }
            try {
              fcall.sendResponse(fb,msg,msgType,seqid);
              return;
            } catch (Exception ex) {
              LOGGER.error("Exception writing to internal frame buffer", ex);
            }
            fb.close();
          }
        };
      }

      protected boolean isOneway() {
        return false;
      }

      public void start(I iface, abort_peer_thrift_args args, org.apache.thrift.async.AsyncMethodCallback<PeerResponse_thrift> resultHandler) throws TException {
        iface.abort_peer_thrift(args.startTS, args.transactionId, args.bReleaseLock,resultHandler);
      }
    }

  }

  public static class reportCompletion_peer_thrift_args implements org.apache.thrift.TBase<reportCompletion_peer_thrift_args, reportCompletion_peer_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletion_peer_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletion_peer_thrift_args");

    private static final org.apache.thrift.protocol.TField COMMIT_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("commitTS", org.apache.thrift.protocol.TType.I64, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletion_peer_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletion_peer_thrift_argsTupleSchemeFactory());
    }

    public long commitTS; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      COMMIT_TS((short)1, "commitTS");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // COMMIT_TS
            return COMMIT_TS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __COMMITTS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.COMMIT_TS, new org.apache.thrift.meta_data.FieldMetaData("commitTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletion_peer_thrift_args.class, metaDataMap);
    }

    public reportCompletion_peer_thrift_args() {
    }

    public reportCompletion_peer_thrift_args(
      long commitTS)
    {
      this();
      this.commitTS = commitTS;
      setCommitTSIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletion_peer_thrift_args(reportCompletion_peer_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.commitTS = other.commitTS;
    }

    public reportCompletion_peer_thrift_args deepCopy() {
      return new reportCompletion_peer_thrift_args(this);
    }

    @Override
    public void clear() {
      setCommitTSIsSet(false);
      this.commitTS = 0;
    }

    public long getCommitTS() {
      return this.commitTS;
    }

    public reportCompletion_peer_thrift_args setCommitTS(long commitTS) {
      this.commitTS = commitTS;
      setCommitTSIsSet(true);
      return this;
    }

    public void unsetCommitTS() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __COMMITTS_ISSET_ID);
    }

    /** Returns true if field commitTS is set (has been assigned a value) and false otherwise */
    public boolean isSetCommitTS() {
      return EncodingUtils.testBit(__isset_bitfield, __COMMITTS_ISSET_ID);
    }

    public void setCommitTSIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __COMMITTS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case COMMIT_TS:
        if (value == null) {
          unsetCommitTS();
        } else {
          setCommitTS((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case COMMIT_TS:
        return getCommitTS();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case COMMIT_TS:
        return isSetCommitTS();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletion_peer_thrift_args)
        return this.equals((reportCompletion_peer_thrift_args)that);
      return false;
    }

    public boolean equals(reportCompletion_peer_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_commitTS = true;
      boolean that_present_commitTS = true;
      if (this_present_commitTS || that_present_commitTS) {
        if (!(this_present_commitTS && that_present_commitTS))
          return false;
        if (this.commitTS != that.commitTS)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_commitTS = true;
      list.add(present_commitTS);
      if (present_commitTS)
        list.add(commitTS);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletion_peer_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetCommitTS()).compareTo(other.isSetCommitTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetCommitTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.commitTS, other.commitTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletion_peer_thrift_args(");
      boolean first = true;

      sb.append("commitTS:");
      sb.append(this.commitTS);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletion_peer_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public reportCompletion_peer_thrift_argsStandardScheme getScheme() {
        return new reportCompletion_peer_thrift_argsStandardScheme();
      }
    }

    private static class reportCompletion_peer_thrift_argsStandardScheme extends StandardScheme<reportCompletion_peer_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletion_peer_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // COMMIT_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.commitTS = iprot.readI64();
                struct.setCommitTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletion_peer_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(COMMIT_TS_FIELD_DESC);
        oprot.writeI64(struct.commitTS);
        oprot.writeFieldEnd();
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletion_peer_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public reportCompletion_peer_thrift_argsTupleScheme getScheme() {
        return new reportCompletion_peer_thrift_argsTupleScheme();
      }
    }

    private static class reportCompletion_peer_thrift_argsTupleScheme extends TupleScheme<reportCompletion_peer_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletion_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetCommitTS()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetCommitTS()) {
          oprot.writeI64(struct.commitTS);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletion_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.commitTS = iprot.readI64();
          struct.setCommitTSIsSet(true);
        }
      }
    }

  }

  public static class reportCompletion_peer_thrift_result implements org.apache.thrift.TBase<reportCompletion_peer_thrift_result, reportCompletion_peer_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletion_peer_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletion_peer_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.I64, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletion_peer_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletion_peer_thrift_resultTupleSchemeFactory());
    }

    public long success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletion_peer_thrift_result.class, metaDataMap);
    }

    public reportCompletion_peer_thrift_result() {
    }

    public reportCompletion_peer_thrift_result(
      long success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletion_peer_thrift_result(reportCompletion_peer_thrift_result other) {
      __isset_bitfield = other.__isset_bitfield;
      this.success = other.success;
    }

    public reportCompletion_peer_thrift_result deepCopy() {
      return new reportCompletion_peer_thrift_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = 0;
    }

    public long getSuccess() {
      return this.success;
    }

    public reportCompletion_peer_thrift_result setSuccess(long success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return EncodingUtils.testBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletion_peer_thrift_result)
        return this.equals((reportCompletion_peer_thrift_result)that);
      return false;
    }

    public boolean equals(reportCompletion_peer_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true;
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletion_peer_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletion_peer_thrift_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletion_peer_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public reportCompletion_peer_thrift_resultStandardScheme getScheme() {
        return new reportCompletion_peer_thrift_resultStandardScheme();
      }
    }

    private static class reportCompletion_peer_thrift_resultStandardScheme extends StandardScheme<reportCompletion_peer_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletion_peer_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.success = iprot.readI64();
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletion_peer_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.isSetSuccess()) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          oprot.writeI64(struct.success);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletion_peer_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public reportCompletion_peer_thrift_resultTupleScheme getScheme() {
        return new reportCompletion_peer_thrift_resultTupleScheme();
      }
    }

    private static class reportCompletion_peer_thrift_resultTupleScheme extends TupleScheme<reportCompletion_peer_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletion_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          oprot.writeI64(struct.success);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletion_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = iprot.readI64();
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class reportCompletionBatch_peer_thrift_args implements org.apache.thrift.TBase<reportCompletionBatch_peer_thrift_args, reportCompletionBatch_peer_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletionBatch_peer_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletionBatch_peer_thrift_args");

    private static final org.apache.thrift.protocol.TField COMMIT_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("commitTS", org.apache.thrift.protocol.TType.LIST, (short)1);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletionBatch_peer_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletionBatch_peer_thrift_argsTupleSchemeFactory());
    }

    public List<Long> commitTS; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      COMMIT_TS((short)1, "commitTS");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // COMMIT_TS
            return COMMIT_TS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.COMMIT_TS, new org.apache.thrift.meta_data.FieldMetaData("commitTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64              , "long"))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletionBatch_peer_thrift_args.class, metaDataMap);
    }

    public reportCompletionBatch_peer_thrift_args() {
    }

    public reportCompletionBatch_peer_thrift_args(
      List<Long> commitTS)
    {
      this();
      this.commitTS = commitTS;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletionBatch_peer_thrift_args(reportCompletionBatch_peer_thrift_args other) {
      if (other.isSetCommitTS()) {
        List<Long> __this__commitTS = new ArrayList<Long>(other.commitTS.size());
        for (Long other_element : other.commitTS) {
          __this__commitTS.add(other_element);
        }
        this.commitTS = __this__commitTS;
      }
    }

    public reportCompletionBatch_peer_thrift_args deepCopy() {
      return new reportCompletionBatch_peer_thrift_args(this);
    }

    @Override
    public void clear() {
      this.commitTS = null;
    }

    public int getCommitTSSize() {
      return (this.commitTS == null) ? 0 : this.commitTS.size();
    }

    public java.util.Iterator<Long> getCommitTSIterator() {
      return (this.commitTS == null) ? null : this.commitTS.iterator();
    }

    public void addToCommitTS(long elem) {
      if (this.commitTS == null) {
        this.commitTS = new ArrayList<Long>();
      }
      this.commitTS.add(elem);
    }

    public List<Long> getCommitTS() {
      return this.commitTS;
    }

    public reportCompletionBatch_peer_thrift_args setCommitTS(List<Long> commitTS) {
      this.commitTS = commitTS;
      return this;
    }

    public void unsetCommitTS() {
      this.commitTS = null;
    }

    /** Returns true if field commitTS is set (has been assigned a value) and false otherwise */
    public boolean isSetCommitTS() {
      return this.commitTS != null;
    }

    public void setCommitTSIsSet(boolean value) {
      if (!value) {
        this.commitTS = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case COMMIT_TS:
        if (value == null) {
          unsetCommitTS();
        } else {
          setCommitTS((List<Long>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case COMMIT_TS:
        return getCommitTS();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case COMMIT_TS:
        return isSetCommitTS();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletionBatch_peer_thrift_args)
        return this.equals((reportCompletionBatch_peer_thrift_args)that);
      return false;
    }

    public boolean equals(reportCompletionBatch_peer_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_commitTS = true && this.isSetCommitTS();
      boolean that_present_commitTS = true && that.isSetCommitTS();
      if (this_present_commitTS || that_present_commitTS) {
        if (!(this_present_commitTS && that_present_commitTS))
          return false;
        if (!this.commitTS.equals(that.commitTS))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_commitTS = true && (isSetCommitTS());
      list.add(present_commitTS);
      if (present_commitTS)
        list.add(commitTS);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletionBatch_peer_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetCommitTS()).compareTo(other.isSetCommitTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetCommitTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.commitTS, other.commitTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletionBatch_peer_thrift_args(");
      boolean first = true;

      sb.append("commitTS:");
      if (this.commitTS == null) {
        sb.append("null");
      } else {
        sb.append(this.commitTS);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletionBatch_peer_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_peer_thrift_argsStandardScheme getScheme() {
        return new reportCompletionBatch_peer_thrift_argsStandardScheme();
      }
    }

    private static class reportCompletionBatch_peer_thrift_argsStandardScheme extends StandardScheme<reportCompletionBatch_peer_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletionBatch_peer_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // COMMIT_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list58 = iprot.readListBegin();
                  struct.commitTS = new ArrayList<Long>(_list58.size);
                  long _elem59;
                  for (int _i60 = 0; _i60 < _list58.size; ++_i60)
                  {
                    _elem59 = iprot.readI64();
                    struct.commitTS.add(_elem59);
                  }
                  iprot.readListEnd();
                }
                struct.setCommitTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletionBatch_peer_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.commitTS != null) {
          oprot.writeFieldBegin(COMMIT_TS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, struct.commitTS.size()));
            for (long _iter61 : struct.commitTS)
            {
              oprot.writeI64(_iter61);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletionBatch_peer_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_peer_thrift_argsTupleScheme getScheme() {
        return new reportCompletionBatch_peer_thrift_argsTupleScheme();
      }
    }

    private static class reportCompletionBatch_peer_thrift_argsTupleScheme extends TupleScheme<reportCompletionBatch_peer_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetCommitTS()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetCommitTS()) {
          {
            oprot.writeI32(struct.commitTS.size());
            for (long _iter62 : struct.commitTS)
            {
              oprot.writeI64(_iter62);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list63 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, iprot.readI32());
            struct.commitTS = new ArrayList<Long>(_list63.size);
            long _elem64;
            for (int _i65 = 0; _i65 < _list63.size; ++_i65)
            {
              _elem64 = iprot.readI64();
              struct.commitTS.add(_elem64);
            }
          }
          struct.setCommitTSIsSet(true);
        }
      }
    }

  }

  public static class reportCompletionBatch_peer_thrift_result implements org.apache.thrift.TBase<reportCompletionBatch_peer_thrift_result, reportCompletionBatch_peer_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<reportCompletionBatch_peer_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("reportCompletionBatch_peer_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.I64, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new reportCompletionBatch_peer_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new reportCompletionBatch_peer_thrift_resultTupleSchemeFactory());
    }

    public long success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(reportCompletionBatch_peer_thrift_result.class, metaDataMap);
    }

    public reportCompletionBatch_peer_thrift_result() {
    }

    public reportCompletionBatch_peer_thrift_result(
      long success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public reportCompletionBatch_peer_thrift_result(reportCompletionBatch_peer_thrift_result other) {
      __isset_bitfield = other.__isset_bitfield;
      this.success = other.success;
    }

    public reportCompletionBatch_peer_thrift_result deepCopy() {
      return new reportCompletionBatch_peer_thrift_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = 0;
    }

    public long getSuccess() {
      return this.success;
    }

    public reportCompletionBatch_peer_thrift_result setSuccess(long success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return EncodingUtils.testBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof reportCompletionBatch_peer_thrift_result)
        return this.equals((reportCompletionBatch_peer_thrift_result)that);
      return false;
    }

    public boolean equals(reportCompletionBatch_peer_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true;
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(reportCompletionBatch_peer_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("reportCompletionBatch_peer_thrift_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class reportCompletionBatch_peer_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_peer_thrift_resultStandardScheme getScheme() {
        return new reportCompletionBatch_peer_thrift_resultStandardScheme();
      }
    }

    private static class reportCompletionBatch_peer_thrift_resultStandardScheme extends StandardScheme<reportCompletionBatch_peer_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, reportCompletionBatch_peer_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.success = iprot.readI64();
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, reportCompletionBatch_peer_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.isSetSuccess()) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          oprot.writeI64(struct.success);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class reportCompletionBatch_peer_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public reportCompletionBatch_peer_thrift_resultTupleScheme getScheme() {
        return new reportCompletionBatch_peer_thrift_resultTupleScheme();
      }
    }

    private static class reportCompletionBatch_peer_thrift_resultTupleScheme extends TupleScheme<reportCompletionBatch_peer_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          oprot.writeI64(struct.success);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, reportCompletionBatch_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = iprot.readI64();
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class validate_peer_thrift_args implements org.apache.thrift.TBase<validate_peer_thrift_args, validate_peer_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<validate_peer_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("validate_peer_thrift_args");

    private static final org.apache.thrift.protocol.TField START_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("startTS", org.apache.thrift.protocol.TType.I64, (short)1);
    private static final org.apache.thrift.protocol.TField RW_SET_FIELD_DESC = new org.apache.thrift.protocol.TField("rwSet", org.apache.thrift.protocol.TType.STRUCT, (short)2);
    private static final org.apache.thrift.protocol.TField TRANSACTION_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("transactionId", org.apache.thrift.protocol.TType.I64, (short)3);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new validate_peer_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new validate_peer_thrift_argsTupleSchemeFactory());
    }

    public long startTS; // required
    public RWSetInfo_thrift rwSet; // required
    public long transactionId; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      START_TS((short)1, "startTS"),
      RW_SET((short)2, "rwSet"),
      TRANSACTION_ID((short)3, "transactionId");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // START_TS
            return START_TS;
          case 2: // RW_SET
            return RW_SET;
          case 3: // TRANSACTION_ID
            return TRANSACTION_ID;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __STARTTS_ISSET_ID = 0;
    private static final int __TRANSACTIONID_ISSET_ID = 1;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.START_TS, new org.apache.thrift.meta_data.FieldMetaData("startTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      tmpMap.put(_Fields.RW_SET, new org.apache.thrift.meta_data.FieldMetaData("rwSet", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, RWSetInfo_thrift.class)));
      tmpMap.put(_Fields.TRANSACTION_ID, new org.apache.thrift.meta_data.FieldMetaData("transactionId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(validate_peer_thrift_args.class, metaDataMap);
    }

    public validate_peer_thrift_args() {
    }

    public validate_peer_thrift_args(
      long startTS,
      RWSetInfo_thrift rwSet,
      long transactionId)
    {
      this();
      this.startTS = startTS;
      setStartTSIsSet(true);
      this.rwSet = rwSet;
      this.transactionId = transactionId;
      setTransactionIdIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public validate_peer_thrift_args(validate_peer_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.startTS = other.startTS;
      if (other.isSetRwSet()) {
        this.rwSet = new RWSetInfo_thrift(other.rwSet);
      }
      this.transactionId = other.transactionId;
    }

    public validate_peer_thrift_args deepCopy() {
      return new validate_peer_thrift_args(this);
    }

    @Override
    public void clear() {
      setStartTSIsSet(false);
      this.startTS = 0;
      this.rwSet = null;
      setTransactionIdIsSet(false);
      this.transactionId = 0;
    }

    public long getStartTS() {
      return this.startTS;
    }

    public validate_peer_thrift_args setStartTS(long startTS) {
      this.startTS = startTS;
      setStartTSIsSet(true);
      return this;
    }

    public void unsetStartTS() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    /** Returns true if field startTS is set (has been assigned a value) and false otherwise */
    public boolean isSetStartTS() {
      return EncodingUtils.testBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    public void setStartTSIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __STARTTS_ISSET_ID, value);
    }

    public RWSetInfo_thrift getRwSet() {
      return this.rwSet;
    }

    public validate_peer_thrift_args setRwSet(RWSetInfo_thrift rwSet) {
      this.rwSet = rwSet;
      return this;
    }

    public void unsetRwSet() {
      this.rwSet = null;
    }

    /** Returns true if field rwSet is set (has been assigned a value) and false otherwise */
    public boolean isSetRwSet() {
      return this.rwSet != null;
    }

    public void setRwSetIsSet(boolean value) {
      if (!value) {
        this.rwSet = null;
      }
    }

    public long getTransactionId() {
      return this.transactionId;
    }

    public validate_peer_thrift_args setTransactionId(long transactionId) {
      this.transactionId = transactionId;
      setTransactionIdIsSet(true);
      return this;
    }

    public void unsetTransactionId() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID);
    }

    /** Returns true if field transactionId is set (has been assigned a value) and false otherwise */
    public boolean isSetTransactionId() {
      return EncodingUtils.testBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID);
    }

    public void setTransactionIdIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case START_TS:
        if (value == null) {
          unsetStartTS();
        } else {
          setStartTS((Long)value);
        }
        break;

      case RW_SET:
        if (value == null) {
          unsetRwSet();
        } else {
          setRwSet((RWSetInfo_thrift)value);
        }
        break;

      case TRANSACTION_ID:
        if (value == null) {
          unsetTransactionId();
        } else {
          setTransactionId((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case START_TS:
        return getStartTS();

      case RW_SET:
        return getRwSet();

      case TRANSACTION_ID:
        return getTransactionId();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case START_TS:
        return isSetStartTS();
      case RW_SET:
        return isSetRwSet();
      case TRANSACTION_ID:
        return isSetTransactionId();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof validate_peer_thrift_args)
        return this.equals((validate_peer_thrift_args)that);
      return false;
    }

    public boolean equals(validate_peer_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_startTS = true;
      boolean that_present_startTS = true;
      if (this_present_startTS || that_present_startTS) {
        if (!(this_present_startTS && that_present_startTS))
          return false;
        if (this.startTS != that.startTS)
          return false;
      }

      boolean this_present_rwSet = true && this.isSetRwSet();
      boolean that_present_rwSet = true && that.isSetRwSet();
      if (this_present_rwSet || that_present_rwSet) {
        if (!(this_present_rwSet && that_present_rwSet))
          return false;
        if (!this.rwSet.equals(that.rwSet))
          return false;
      }

      boolean this_present_transactionId = true;
      boolean that_present_transactionId = true;
      if (this_present_transactionId || that_present_transactionId) {
        if (!(this_present_transactionId && that_present_transactionId))
          return false;
        if (this.transactionId != that.transactionId)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_startTS = true;
      list.add(present_startTS);
      if (present_startTS)
        list.add(startTS);

      boolean present_rwSet = true && (isSetRwSet());
      list.add(present_rwSet);
      if (present_rwSet)
        list.add(rwSet);

      boolean present_transactionId = true;
      list.add(present_transactionId);
      if (present_transactionId)
        list.add(transactionId);

      return list.hashCode();
    }

    @Override
    public int compareTo(validate_peer_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetStartTS()).compareTo(other.isSetStartTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetStartTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.startTS, other.startTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetRwSet()).compareTo(other.isSetRwSet());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetRwSet()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.rwSet, other.rwSet);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetTransactionId()).compareTo(other.isSetTransactionId());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetTransactionId()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.transactionId, other.transactionId);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("validate_peer_thrift_args(");
      boolean first = true;

      sb.append("startTS:");
      sb.append(this.startTS);
      first = false;
      if (!first) sb.append(", ");
      sb.append("rwSet:");
      if (this.rwSet == null) {
        sb.append("null");
      } else {
        sb.append(this.rwSet);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("transactionId:");
      sb.append(this.transactionId);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (rwSet != null) {
        rwSet.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class validate_peer_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public validate_peer_thrift_argsStandardScheme getScheme() {
        return new validate_peer_thrift_argsStandardScheme();
      }
    }

    private static class validate_peer_thrift_argsStandardScheme extends StandardScheme<validate_peer_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, validate_peer_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // START_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.startTS = iprot.readI64();
                struct.setStartTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // RW_SET
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.rwSet = new RWSetInfo_thrift();
                struct.rwSet.read(iprot);
                struct.setRwSetIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 3: // TRANSACTION_ID
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.transactionId = iprot.readI64();
                struct.setTransactionIdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, validate_peer_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(START_TS_FIELD_DESC);
        oprot.writeI64(struct.startTS);
        oprot.writeFieldEnd();
        if (struct.rwSet != null) {
          oprot.writeFieldBegin(RW_SET_FIELD_DESC);
          struct.rwSet.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldBegin(TRANSACTION_ID_FIELD_DESC);
        oprot.writeI64(struct.transactionId);
        oprot.writeFieldEnd();
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class validate_peer_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public validate_peer_thrift_argsTupleScheme getScheme() {
        return new validate_peer_thrift_argsTupleScheme();
      }
    }

    private static class validate_peer_thrift_argsTupleScheme extends TupleScheme<validate_peer_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, validate_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetStartTS()) {
          optionals.set(0);
        }
        if (struct.isSetRwSet()) {
          optionals.set(1);
        }
        if (struct.isSetTransactionId()) {
          optionals.set(2);
        }
        oprot.writeBitSet(optionals, 3);
        if (struct.isSetStartTS()) {
          oprot.writeI64(struct.startTS);
        }
        if (struct.isSetRwSet()) {
          struct.rwSet.write(oprot);
        }
        if (struct.isSetTransactionId()) {
          oprot.writeI64(struct.transactionId);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, validate_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(3);
        if (incoming.get(0)) {
          struct.startTS = iprot.readI64();
          struct.setStartTSIsSet(true);
        }
        if (incoming.get(1)) {
          struct.rwSet = new RWSetInfo_thrift();
          struct.rwSet.read(iprot);
          struct.setRwSetIsSet(true);
        }
        if (incoming.get(2)) {
          struct.transactionId = iprot.readI64();
          struct.setTransactionIdIsSet(true);
        }
      }
    }

  }

  public static class validate_peer_thrift_result implements org.apache.thrift.TBase<validate_peer_thrift_result, validate_peer_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<validate_peer_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("validate_peer_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new validate_peer_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new validate_peer_thrift_resultTupleSchemeFactory());
    }

    public PeerResponse_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, PeerResponse_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(validate_peer_thrift_result.class, metaDataMap);
    }

    public validate_peer_thrift_result() {
    }

    public validate_peer_thrift_result(
      PeerResponse_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public validate_peer_thrift_result(validate_peer_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new PeerResponse_thrift(other.success);
      }
    }

    public validate_peer_thrift_result deepCopy() {
      return new validate_peer_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public PeerResponse_thrift getSuccess() {
      return this.success;
    }

    public validate_peer_thrift_result setSuccess(PeerResponse_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((PeerResponse_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof validate_peer_thrift_result)
        return this.equals((validate_peer_thrift_result)that);
      return false;
    }

    public boolean equals(validate_peer_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(validate_peer_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("validate_peer_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class validate_peer_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public validate_peer_thrift_resultStandardScheme getScheme() {
        return new validate_peer_thrift_resultStandardScheme();
      }
    }

    private static class validate_peer_thrift_resultStandardScheme extends StandardScheme<validate_peer_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, validate_peer_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new PeerResponse_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, validate_peer_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class validate_peer_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public validate_peer_thrift_resultTupleScheme getScheme() {
        return new validate_peer_thrift_resultTupleScheme();
      }
    }

    private static class validate_peer_thrift_resultTupleScheme extends TupleScheme<validate_peer_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, validate_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, validate_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new PeerResponse_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class getSTS_peer_thrift_args implements org.apache.thrift.TBase<getSTS_peer_thrift_args, getSTS_peer_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<getSTS_peer_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getSTS_peer_thrift_args");


    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getSTS_peer_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getSTS_peer_thrift_argsTupleSchemeFactory());
    }


    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getSTS_peer_thrift_args.class, metaDataMap);
    }

    public getSTS_peer_thrift_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getSTS_peer_thrift_args(getSTS_peer_thrift_args other) {
    }

    public getSTS_peer_thrift_args deepCopy() {
      return new getSTS_peer_thrift_args(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getSTS_peer_thrift_args)
        return this.equals((getSTS_peer_thrift_args)that);
      return false;
    }

    public boolean equals(getSTS_peer_thrift_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      return list.hashCode();
    }

    @Override
    public int compareTo(getSTS_peer_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getSTS_peer_thrift_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getSTS_peer_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public getSTS_peer_thrift_argsStandardScheme getScheme() {
        return new getSTS_peer_thrift_argsStandardScheme();
      }
    }

    private static class getSTS_peer_thrift_argsStandardScheme extends StandardScheme<getSTS_peer_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getSTS_peer_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getSTS_peer_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getSTS_peer_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public getSTS_peer_thrift_argsTupleScheme getScheme() {
        return new getSTS_peer_thrift_argsTupleScheme();
      }
    }

    private static class getSTS_peer_thrift_argsTupleScheme extends TupleScheme<getSTS_peer_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getSTS_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getSTS_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
      }
    }

  }

  public static class getSTS_peer_thrift_result implements org.apache.thrift.TBase<getSTS_peer_thrift_result, getSTS_peer_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<getSTS_peer_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getSTS_peer_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.I64, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getSTS_peer_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getSTS_peer_thrift_resultTupleSchemeFactory());
    }

    public long success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getSTS_peer_thrift_result.class, metaDataMap);
    }

    public getSTS_peer_thrift_result() {
    }

    public getSTS_peer_thrift_result(
      long success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getSTS_peer_thrift_result(getSTS_peer_thrift_result other) {
      __isset_bitfield = other.__isset_bitfield;
      this.success = other.success;
    }

    public getSTS_peer_thrift_result deepCopy() {
      return new getSTS_peer_thrift_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = 0;
    }

    public long getSuccess() {
      return this.success;
    }

    public getSTS_peer_thrift_result setSuccess(long success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return EncodingUtils.testBit(__isset_bitfield, __SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getSTS_peer_thrift_result)
        return this.equals((getSTS_peer_thrift_result)that);
      return false;
    }

    public boolean equals(getSTS_peer_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true;
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(getSTS_peer_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getSTS_peer_thrift_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getSTS_peer_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public getSTS_peer_thrift_resultStandardScheme getScheme() {
        return new getSTS_peer_thrift_resultStandardScheme();
      }
    }

    private static class getSTS_peer_thrift_resultStandardScheme extends StandardScheme<getSTS_peer_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getSTS_peer_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.success = iprot.readI64();
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getSTS_peer_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.isSetSuccess()) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          oprot.writeI64(struct.success);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getSTS_peer_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public getSTS_peer_thrift_resultTupleScheme getScheme() {
        return new getSTS_peer_thrift_resultTupleScheme();
      }
    }

    private static class getSTS_peer_thrift_resultTupleScheme extends TupleScheme<getSTS_peer_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getSTS_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          oprot.writeI64(struct.success);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getSTS_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = iprot.readI64();
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class getCtsSts_peer_thrift_args implements org.apache.thrift.TBase<getCtsSts_peer_thrift_args, getCtsSts_peer_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<getCtsSts_peer_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getCtsSts_peer_thrift_args");


    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getCtsSts_peer_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getCtsSts_peer_thrift_argsTupleSchemeFactory());
    }


    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getCtsSts_peer_thrift_args.class, metaDataMap);
    }

    public getCtsSts_peer_thrift_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getCtsSts_peer_thrift_args(getCtsSts_peer_thrift_args other) {
    }

    public getCtsSts_peer_thrift_args deepCopy() {
      return new getCtsSts_peer_thrift_args(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getCtsSts_peer_thrift_args)
        return this.equals((getCtsSts_peer_thrift_args)that);
      return false;
    }

    public boolean equals(getCtsSts_peer_thrift_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      return list.hashCode();
    }

    @Override
    public int compareTo(getCtsSts_peer_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getCtsSts_peer_thrift_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getCtsSts_peer_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public getCtsSts_peer_thrift_argsStandardScheme getScheme() {
        return new getCtsSts_peer_thrift_argsStandardScheme();
      }
    }

    private static class getCtsSts_peer_thrift_argsStandardScheme extends StandardScheme<getCtsSts_peer_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getCtsSts_peer_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getCtsSts_peer_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getCtsSts_peer_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public getCtsSts_peer_thrift_argsTupleScheme getScheme() {
        return new getCtsSts_peer_thrift_argsTupleScheme();
      }
    }

    private static class getCtsSts_peer_thrift_argsTupleScheme extends TupleScheme<getCtsSts_peer_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getCtsSts_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getCtsSts_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
      }
    }

  }

  public static class getCtsSts_peer_thrift_result implements org.apache.thrift.TBase<getCtsSts_peer_thrift_result, getCtsSts_peer_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<getCtsSts_peer_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("getCtsSts_peer_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.LIST, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new getCtsSts_peer_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new getCtsSts_peer_thrift_resultTupleSchemeFactory());
    }

    public List<Long> success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
              new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64              , "long"))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(getCtsSts_peer_thrift_result.class, metaDataMap);
    }

    public getCtsSts_peer_thrift_result() {
    }

    public getCtsSts_peer_thrift_result(
      List<Long> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getCtsSts_peer_thrift_result(getCtsSts_peer_thrift_result other) {
      if (other.isSetSuccess()) {
        List<Long> __this__success = new ArrayList<Long>(other.success.size());
        for (Long other_element : other.success) {
          __this__success.add(other_element);
        }
        this.success = __this__success;
      }
    }

    public getCtsSts_peer_thrift_result deepCopy() {
      return new getCtsSts_peer_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<Long> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(long elem) {
      if (this.success == null) {
        this.success = new ArrayList<Long>();
      }
      this.success.add(elem);
    }

    public List<Long> getSuccess() {
      return this.success;
    }

    public getCtsSts_peer_thrift_result setSuccess(List<Long> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<Long>)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getCtsSts_peer_thrift_result)
        return this.equals((getCtsSts_peer_thrift_result)that);
      return false;
    }

    public boolean equals(getCtsSts_peer_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(getCtsSts_peer_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getCtsSts_peer_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class getCtsSts_peer_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public getCtsSts_peer_thrift_resultStandardScheme getScheme() {
        return new getCtsSts_peer_thrift_resultStandardScheme();
      }
    }

    private static class getCtsSts_peer_thrift_resultStandardScheme extends StandardScheme<getCtsSts_peer_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, getCtsSts_peer_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
                {
                  org.apache.thrift.protocol.TList _list66 = iprot.readListBegin();
                  struct.success = new ArrayList<Long>(_list66.size);
                  long _elem67;
                  for (int _i68 = 0; _i68 < _list66.size; ++_i68)
                  {
                    _elem67 = iprot.readI64();
                    struct.success.add(_elem67);
                  }
                  iprot.readListEnd();
                }
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, getCtsSts_peer_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, struct.success.size()));
            for (long _iter69 : struct.success)
            {
              oprot.writeI64(_iter69);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class getCtsSts_peer_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public getCtsSts_peer_thrift_resultTupleScheme getScheme() {
        return new getCtsSts_peer_thrift_resultTupleScheme();
      }
    }

    private static class getCtsSts_peer_thrift_resultTupleScheme extends TupleScheme<getCtsSts_peer_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, getCtsSts_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          {
            oprot.writeI32(struct.success.size());
            for (long _iter70 : struct.success)
            {
              oprot.writeI64(_iter70);
            }
          }
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, getCtsSts_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          {
            org.apache.thrift.protocol.TList _list71 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.I64, iprot.readI32());
            struct.success = new ArrayList<Long>(_list71.size);
            long _elem72;
            for (int _i73 = 0; _i73 < _list71.size; ++_i73)
            {
              _elem72 = iprot.readI64();
              struct.success.add(_elem72);
            }
          }
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class commit_peer_thrift_args implements org.apache.thrift.TBase<commit_peer_thrift_args, commit_peer_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<commit_peer_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("commit_peer_thrift_args");

    private static final org.apache.thrift.protocol.TField START_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("startTS", org.apache.thrift.protocol.TType.I64, (short)1);
    private static final org.apache.thrift.protocol.TField COMMIT_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("commitTS", org.apache.thrift.protocol.TType.I64, (short)2);
    private static final org.apache.thrift.protocol.TField TRANSACTION_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("transactionId", org.apache.thrift.protocol.TType.I64, (short)3);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new commit_peer_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new commit_peer_thrift_argsTupleSchemeFactory());
    }

    public long startTS; // required
    public long commitTS; // required
    public long transactionId; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      START_TS((short)1, "startTS"),
      COMMIT_TS((short)2, "commitTS"),
      TRANSACTION_ID((short)3, "transactionId");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // START_TS
            return START_TS;
          case 2: // COMMIT_TS
            return COMMIT_TS;
          case 3: // TRANSACTION_ID
            return TRANSACTION_ID;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __STARTTS_ISSET_ID = 0;
    private static final int __COMMITTS_ISSET_ID = 1;
    private static final int __TRANSACTIONID_ISSET_ID = 2;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.START_TS, new org.apache.thrift.meta_data.FieldMetaData("startTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      tmpMap.put(_Fields.COMMIT_TS, new org.apache.thrift.meta_data.FieldMetaData("commitTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      tmpMap.put(_Fields.TRANSACTION_ID, new org.apache.thrift.meta_data.FieldMetaData("transactionId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(commit_peer_thrift_args.class, metaDataMap);
    }

    public commit_peer_thrift_args() {
    }

    public commit_peer_thrift_args(
      long startTS,
      long commitTS,
      long transactionId)
    {
      this();
      this.startTS = startTS;
      setStartTSIsSet(true);
      this.commitTS = commitTS;
      setCommitTSIsSet(true);
      this.transactionId = transactionId;
      setTransactionIdIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public commit_peer_thrift_args(commit_peer_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.startTS = other.startTS;
      this.commitTS = other.commitTS;
      this.transactionId = other.transactionId;
    }

    public commit_peer_thrift_args deepCopy() {
      return new commit_peer_thrift_args(this);
    }

    @Override
    public void clear() {
      setStartTSIsSet(false);
      this.startTS = 0;
      setCommitTSIsSet(false);
      this.commitTS = 0;
      setTransactionIdIsSet(false);
      this.transactionId = 0;
    }

    public long getStartTS() {
      return this.startTS;
    }

    public commit_peer_thrift_args setStartTS(long startTS) {
      this.startTS = startTS;
      setStartTSIsSet(true);
      return this;
    }

    public void unsetStartTS() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    /** Returns true if field startTS is set (has been assigned a value) and false otherwise */
    public boolean isSetStartTS() {
      return EncodingUtils.testBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    public void setStartTSIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __STARTTS_ISSET_ID, value);
    }

    public long getCommitTS() {
      return this.commitTS;
    }

    public commit_peer_thrift_args setCommitTS(long commitTS) {
      this.commitTS = commitTS;
      setCommitTSIsSet(true);
      return this;
    }

    public void unsetCommitTS() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __COMMITTS_ISSET_ID);
    }

    /** Returns true if field commitTS is set (has been assigned a value) and false otherwise */
    public boolean isSetCommitTS() {
      return EncodingUtils.testBit(__isset_bitfield, __COMMITTS_ISSET_ID);
    }

    public void setCommitTSIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __COMMITTS_ISSET_ID, value);
    }

    public long getTransactionId() {
      return this.transactionId;
    }

    public commit_peer_thrift_args setTransactionId(long transactionId) {
      this.transactionId = transactionId;
      setTransactionIdIsSet(true);
      return this;
    }

    public void unsetTransactionId() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID);
    }

    /** Returns true if field transactionId is set (has been assigned a value) and false otherwise */
    public boolean isSetTransactionId() {
      return EncodingUtils.testBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID);
    }

    public void setTransactionIdIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case START_TS:
        if (value == null) {
          unsetStartTS();
        } else {
          setStartTS((Long)value);
        }
        break;

      case COMMIT_TS:
        if (value == null) {
          unsetCommitTS();
        } else {
          setCommitTS((Long)value);
        }
        break;

      case TRANSACTION_ID:
        if (value == null) {
          unsetTransactionId();
        } else {
          setTransactionId((Long)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case START_TS:
        return getStartTS();

      case COMMIT_TS:
        return getCommitTS();

      case TRANSACTION_ID:
        return getTransactionId();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case START_TS:
        return isSetStartTS();
      case COMMIT_TS:
        return isSetCommitTS();
      case TRANSACTION_ID:
        return isSetTransactionId();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof commit_peer_thrift_args)
        return this.equals((commit_peer_thrift_args)that);
      return false;
    }

    public boolean equals(commit_peer_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_startTS = true;
      boolean that_present_startTS = true;
      if (this_present_startTS || that_present_startTS) {
        if (!(this_present_startTS && that_present_startTS))
          return false;
        if (this.startTS != that.startTS)
          return false;
      }

      boolean this_present_commitTS = true;
      boolean that_present_commitTS = true;
      if (this_present_commitTS || that_present_commitTS) {
        if (!(this_present_commitTS && that_present_commitTS))
          return false;
        if (this.commitTS != that.commitTS)
          return false;
      }

      boolean this_present_transactionId = true;
      boolean that_present_transactionId = true;
      if (this_present_transactionId || that_present_transactionId) {
        if (!(this_present_transactionId && that_present_transactionId))
          return false;
        if (this.transactionId != that.transactionId)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_startTS = true;
      list.add(present_startTS);
      if (present_startTS)
        list.add(startTS);

      boolean present_commitTS = true;
      list.add(present_commitTS);
      if (present_commitTS)
        list.add(commitTS);

      boolean present_transactionId = true;
      list.add(present_transactionId);
      if (present_transactionId)
        list.add(transactionId);

      return list.hashCode();
    }

    @Override
    public int compareTo(commit_peer_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetStartTS()).compareTo(other.isSetStartTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetStartTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.startTS, other.startTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetCommitTS()).compareTo(other.isSetCommitTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetCommitTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.commitTS, other.commitTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetTransactionId()).compareTo(other.isSetTransactionId());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetTransactionId()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.transactionId, other.transactionId);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("commit_peer_thrift_args(");
      boolean first = true;

      sb.append("startTS:");
      sb.append(this.startTS);
      first = false;
      if (!first) sb.append(", ");
      sb.append("commitTS:");
      sb.append(this.commitTS);
      first = false;
      if (!first) sb.append(", ");
      sb.append("transactionId:");
      sb.append(this.transactionId);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class commit_peer_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public commit_peer_thrift_argsStandardScheme getScheme() {
        return new commit_peer_thrift_argsStandardScheme();
      }
    }

    private static class commit_peer_thrift_argsStandardScheme extends StandardScheme<commit_peer_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, commit_peer_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // START_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.startTS = iprot.readI64();
                struct.setStartTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // COMMIT_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.commitTS = iprot.readI64();
                struct.setCommitTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 3: // TRANSACTION_ID
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.transactionId = iprot.readI64();
                struct.setTransactionIdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, commit_peer_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(START_TS_FIELD_DESC);
        oprot.writeI64(struct.startTS);
        oprot.writeFieldEnd();
        oprot.writeFieldBegin(COMMIT_TS_FIELD_DESC);
        oprot.writeI64(struct.commitTS);
        oprot.writeFieldEnd();
        oprot.writeFieldBegin(TRANSACTION_ID_FIELD_DESC);
        oprot.writeI64(struct.transactionId);
        oprot.writeFieldEnd();
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class commit_peer_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public commit_peer_thrift_argsTupleScheme getScheme() {
        return new commit_peer_thrift_argsTupleScheme();
      }
    }

    private static class commit_peer_thrift_argsTupleScheme extends TupleScheme<commit_peer_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, commit_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetStartTS()) {
          optionals.set(0);
        }
        if (struct.isSetCommitTS()) {
          optionals.set(1);
        }
        if (struct.isSetTransactionId()) {
          optionals.set(2);
        }
        oprot.writeBitSet(optionals, 3);
        if (struct.isSetStartTS()) {
          oprot.writeI64(struct.startTS);
        }
        if (struct.isSetCommitTS()) {
          oprot.writeI64(struct.commitTS);
        }
        if (struct.isSetTransactionId()) {
          oprot.writeI64(struct.transactionId);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, commit_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(3);
        if (incoming.get(0)) {
          struct.startTS = iprot.readI64();
          struct.setStartTSIsSet(true);
        }
        if (incoming.get(1)) {
          struct.commitTS = iprot.readI64();
          struct.setCommitTSIsSet(true);
        }
        if (incoming.get(2)) {
          struct.transactionId = iprot.readI64();
          struct.setTransactionIdIsSet(true);
        }
      }
    }

  }

  public static class commit_peer_thrift_result implements org.apache.thrift.TBase<commit_peer_thrift_result, commit_peer_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<commit_peer_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("commit_peer_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new commit_peer_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new commit_peer_thrift_resultTupleSchemeFactory());
    }

    public PeerResponse_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, PeerResponse_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(commit_peer_thrift_result.class, metaDataMap);
    }

    public commit_peer_thrift_result() {
    }

    public commit_peer_thrift_result(
      PeerResponse_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public commit_peer_thrift_result(commit_peer_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new PeerResponse_thrift(other.success);
      }
    }

    public commit_peer_thrift_result deepCopy() {
      return new commit_peer_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public PeerResponse_thrift getSuccess() {
      return this.success;
    }

    public commit_peer_thrift_result setSuccess(PeerResponse_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((PeerResponse_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof commit_peer_thrift_result)
        return this.equals((commit_peer_thrift_result)that);
      return false;
    }

    public boolean equals(commit_peer_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(commit_peer_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("commit_peer_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class commit_peer_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public commit_peer_thrift_resultStandardScheme getScheme() {
        return new commit_peer_thrift_resultStandardScheme();
      }
    }

    private static class commit_peer_thrift_resultStandardScheme extends StandardScheme<commit_peer_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, commit_peer_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new PeerResponse_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, commit_peer_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class commit_peer_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public commit_peer_thrift_resultTupleScheme getScheme() {
        return new commit_peer_thrift_resultTupleScheme();
      }
    }

    private static class commit_peer_thrift_resultTupleScheme extends TupleScheme<commit_peer_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, commit_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, commit_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new PeerResponse_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

  public static class abort_peer_thrift_args implements org.apache.thrift.TBase<abort_peer_thrift_args, abort_peer_thrift_args._Fields>, java.io.Serializable, Cloneable, Comparable<abort_peer_thrift_args>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("abort_peer_thrift_args");

    private static final org.apache.thrift.protocol.TField START_TS_FIELD_DESC = new org.apache.thrift.protocol.TField("startTS", org.apache.thrift.protocol.TType.I64, (short)1);
    private static final org.apache.thrift.protocol.TField TRANSACTION_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("transactionId", org.apache.thrift.protocol.TType.I64, (short)2);
    private static final org.apache.thrift.protocol.TField B_RELEASE_LOCK_FIELD_DESC = new org.apache.thrift.protocol.TField("bReleaseLock", org.apache.thrift.protocol.TType.BOOL, (short)3);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new abort_peer_thrift_argsStandardSchemeFactory());
      schemes.put(TupleScheme.class, new abort_peer_thrift_argsTupleSchemeFactory());
    }

    public long startTS; // required
    public long transactionId; // required
    public boolean bReleaseLock; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      START_TS((short)1, "startTS"),
      TRANSACTION_ID((short)2, "transactionId"),
      B_RELEASE_LOCK((short)3, "bReleaseLock");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // START_TS
            return START_TS;
          case 2: // TRANSACTION_ID
            return TRANSACTION_ID;
          case 3: // B_RELEASE_LOCK
            return B_RELEASE_LOCK;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __STARTTS_ISSET_ID = 0;
    private static final int __TRANSACTIONID_ISSET_ID = 1;
    private static final int __BRELEASELOCK_ISSET_ID = 2;
    private byte __isset_bitfield = 0;
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.START_TS, new org.apache.thrift.meta_data.FieldMetaData("startTS", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      tmpMap.put(_Fields.TRANSACTION_ID, new org.apache.thrift.meta_data.FieldMetaData("transactionId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64          , "long")));
      tmpMap.put(_Fields.B_RELEASE_LOCK, new org.apache.thrift.meta_data.FieldMetaData("bReleaseLock", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BOOL)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(abort_peer_thrift_args.class, metaDataMap);
    }

    public abort_peer_thrift_args() {
    }

    public abort_peer_thrift_args(
      long startTS,
      long transactionId,
      boolean bReleaseLock)
    {
      this();
      this.startTS = startTS;
      setStartTSIsSet(true);
      this.transactionId = transactionId;
      setTransactionIdIsSet(true);
      this.bReleaseLock = bReleaseLock;
      setBReleaseLockIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public abort_peer_thrift_args(abort_peer_thrift_args other) {
      __isset_bitfield = other.__isset_bitfield;
      this.startTS = other.startTS;
      this.transactionId = other.transactionId;
      this.bReleaseLock = other.bReleaseLock;
    }

    public abort_peer_thrift_args deepCopy() {
      return new abort_peer_thrift_args(this);
    }

    @Override
    public void clear() {
      setStartTSIsSet(false);
      this.startTS = 0;
      setTransactionIdIsSet(false);
      this.transactionId = 0;
      setBReleaseLockIsSet(false);
      this.bReleaseLock = false;
    }

    public long getStartTS() {
      return this.startTS;
    }

    public abort_peer_thrift_args setStartTS(long startTS) {
      this.startTS = startTS;
      setStartTSIsSet(true);
      return this;
    }

    public void unsetStartTS() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    /** Returns true if field startTS is set (has been assigned a value) and false otherwise */
    public boolean isSetStartTS() {
      return EncodingUtils.testBit(__isset_bitfield, __STARTTS_ISSET_ID);
    }

    public void setStartTSIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __STARTTS_ISSET_ID, value);
    }

    public long getTransactionId() {
      return this.transactionId;
    }

    public abort_peer_thrift_args setTransactionId(long transactionId) {
      this.transactionId = transactionId;
      setTransactionIdIsSet(true);
      return this;
    }

    public void unsetTransactionId() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID);
    }

    /** Returns true if field transactionId is set (has been assigned a value) and false otherwise */
    public boolean isSetTransactionId() {
      return EncodingUtils.testBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID);
    }

    public void setTransactionIdIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __TRANSACTIONID_ISSET_ID, value);
    }

    public boolean isBReleaseLock() {
      return this.bReleaseLock;
    }

    public abort_peer_thrift_args setBReleaseLock(boolean bReleaseLock) {
      this.bReleaseLock = bReleaseLock;
      setBReleaseLockIsSet(true);
      return this;
    }

    public void unsetBReleaseLock() {
      __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __BRELEASELOCK_ISSET_ID);
    }

    /** Returns true if field bReleaseLock is set (has been assigned a value) and false otherwise */
    public boolean isSetBReleaseLock() {
      return EncodingUtils.testBit(__isset_bitfield, __BRELEASELOCK_ISSET_ID);
    }

    public void setBReleaseLockIsSet(boolean value) {
      __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __BRELEASELOCK_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case START_TS:
        if (value == null) {
          unsetStartTS();
        } else {
          setStartTS((Long)value);
        }
        break;

      case TRANSACTION_ID:
        if (value == null) {
          unsetTransactionId();
        } else {
          setTransactionId((Long)value);
        }
        break;

      case B_RELEASE_LOCK:
        if (value == null) {
          unsetBReleaseLock();
        } else {
          setBReleaseLock((Boolean)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case START_TS:
        return getStartTS();

      case TRANSACTION_ID:
        return getTransactionId();

      case B_RELEASE_LOCK:
        return isBReleaseLock();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case START_TS:
        return isSetStartTS();
      case TRANSACTION_ID:
        return isSetTransactionId();
      case B_RELEASE_LOCK:
        return isSetBReleaseLock();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof abort_peer_thrift_args)
        return this.equals((abort_peer_thrift_args)that);
      return false;
    }

    public boolean equals(abort_peer_thrift_args that) {
      if (that == null)
        return false;

      boolean this_present_startTS = true;
      boolean that_present_startTS = true;
      if (this_present_startTS || that_present_startTS) {
        if (!(this_present_startTS && that_present_startTS))
          return false;
        if (this.startTS != that.startTS)
          return false;
      }

      boolean this_present_transactionId = true;
      boolean that_present_transactionId = true;
      if (this_present_transactionId || that_present_transactionId) {
        if (!(this_present_transactionId && that_present_transactionId))
          return false;
        if (this.transactionId != that.transactionId)
          return false;
      }

      boolean this_present_bReleaseLock = true;
      boolean that_present_bReleaseLock = true;
      if (this_present_bReleaseLock || that_present_bReleaseLock) {
        if (!(this_present_bReleaseLock && that_present_bReleaseLock))
          return false;
        if (this.bReleaseLock != that.bReleaseLock)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_startTS = true;
      list.add(present_startTS);
      if (present_startTS)
        list.add(startTS);

      boolean present_transactionId = true;
      list.add(present_transactionId);
      if (present_transactionId)
        list.add(transactionId);

      boolean present_bReleaseLock = true;
      list.add(present_bReleaseLock);
      if (present_bReleaseLock)
        list.add(bReleaseLock);

      return list.hashCode();
    }

    @Override
    public int compareTo(abort_peer_thrift_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetStartTS()).compareTo(other.isSetStartTS());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetStartTS()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.startTS, other.startTS);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetTransactionId()).compareTo(other.isSetTransactionId());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetTransactionId()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.transactionId, other.transactionId);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetBReleaseLock()).compareTo(other.isSetBReleaseLock());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetBReleaseLock()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.bReleaseLock, other.bReleaseLock);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("abort_peer_thrift_args(");
      boolean first = true;

      sb.append("startTS:");
      sb.append(this.startTS);
      first = false;
      if (!first) sb.append(", ");
      sb.append("transactionId:");
      sb.append(this.transactionId);
      first = false;
      if (!first) sb.append(", ");
      sb.append("bReleaseLock:");
      sb.append(this.bReleaseLock);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
        __isset_bitfield = 0;
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class abort_peer_thrift_argsStandardSchemeFactory implements SchemeFactory {
      public abort_peer_thrift_argsStandardScheme getScheme() {
        return new abort_peer_thrift_argsStandardScheme();
      }
    }

    private static class abort_peer_thrift_argsStandardScheme extends StandardScheme<abort_peer_thrift_args> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, abort_peer_thrift_args struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 1: // START_TS
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.startTS = iprot.readI64();
                struct.setStartTSIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 2: // TRANSACTION_ID
              if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
                struct.transactionId = iprot.readI64();
                struct.setTransactionIdIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            case 3: // B_RELEASE_LOCK
              if (schemeField.type == org.apache.thrift.protocol.TType.BOOL) {
                struct.bReleaseLock = iprot.readBool();
                struct.setBReleaseLockIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, abort_peer_thrift_args struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        oprot.writeFieldBegin(START_TS_FIELD_DESC);
        oprot.writeI64(struct.startTS);
        oprot.writeFieldEnd();
        oprot.writeFieldBegin(TRANSACTION_ID_FIELD_DESC);
        oprot.writeI64(struct.transactionId);
        oprot.writeFieldEnd();
        oprot.writeFieldBegin(B_RELEASE_LOCK_FIELD_DESC);
        oprot.writeBool(struct.bReleaseLock);
        oprot.writeFieldEnd();
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class abort_peer_thrift_argsTupleSchemeFactory implements SchemeFactory {
      public abort_peer_thrift_argsTupleScheme getScheme() {
        return new abort_peer_thrift_argsTupleScheme();
      }
    }

    private static class abort_peer_thrift_argsTupleScheme extends TupleScheme<abort_peer_thrift_args> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, abort_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetStartTS()) {
          optionals.set(0);
        }
        if (struct.isSetTransactionId()) {
          optionals.set(1);
        }
        if (struct.isSetBReleaseLock()) {
          optionals.set(2);
        }
        oprot.writeBitSet(optionals, 3);
        if (struct.isSetStartTS()) {
          oprot.writeI64(struct.startTS);
        }
        if (struct.isSetTransactionId()) {
          oprot.writeI64(struct.transactionId);
        }
        if (struct.isSetBReleaseLock()) {
          oprot.writeBool(struct.bReleaseLock);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, abort_peer_thrift_args struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(3);
        if (incoming.get(0)) {
          struct.startTS = iprot.readI64();
          struct.setStartTSIsSet(true);
        }
        if (incoming.get(1)) {
          struct.transactionId = iprot.readI64();
          struct.setTransactionIdIsSet(true);
        }
        if (incoming.get(2)) {
          struct.bReleaseLock = iprot.readBool();
          struct.setBReleaseLockIsSet(true);
        }
      }
    }

  }

  public static class abort_peer_thrift_result implements org.apache.thrift.TBase<abort_peer_thrift_result, abort_peer_thrift_result._Fields>, java.io.Serializable, Cloneable, Comparable<abort_peer_thrift_result>   {
    private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("abort_peer_thrift_result");

    private static final org.apache.thrift.protocol.TField SUCCESS_FIELD_DESC = new org.apache.thrift.protocol.TField("success", org.apache.thrift.protocol.TType.STRUCT, (short)0);

    private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
    static {
      schemes.put(StandardScheme.class, new abort_peer_thrift_resultStandardSchemeFactory());
      schemes.put(TupleScheme.class, new abort_peer_thrift_resultTupleSchemeFactory());
    }

    public PeerResponse_thrift success; // required

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements org.apache.thrift.TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
    static {
      Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new org.apache.thrift.meta_data.FieldMetaData("success", org.apache.thrift.TFieldRequirementType.DEFAULT, 
          new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, PeerResponse_thrift.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(abort_peer_thrift_result.class, metaDataMap);
    }

    public abort_peer_thrift_result() {
    }

    public abort_peer_thrift_result(
      PeerResponse_thrift success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public abort_peer_thrift_result(abort_peer_thrift_result other) {
      if (other.isSetSuccess()) {
        this.success = new PeerResponse_thrift(other.success);
      }
    }

    public abort_peer_thrift_result deepCopy() {
      return new abort_peer_thrift_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public PeerResponse_thrift getSuccess() {
      return this.success;
    }

    public abort_peer_thrift_result setSuccess(PeerResponse_thrift success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been assigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((PeerResponse_thrift)value);
        }
        break;

      }
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      if (field == null) {
        throw new IllegalArgumentException();
      }

      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof abort_peer_thrift_result)
        return this.equals((abort_peer_thrift_result)that);
      return false;
    }

    public boolean equals(abort_peer_thrift_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      List<Object> list = new ArrayList<Object>();

      boolean present_success = true && (isSetSuccess());
      list.add(present_success);
      if (present_success)
        list.add(success);

      return list.hashCode();
    }

    @Override
    public int compareTo(abort_peer_thrift_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(other.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {
        lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.success, other.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public _Fields fieldForId(int fieldId) {
      return _Fields.findByThriftId(fieldId);
    }

    public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
      schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
      schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
      }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("abort_peer_thrift_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws org.apache.thrift.TException {
      // check for required fields
      // check for sub-struct validity
      if (success != null) {
        success.validate();
      }
    }

    private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
      try {
        write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
      try {
        read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
      } catch (org.apache.thrift.TException te) {
        throw new java.io.IOException(te);
      }
    }

    private static class abort_peer_thrift_resultStandardSchemeFactory implements SchemeFactory {
      public abort_peer_thrift_resultStandardScheme getScheme() {
        return new abort_peer_thrift_resultStandardScheme();
      }
    }

    private static class abort_peer_thrift_resultStandardScheme extends StandardScheme<abort_peer_thrift_result> {

      public void read(org.apache.thrift.protocol.TProtocol iprot, abort_peer_thrift_result struct) throws org.apache.thrift.TException {
        org.apache.thrift.protocol.TField schemeField;
        iprot.readStructBegin();
        while (true)
        {
          schemeField = iprot.readFieldBegin();
          if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
            break;
          }
          switch (schemeField.id) {
            case 0: // SUCCESS
              if (schemeField.type == org.apache.thrift.protocol.TType.STRUCT) {
                struct.success = new PeerResponse_thrift();
                struct.success.read(iprot);
                struct.setSuccessIsSet(true);
              } else { 
                org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
              }
              break;
            default:
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
          }
          iprot.readFieldEnd();
        }
        iprot.readStructEnd();

        // check for required fields of primitive type, which can't be checked in the validate method
        struct.validate();
      }

      public void write(org.apache.thrift.protocol.TProtocol oprot, abort_peer_thrift_result struct) throws org.apache.thrift.TException {
        struct.validate();

        oprot.writeStructBegin(STRUCT_DESC);
        if (struct.success != null) {
          oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
          struct.success.write(oprot);
          oprot.writeFieldEnd();
        }
        oprot.writeFieldStop();
        oprot.writeStructEnd();
      }

    }

    private static class abort_peer_thrift_resultTupleSchemeFactory implements SchemeFactory {
      public abort_peer_thrift_resultTupleScheme getScheme() {
        return new abort_peer_thrift_resultTupleScheme();
      }
    }

    private static class abort_peer_thrift_resultTupleScheme extends TupleScheme<abort_peer_thrift_result> {

      @Override
      public void write(org.apache.thrift.protocol.TProtocol prot, abort_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol oprot = (TTupleProtocol) prot;
        BitSet optionals = new BitSet();
        if (struct.isSetSuccess()) {
          optionals.set(0);
        }
        oprot.writeBitSet(optionals, 1);
        if (struct.isSetSuccess()) {
          struct.success.write(oprot);
        }
      }

      @Override
      public void read(org.apache.thrift.protocol.TProtocol prot, abort_peer_thrift_result struct) throws org.apache.thrift.TException {
        TTupleProtocol iprot = (TTupleProtocol) prot;
        BitSet incoming = iprot.readBitSet(1);
        if (incoming.get(0)) {
          struct.success = new PeerResponse_thrift();
          struct.success.read(iprot);
          struct.setSuccessIsSet(true);
        }
      }
    }

  }

}
